# COSMIC
COSMIC (Compact Object Synthesis and Monte Carlo Investigation Code)

COSMIC is a rapid binary population synthesis suite with a special purpose of generating realistic compact binary populations. COSMIC can also be used to evolve binaries with BSE in a python environment.

COSMIC currently implements binary evolutionary processes using BSE ([Hurley+2002](https://ui.adsabs.harvard.edu/abs/2002MNRAS.329..897H/abstract)). Several modifications have been applied to BSE to account for recent updates to binary evolution especially important to compact binary formation (e.g. metallicity-dependent stellar winds or black hole natal kick strengths). For a detailed discussion of these modifications, see [Breivik et al 2020](https://ui.adsabs.harvard.edu/abs/2020ApJ...898...71B/abstract))

<https://cosmic-popsynth.github.io/>

# Release Status

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.3561144.svg)](https://doi.org/10.5281/zenodo.3561144)


[![PyPI version](https://badge.fury.io/py/cosmic-popsynth.svg)](https://badge.fury.io/py/cosmic-popsynth)


# Installation

The easiest method to install cosmic is using pip directly:

```
pip install cosmic-popsynth
```

[![Unit Test COSMIC](https://github.com/COSMIC-PopSynth/COSMIC/actions/workflows/python-package.yml/badge.svg)](https://github.com/COSMIC-PopSynth/COSMIC/actions/workflows/python-package.yml)

[![codecov](https://codecov.io/gh/COSMIC-PopSynth/COSMIC/branch/develop/graph/badge.svg)](https://codecov.io/gh/COSMIC-PopSynth/COSMIC)

***
      SUBROUTINE MIX(M0,M,AJ,KS,ZPARS,bhspin)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
*     Author : J. R. Hurley
*     Date :   7th July 1998
*
*       Evolution parameters for mixed star.
*       ------------------------------------
*
*
      INTEGER KS(2),I1,I2,K1,K2,KW,ICASE
      REAL*8 M0(2),M(2),AJ(2),ZPARS(20),bhspin(2)
      REAL*8 TSCLS(20),LUMS(10),GB(10),TMS1,TMS2,TMS3,TN
      REAL*8 M01,M02,M03,M1,M2,M3,AGE1,AGE2,AGE3,MC3,MCH
      REAL*8 M_CORE_BGB_1,M_CORE_BGB_2,M_CORE_BGB_3,HE_3_current
      PARAMETER(MCH=1.44D0)
*
*
*       Define global indices with body #I1 being most evolved.
      IF(KS(1).GE.KS(2))THEN
          I1 = 1
          I2 = 2
      ELSE
          I1 = 2
          I2 = 1
      END IF
*
*       Specify case index for collision treatment.
      K1 = KS(I1)
      K2 = KS(I2)
      ICASE = KTYPE(K1,K2)
*     if(icase.gt.100) WRITE(66,*)' MIX ERROR ICASE>100 ',icase,k1,k2
*
*       Determine evolution time scales for first star.
      M01 = M0(I1)
      M1 = M(I1)
      AGE1 = AJ(I1)
      CALL star(K1,M01,M1,TMS1,TN,TSCLS,LUMS,GB,ZPARS)
      IF(REJUVFLAG.EQ.1.AND.KS(1).LE.2.0.AND.KS(2).LE.2.0)THEN
          M_CORE_BGB_1 = GB(9)
      ENDIF
*
*       Obtain time scales for second star.
      M02 = M0(I2)
      M2 = M(I2)
      AGE2 = AJ(I2)
      CALL star(K2,M02,M2,TMS2,TN,TSCLS,LUMS,GB,ZPARS)
      IF(REJUVFLAG.EQ.1.AND.KS(1).LE.2.0.AND.KS(2).LE.2.0)THEN
          M_CORE_BGB_2 = GB(9)
      ENDIF
*
*       Check for planetary systems - defined as HeWDs and low-mass WDs!
      IF(K1.EQ.10.AND.M1.LT.0.05)THEN
         ICASE = K2
         IF(K2.LE.1)THEN
            ICASE = 1
            AGE1 = 0.D0
         ENDIF
      ELSEIF(K1.GE.11.AND.M1.LT.0.5.AND.ICASE.EQ.6)THEN
         ICASE = 9
      ENDIF
      IF(K2.EQ.10.AND.M2.LT.0.05)THEN
         ICASE = K1
         IF(K1.LE.1)THEN
            ICASE = 1
            AGE2 = 0.D0
         ENDIF
      ENDIF
*
*       Specify total mass.
      M3 = M1 + M2
      M03 = M01 + M02
      KW = ICASE
      AGE3 = 0.d0
*
*       Restrict merged stars to masses less than 100 Msun.
C      IF(M3.GE.100.D0)THEN
C         M3 = 99.D0
C         M03 = MIN(M03,M3)
C      ENDIF
*
*       Evaluate apparent age and other parameters.
*
      IF(ICASE.EQ.1)THEN
*       Specify new age based on complete mixing.
*       The above line is ~supsicious~ and probably the 0.1
*       factor is more likely to be over mixing than complete
*       mixing. We will now make it a parameter so that it can
*       be partial mixing.
         IF(K1.EQ.7) KW = 7
         CALL star(KW,M03,M3,TMS3,TN,TSCLS,LUMS,GB,ZPARS)
         IF(REJUVFLAG.EQ.1.AND.KS(1).LE.2.0.AND.KS(2).LE.2.0)THEN
             M_CORE_BGB_3 = GB(9)
             HE_3_current =AGE1*M_CORE_BGB_1/TMS1+AGE2*M_CORE_BGB_2/TMS2
             AGE3 = TMS3*He_3_current/M_CORE_BGB_3
         ELSE
             AGE3 = REJUV_FAC*TMS3*(AGE1*M1/TMS1 + AGE2*M2/TMS2)/M3
         ENDIF
      ELSEIF(ICASE.EQ.3.OR.ICASE.EQ.6.OR.ICASE.EQ.9)THEN
         MC3 = M1
         CALL gntage(MC3,M3,KW,ZPARS,M03,AGE3)
      ELSEIF(ICASE.EQ.4)THEN
         MC3 = M1
         AGE3 = AGE1/TMS1
         CALL gntage(MC3,M3,KW,ZPARS,M03,AGE3)
      ELSEIF(ICASE.EQ.7)THEN
         CALL star(KW,M03,M3,TMS3,TN,TSCLS,LUMS,GB,ZPARS)
         AGE3 = TMS3*(AGE2*M2/TMS2)/M3
      ELSEIF(ICASE.LE.12)THEN
*       Ensure that a new WD has the initial mass set correctly.
         M03 = M3
         IF(ecsn.gt.0.d0.and.ICASE.EQ.11.AND.M3.GE.1.38d0)then
            KW = 12 !will let hrdiag update accordingly...
         ELSEIF(ICASE.LT.12.AND.M3.GE.MCH)THEN
            M3 = 0.D0
            KW = 15
         ENDIF
      ELSEIF(ICASE.EQ.13.OR.ICASE.EQ.14)THEN
*       Set unstable Thorne-Zytkow object with fast mass loss of envelope
*       unless the less evolved star is a WD, NS or BH.
         IF(K2.LT.10)THEN
            M03 = M1
            M3 = M1
         ENDIF
         IF(ICASE.EQ.13.AND.M3.GT.MXNS)then
            KW = 14
         ENDIF
      ELSEIF(ICASE.EQ.15)THEN
         M3 = 0.D0
      ELSEIF(ICASE.GT.100)THEN
*       Common envelope case which should only be used after COMENV.
         KW = K1
         AGE3 = AGE1
         M3 = M1
         M03 = M01
      ELSE
*       This should not be reached.
        KW = 1
        M03 = M3
      ENDIF
*
* Put the result in *1.
*
* CLR - If the secondary is a BH and the primary is not, then copy the
* spin of the secondary into the primary

* If you ever want to consider spin-up in combined stars, this is the
* palce
      IF(KS(2).EQ.14)then
          bhspin(1) = bhspin(2)
      ENDIF
      KS(1) = KW
      KS(2) = 15
      M(1) = M3
      M(2) = 0.D0
      M0(1) = M03
      AJ(1) = AGE3
*
      RETURN
      END
***

***
      real*8 FUNCTION mlwind(kw,lum,r,mt,mc,rl,z)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
      integer kw,testflag
      real*8 lum,r,mt,mc,rl,z,teff,alpha
      real*8 dml,dms,dmt,p0,x,mew,lum0,kap
      real*8 MLalpha
      external MLalpha
      parameter(lum0=7.0d+04,kap=-0.5d0)
*
*      windflag = 0 !BSE=0, startrack08=1, vink=2, vink+LBV for all
*      stars=3.
* Must be one of these values or mlwind will cause problem with code,
* i.e. mlwind not set (see last line of main if statement...).
    
      if(windflag.eq.0)then
* BSE
*
* Calculate stellar wind mass loss.
*
* Apply mass loss of Nieuwenhuijzen & de Jager, A&A, 1990, 231, 134,
* for massive stars over the entire HRD.
         dms = 0.d0
         if(lum.gt.4000.d0)then
            x = MIN(1.d0,(lum-4000.d0)/500.d0)
            dms = 9.6d-15*x*(r**0.81d0)*(lum**1.24d0)*(mt**0.16d0)
            alpha = 0.5d0
            dms = dms*(z/zsun)**(alpha)
         endif
         if(kw.ge.2.and.kw.le.9)then
* 'Reimers' mass loss
            dml = neta*4.0d-13*r*lum/mt
            if(rl.gt.0.d0) dml =
     &         dml*(1.d0 + bwind*(MIN(0.5d0,(r/rl)))**6)
* Apply mass loss of Vassiliadis & Wood, ApJ, 1993, 413, 641,
* for high pulsation periods on AGB.
            if(kw.eq.5.or.kw.eq.6)then
               p0 = -2.07d0 - 0.9d0*log10(mt) + 1.94d0*log10(r)
               p0 = 10.d0**p0
               p0 = MIN(p0,2000.d0)
               dmt = -11.4d0+0.0125d0*(p0-100.d0*MAX(mt-2.5d0,0.d0))
               dmt = 10.d0**dmt
               dmt = 1.d0*MIN(dmt,1.36d-09*lum)
               dml = MAX(dml,dmt)
            endif
            if(kw.gt.6)then
               dms = MAX(dml,1.0d-13*hewind*lum**(3.d0/2.d0))
            else
               dms = MAX(dml,dms)
               mew = ((mt-mc)/mt)*MIN(5.d0,MAX(1.2d0,(lum/lum0)**kap))
* reduced WR-like mass loss for small H-envelope mass
               if(mew.lt.1.d0)then
                  dml = 1.0d-13*lum**(3.d0/2.d0)*(1.d0 - mew)
                  dms = MAX(dml,dms)
               endif
* LBV-like mass loss beyond the Humphreys-Davidson limit.
               x = 1.0d-5*r*sqrt(lum)
               if(lum.gt.6.0d+05.and.x.gt.1.d0)then
                  dml = 0.1d0*(x-1.d0)**3*(lum/6.0d+05-1.d0)
                  dms = dms + dml
               endif
            endif
         endif
*
         mlwind = dms
      elseif(windflag.eq.1)then
* StarTrack (Beclzynski+08)
*
* Calculate stellar wind mass loss.
*
* Apply mass loss of Nieuwenhuijzen & de Jager, A&A, 1990, 231, 134,
* for massive stars over the entire HRD, with no luminosity limit
* according to Belczynsk+08 pp. 174.
*
* This may not be what is actually assumed in StarTrack (see the windf1 function).
*
*
         dms = 0.d0
         if(lum.gt.4000.d0.or.(kw.ge.0.and.kw.le.1))then
            if(lum.gt.4000.d0)then
               x = MIN(1.d0,(lum-4000.d0)/500.d0)
            else
               x = 0.1d0/500.d0
            endif !or is it simply x = Min(1, lum/500)?
            dms = 9.6d-15*x*(r**0.81d0)*(lum**1.24d0)*(mt**0.16d0)
            alpha = 0.5d0
            dms = dms*(z/zsun)**(alpha)
         endif
         if(kw.ge.2.and.kw.le.9)then
* 'Reimers' mass loss
            dml = neta*4.0d-13*r*lum/mt
            if(rl.gt.0.d0) dml =
     &         dml*(1.d0 + bwind*(MIN(0.5d0,(r/rl)))**6)
* Apply mass loss of Vassiliadis & Wood, ApJ, 1993, 413, 641,
* for high pulsation periods on AGB.
            if(kw.eq.5.or.kw.eq.6)then
               p0 = -2.07d0 - 0.9d0*log10(mt) + 1.94d0*log10(r)
               p0 = 10.d0**p0
               p0 = MIN(p0,2000.d0)
               dmt = -11.4d0+0.0125d0*(p0-100.d0*MAX(mt-2.5d0,0.d0))
               dmt = 10.d0**dmt
               dmt = 1.d0*MIN(dmt,1.36d-09*lum)
               dml = MAX(dml,dmt)
            endif
            if(kw.gt.6)then
               dms = MAX(dml,1.0d-13*lum**(3.d0/2.d0)) !hewind here for KH06, not included for StarTrack...
            else
               dms = MAX(dml,dms)
               mew = ((mt-mc)/mt)*MIN(5.d0,MAX(1.2d0,(lum/lum0)**kap))
* reduced WR-like mass loss for small H-envelope mass
               if(mew.lt.1.d0)then
                  dml = 1.0d-13*lum**(3.d0/2.d0)*(1.d0 - mew)
                  dms = MAX(dml,dms)
               endif
* LBV-like mass loss beyond the Humphreys-Davidson limit.
               x = 1.0d-5*r*sqrt(lum)
               if(lum.gt.6.0d+05.and.x.gt.1.d0)then
                  dml = 0.1d0*(x-1.d0)**3*(lum/6.0d+05-1.d0)
                  dms = dms + dml
               endif
            endif
         endif
*
         mlwind = dms
      elseif(windflag.ge.2)then
* Vink winds etc according to as implemented following
* Belczynski, Bulik, Fryer, Ruiter, Valsecchi, Vink & Hurley 2010.
*
* Firstly implement BSE 'old' winds that cover all other stars not
* accounted for by Vink winds (see Belczynski+09). Then implement
* Vink et al. winds.
*
* We also include the option for a variable metallicity-dependent mass
* loss parameter which eddlimflag is set, which makes the metallicity
* dependence become weaker as the star approaches the electron-scattering
* Eddington limit (Grafener & Hamann 2008, Giacobbo et al. 2018)
*
         teff = 1000.d0*((1130.d0*lum/(r**2.d0))**(1.d0/4.d0))
         dms = 0.d0
         if(lum.gt.4000.d0)then
* Apply mass loss of Nieuwenhuijzen & de Jager, A&A, 1990, 231, 134,
* for massive stars over the entire HRD after OB stars accounted for.
            x = MIN(1.d0,(lum-4000.d0)/500.d0)
            dms = 9.6d-15*x*(r**0.81d0)*(lum**1.24d0)*(mt**0.16d0)
            alpha = 0.5d0
            dms = dms*(z/zsun)**(alpha)
            testflag = 1
         endif
         if(kw.ge.2.and.kw.le.6)then
* 'Reimers' mass loss
            dml = neta*4.0d-13*r*lum/mt
            if(rl.gt.0.d0) dml =
     &         dml*(1.d0 + bwind*(MIN(0.5d0,(r/rl)))**6)
* Apply mass loss of Vassiliadis & Wood, ApJ, 1993, 413, 641,
* for high pulsation periods on AGB.
            if(kw.eq.5.or.kw.eq.6)then
               p0 = -2.07d0 - 0.9d0*log10(mt) + 1.94d0*log10(r)
               p0 = 10.d0**p0
               p0 = MIN(p0,2000.d0)
               dmt = -11.4d0+0.0125d0*(p0-100.d0*MAX(mt-2.5d0,0.d0))
               dmt = 10.d0**dmt
               dmt = 1.d0*MIN(dmt,1.36d-09*lum)
               dml = MAX(dml,dmt)
            endif
            dms = MAX(dms,dml)
         endif
* Apply Vink, de Koter & Lamers (2001) OB star winds.
* Next check if hot massive H-rich O/B star in appropriate temperature ranges.
         if(teff.ge.12500.and.teff.le.25000)then
            if(eddlimflag.eq.0) alpha = 0.85d0
            if(eddlimflag.eq.1) alpha = MLalpha(mt,lum,kw)
            dms = -6.688d0 + 2.210d0*LOG10(lum/1.0d+05) -
     &            1.339d0*LOG10(mt/30.d0) - 1.601d0*LOG10(1.3d0/2.d0) +
     &            alpha*LOG10(z/zsun) + 1.07d0*LOG10(teff/2.0d+04)
            dms = 10.d0**dms
            testflag = 2
         elseif(teff.gt.25000.)then
*        Although Vink et al. formulae  are only defined until Teff=50000K,
*        we follow the Dutch prescription of MESA, and extend to higher Teff
             dms = -6.697d0 + 2.194d0*LOG10(lum/1.0d+05) -
     &            1.313d0*LOG10(mt/30.d0) - 1.226d0*LOG10(2.6d0/2.d0) +
     &            alpha*LOG10(z/zsun) +0.933d0*LOG10(teff/4.0d+04) -
     &            10.92d0*(LOG10(teff/4.0d+04)**2)
       dms = 10.d0**dms
       testflag = 2
         endif

         if((windflag.eq.3.or.kw.ge.2).and.kw.le.6)then
* LBV-like mass loss beyond the Humphreys-Davidson limit.
* Optional flag (windflag=3) to use for every non-degenerate star
* past the limit, rather than just for giant, evolved stars
            x = 1.0d-5*r*sqrt(lum)
            if(lum.gt.6.0d+05.and.x.gt.1.d0)then
               if(eddlimflag.eq.0) alpha = 0.d0
               if(eddlimflag.eq.1) alpha = MLalpha(mt,lum,kw)
               dms = 1.5d0*1.0d-04*((z/zsun)**alpha)
               testflag = 3
            endif
         elseif(kw.ge.7.and.kw.le.9)then !WR (naked helium stars)
* If naked helium use Hamann & Koesterke (1998) WR winds reduced by factor of
* 10 (Yoon & Langer 2005), with Vink & de Koter (2005) metallicity dependence
            if(eddlimflag.eq.0) alpha = 0.86d0
            if(eddlimflag.eq.1) alpha = MLalpha(mt,lum,kw)
            dms = 1.0d-13*(lum**1.5d0)*((z/zsun)**alpha)
            testflag = 4
         endif
*
         mlwind = dms
      endif

      return
      end
***

***
      SUBROUTINE CONCATKSTARS(int1,int2,int3)
*
* Concatenate Strings.
*
*     Author : Scott Coughlinn
*     Date :   11th December 2018
*
      IMPLICIT NONE
*
      INTEGER int1,int2,int3
      CHARACTER(len=2) str1,str2
      CHARACTER(len=4) str3

      WRITE(str1,'(i2.2)') int1
      WRITE(str2,'(i2.2)') int2

      str3 = trim(adjustl(str1))//trim(adjustl(str2))

      READ(str3,*)int3
      END

***
      SUBROUTINE checkstate(dtp,dtp_original,tsave,tphys,tphysf,
     &                      iplot,isave,binstate,evolve_type,
     &                      mass1,mass2,kstar1,kstar2,sep,
     &                      tb,ecc,rrl1,rrl2,
     &                      aj1,aj2,tms1,tms2,
     &                      massc1,massc2,rad1,rad2,
     &                      mass0_1,mass0_2,lumin1,lumin2,
     &                      radc1,radc2,menv1,menv2,renv1,renv2,
     &                      ospin1,ospin2,b_0_1,b_0_2,bacc1,bacc2,
     &                      tacc1,tacc2,epoch1,epoch2,bhspin1,bhspin2)
*
* Concatenate Strings.
*
*     Author : Scott Coughlin
*     Date :   7th April 2020
*
      IMPLICIT NONE
      INCLUDE 'checkstate.h'
      INCLUDE 'const_bse.h'
      INTEGER jj,ii,param_index,binstate
      INTEGER kstar1,kstar2
      LOGICAL pass_condition,pass_condition_any
      LOGICAL isave,iplot
      REAL*8 current_state_array(41)
      REAL*8 dtp,dtp_original,tsave,tphys,tphysf,mass1,mass2
      REAL*8 evolve_type,sep,tb,ecc,rrl1,rrl2
      REAL*8 aj1,aj2,tms1,tms2,massc1,massc2,rad1,rad2
      REAL*8 mass0_1,mass0_2,lumin1,lumin2,radc1,radc2
      REAL*8 menv1,menv2,renv1,renv2,ospin1,ospin2
      REAL*8 b_0_1,b_0_2,bacc1,bacc2,tacc1,tacc2,epoch1,epoch2
      REAL*8 bhspin1,bhspin2
      current_state_array(1) = binstate
      current_state_array(2) = evolve_type
      current_state_array(3) = mass1
      current_state_array(4) = mass2
      current_state_array(5) = kstar1
      current_state_array(6) = kstar2
      current_state_array(7) = sep
      current_state_array(8) = tb
      current_state_array(9) = ecc
      current_state_array(10) = rrl1
      current_state_array(11) = rrl2
      current_state_array(12) = aj1
      current_state_array(13) = aj2
      current_state_array(14) = tms1
      current_state_array(15) = tms2
      current_state_array(16) = massc1
      current_state_array(17) = massc2
      current_state_array(18) = rad1
      current_state_array(19) = rad2
      current_state_array(20) = mass0_1
      current_state_array(21) = mass0_2
      current_state_array(22) = lumin1
      current_state_array(23) = lumin2
      current_state_array(24) = radc1
      current_state_array(25) = radc2
      current_state_array(26) = menv1
      current_state_array(27) = menv2
      current_state_array(28) = renv1
      current_state_array(29) = renv2
      current_state_array(30) = ospin1
      current_state_array(31) = ospin2
      current_state_array(32) = b_0_1
      current_state_array(33) = b_0_2
      current_state_array(34) = bacc1
      current_state_array(35) = bacc2
      current_state_array(36) = tacc1
      current_state_array(37) = tacc2
      current_state_array(38) = epoch1
      current_state_array(39) = epoch2
      current_state_array(40) = bhspin1
      current_state_array(41) = bhspin2

* tsave should never be bigger than tphysf
      IF(tsave.ge.tphysf)THEN
          tsave = tphysf
      ENDIF

* We track to see if any conditional pass, otherwise dtp will be set to
* dtp_original
      pass_condition_any = .false.

      DO jj = 1,15
* start by assuming we do not pass the current conditional setting of dtp
          pass_condition = .false.
* First check if there is even a dtp requested, if not
* this implies that a conditional has not been set so we should continue
          IF(dtp_state(jj).eq.-1.d0)THEN
              goto 74
          ENDIF
* if we do have the conditional then we need to know the sign of the conditional
* i.e. EQUAL (0), GT (1), GE (2), LT (3), LE (4) and then piece wise together the whole statement
* Moreover we need to keep track of which parameter in the current_state_array we are checking
          param_index = 0
          DO ii = 2, 120, 3
              param_index = param_index + 1
* This part of the checkstate array had no conditional set (we know because the default has not changed)
              IF(checkstate_array(jj,ii-1).eq.-10E30.and.
     &               checkstate_array(jj,ii+1).eq.10E30)THEN
                  goto 69
              ENDIF

* Now we check for what the conditional was and apply it. As soon as the
* conditional is false we do not check anymore
              IF(checkstate_array(jj,ii).eq.0)THEN

                  IF(checkstate_array(jj,ii-1).eq.
     &              current_state_array(param_index)
     &              .and.
     &              checkstate_array(jj,ii+1).eq.
     &              current_state_array(param_index))THEN
                      pass_condition = .true.
                  ELSE
                      pass_condition = .false.
                      goto 79
                  ENDIF

              ELSEIF(checkstate_array(jj,ii).eq.1)THEN

                  IF(current_state_array(param_index).gt.
     &               checkstate_array(jj,ii-1))THEN
                      pass_condition = .true.
                  ELSE
                      pass_condition = .false.
                      goto 79
                  ENDIF
              
              ELSEIF(checkstate_array(jj,ii).eq.2)THEN
                  IF(current_state_array(param_index).ge.
     &               checkstate_array(jj,ii-1))THEN
                      pass_condition = .true.
                  ELSE
                      pass_condition = .false.
                      goto 79
                  ENDIF

              ELSEIF(checkstate_array(jj,ii).eq.3)THEN

                  IF(current_state_array(param_index).lt.
     &               checkstate_array(jj,ii+1))THEN
                      pass_condition = .true.
                  ELSE
                      pass_condition = .false.
                      goto 79
                  ENDIF

              ELSEIF(checkstate_array(jj,ii).eq.4)THEN
                  IF(current_state_array(param_index).le.
     &               checkstate_array(jj,ii+1))THEN
                      pass_condition = .true.
                  ELSE
                      pass_condition = .false.
                      goto 79
                  ENDIF
              ENDIF
 69       CONTINUE
          ENDDO
 79       CONTINUE
* finally we see if we satisfied the conditional and set dtp
          IF(pass_condition)THEN
              IF(dtp_state(jj).ne.tphysf.and.tsave.ge.tphysf)THEN
                  tsave = tphys
              ENDIF
              dtp = dtp_state(jj)
              pass_condition_any = .true.
          ENDIF
 74   CONTINUE
      ENDDO
      IF(pass_condition_any.neqv..true.)THEN
* if no conditions are met then return to orginal dtp
          dtp = dtp_original
      ENDIF
      isave = .true.
      iplot = .false.
      IF(dtp.eq.0.d0)THEN
         iplot = .true.
         isave = .false.
         tsave = tphysf
      ENDIF
      END

***
      SUBROUTINE evolv2(kstar,mass,tb,ecc,z,tphysf,
     \ dtp,mass0,rad,lumin,massc,radc,
     \ menv,renv,ospin,B_0,bacc,tacc,epoch,tms,
     \ bhspin,tphys,zpars,bkick,bppout,bcmout)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
***
*
*           B I N A R Y
*           ***********
*
*       Roche lobe overflow.
*       --------------------
*
*       Developed by Jarrod Hurley, IOA, Cambridge.
*       .........................................................
*
*       Advice by Christopher Tout, Onno Pols & Sverre Aarseth.
*       ++++++++++++++++++++++++++++++++++++++++++++++++++
*
* Adapted from Aarseth's code 21st September 1996.
* Fully revised on 27th November 1996 to remove vestiges of N-body code and
* incorporate corrections.
* Fully revised on 1st April 1998 to include new stellar evolution formulae
* and associated binary evolution changes.
* Fully revised on 4th July 1998 to include eccentricity, tidal
* circularization, wind accretion, velocity kicks for supernovae and all
* associated orbital momentum changes.
*
***
*
* See Tout et al., 1997, MNRAS, 291, 732 for a description of many of the
* processes in this code as well as the relevant references mentioned
* within the code.
*
* Reference for the stellar evolution formulae is Hurley, Pols & Tout,
* 2000, MNRAS, 315, 543 (SSE paper).
* Reference for the binary evolution algorithm is Hurley, Tout & Pols,
* 2002, MNRAS, 329, 897 (BSE paper).
*
***
*
* March 2001 *
* Changes since version 3, i.e. since production of Paper3:
*
* 1) The Eddington limit flag (on/off) has been replaced by an
*    Eddington limit multiplicative factor (eddfac). So if you
*    want to neglect the Eddington limit you would set eddfac
*    to a large value.
*
* 2) To determine whether material transferred during RLOF forms
*    an accretion disk around the secondary or hits the secondary
*    in a direct stream we calculate a minimum radial distance, rmin,
*    of the mass stream from the secondary. This is taken from eq.(1)
*    of Ulrich & Burger (1976, ApJ, 206, 509) which they fitted to
*    the calculations of Lubow & Shu (1974, ApJ, 198, 383).
*    If rmin is less than the radius of the secondary then an
*    accretion disk is not formed.
*    Note that the formula for rmin given by Ulrich & Burger is valid
*    for all q whereas that given by Nelemans et al. (2001, A&A,
*    submitted) in their eq.(6) is only valid for q < 1 where
*    they define q = Mdonor/Maccretor, i.e. DD systems.
*
* 3) The changes to orbital and spin angular momentum owing to
*    RLOF mass transfer have been improved, and an new input option
*    now exists.
*    When mass is lost from the system during RLOF there are now
*    three choices as to how the orbital angular momentum is
*    affected: a) the lost material carries with it a fraction
*    gamma of the orbital angular momentum, i.e.
*    dJorb = gamma*dm*a^2*omega_orb; b) the material carries with it
*    the specific angular momentum of the primary, i.e.
*    dJorb = dm*a_1^2*omega_orb; or c) assume the material is lost
*    from the system as if a wind from the secondary, i.e.
*    dJorb = dm*a_2^2*omega_orb.
*    The parameter gamma is an input option.
*    Choice c) is used if the mass transfer is super-Eddington
*    or the system is experiencing novae eruptions.
*    In all other cases choice a) is used if gamma > 0.0, b) if
*    gamma = -1.0 and c) is used if gamma = -2.0.
*    The primary spin angular momentum is reduced by an amount
*    dm1*r_1^2*omega_1 when an amount of mass dm1 is transferred
*    from the primary.
*    If the secondary accretes through a disk then its spin
*    angular momentum is altered by assuming that the material
*    falls onto the star from the inner edge of a Keplerian
*    disk and that the system is in a steady state, i.e.
*    an amount dm2*SQRT(G*m_2*r_2).
*    If there is no accretion disk then we calculate the angular
*    momentum of the transferred material by using the radius at
*    at which the disk would have formed (rdisk = 1.7*rmin, see
*    Ulrich & Burger 1976) if allowed, i.e. the angular momentum
*    of the inner Lagrangian point, and add this directly to
*    the secondary, i.e. an amount dm2*SQRT(G*m_2*rdisk).
*    Total angular momentum is conserved in this model.
*
* 4) Now using q_crit = 3.0 for MS-MS Roche systems (previously we
*    had nothing). This corresponds roughly to R proportional to M^5
*    which should be true for the majority of the MS (varies from
*    (M^17 -> M^2). If q > q_crit then contact occurs.
*    For CHeB primaries we also take q_crit = 3.0 and allow
*    common-envelope to occur if this is exceeded.
*
* 5) The value of lambda used in calculations of the envelope binding
*    energy for giants in common-envelope is now variable (see function
*    in zfuncs). The lambda function has been fitted by Onno to detailed
*    models ... he will write about this soon!
*
* 6) Note that eq.42 in the paper is missing a SQRT around the
*    MR^2/a^5 part. This needs to be corrected in any code update
*    paper with a thanks to Jeremy Sepinsky (student at NorthWestern).
*    It is ok in the code.
*
* March 2003 *
* New input options added:
*
*    ifflag - for the mass of a WD you can choose to use the mass that
*             results from the evolution algorithm (basically a competition
*             between core-mass growth and envelope mass-loss) or use the IFMR
*             proposed by Han, Podsiadlowski & Eggleton, 1995, MNRAS, 272, 800
*             [>0 activates HPE IFMR].
*
*    wdflag - for the cooling of WDs you can choose to use either the standard
*             Mestel cooling law (see SSE paper) or a modified-Mestel law that
*             is better matched to detailed models (provided by Brad Hansen
*             ... see Hurley & Shara, 2003, ApJ, May 20, in press)
*             [>0 activates modified-Mestel].
*
*    bhflag - choose whether or not black holes should get velocity kicks
*             at formation
*             [0= no kick; >0 kick].
*
*    nsflag - for the mass of neutron stars and black holes you can use either
*             the SSE prescription or the prescription presented by
*             Belczynski et al. 2002, ApJ, 572, 407 who found that SSE was
*             underestimating the masses of these stars. In either case you also
*             need to set the maximum NS mass (mxns) for the prescription
*             [0= SSE, mxns=1.8; >0 Belczynski, mxns=3.0].
*
* Sept 2004 *
* Input options added/changed:
*
*    ceflag - set to 1 this uses de Kool (or Podsiadlowski) CE prescription,
*             other options, such as Yungelson, could be added as well.
*
*    hewind - factor to control the amount of He star mass-loss, i.e.
*             1.0e-13*hewind*L^(2/3) gives He star mass-loss.
*
*
*       ++++++++++++++++++++++++++++++++++++++++++++++++++
***
*
      INTEGER loop,iter,intpol,k,ip,jp,j1,j2,jj
      INTEGER kcomp1,kcomp2,formation(2)
      PARAMETER(loop=20000)
      INTEGER kstar(2),kw,kst,kw1,kw2,kmin,kmax
      INTEGER kstar1_bpp,kstar2_bpp
*
      REAL*8 km,km0,tphys,tphys0,dtm0,tphys00,tphysfhold
      REAL*8 tphysf,dtp,tsave
      REAL*8 aj(2),aj0(2),epoch(2),tms(2),tbgb(2),tkh(2),dtmi(2)
      REAL*8 mass0(2),mass(2),massc(2),menv(2),mass00(2),mcxx(2)
      REAL*8 mass1_bpp,mass2_bpp
      REAL*8 rad(2),rol(2),rol0(2),rdot(2),radc(2),renv(2),radx(2)
      REAL*8 lumin(2),k2str(2),q(2),dms(2),dmr(2),dmt(2)
      REAL*8 dml,vorb2,vwind2,omv2,ivsqm,lacc,bkick(20)
      REAL*8 sep,dr,tb,dme,tdyn,taum,dm1,dm2,dmchk,qc,dt,pd,rlperi
      REAL*8 m1ce,m2ce,mch,tmsnew,dm22,mew
      PARAMETER(mch=1.44d0)
      REAL*8 yeardy,yearsc,aursun
      PARAMETER(yeardy=365.24d0,aursun=214.95d0,yearsc=3.1557d+07)
      REAL*8 acc1,tiny
      PARAMETER(acc1=3.920659d+08,tiny=1.0d-14)
      REAL*8 ecc,ecc1,tc,tcirc,ttid,ecc2,omecc2,sqome2,sqome3,sqome5
      REAL*8 f1,f2,f3,f4,f5,f,raa2,raa6,eqspin,rg2,tcqr
      REAL*8 k3,mr23yr,twopi
      PARAMETER(k3=0.21d0,mr23yr=0.4311d0)
      REAL*8 jspin(2),ospin(2),jorb,oorb,jspbru,ospbru
      REAL*8 bhspin(2)
      REAL*8 delet,delet1,dspint(2),djspint(2),djtx(2)
      REAL*8 dtj,djorb,djgr,djmb,djt,djtt,rmin,rdisk
*
      INTEGER pulsar
      INTEGER mergemsp,merge_mem,notamerger,binstate,mergertype
      REAL*8 fallback,sigmahold
      REAL*8 vk,u1,u2,s,Kconst,betahold,convradcomp(2),teff(2)
      REAL*8 B_0(2),bacc(2),tacc(2),xip,xihold
      REAL*8 deltam1_bcm,deltam2_bcm,b01_bcm,b02_bcm
      REAL*8 B(2),Bbot,omdot,b_mdot,b_mdot_lim,evolve_type
      COMMON /fall/fallback
      REAL ran3
      EXTERNAL ran3
*

*
      REAL*8 z,tm,tn,m0,mt,rm,lum,mc,rc,me,re,k2,age,dtm,dtr
      REAL*8 tscls(20),lums(10),GB(10),zpars(20)
      REAL*8 zero,ngtv,ngtv2,mt2,rrl1,rrl2,mcx,teff1,teff2
      REAL*8 mass1i,mass2i,tbi,ecci
      LOGICAL coel,com,prec,inttry,change,snova,sgl
      LOGICAL supedd,novae,disk
      LOGICAL isave,iplot
      REAL*8 rl,mlwind,vrotf,corerd,f_fac
      EXTERNAL rl,mlwind,vrotf,corerd
*
      REAL*8 kw3,wsun,wx
      PARAMETER(kw3=619.2d0,wsun=9.46d+07,wx=9.46d+08)
      LOGICAL output
      REAL*8 bppout(1000,23)
      REAL*8 bcmout(50000,42)
*
      REAL*8 vk1_bcm,vk2_bcm,vsys_bcm,theta_bcm
      REAL*8 qc_fixed
      LOGICAL switchedCE,disrupt

Cf2py intent(in) kstar
Cf2py intent(in) mass
Cf2py intent(in) tb
Cf2py intent(in) ecc
Cf2py intent(in) z
Cf2py intent(in) tphysf
Cf2py intent(in) dtp
Cf2py intent(in) mass0
Cf2py intent(in) rad
Cf2py intent(in) lumin
Cf2py intent(in) massc
Cf2py intent(in) radc
Cf2py intent(in) menv
Cf2py intent(in) renv
Cf2py intent(in) ospin
Cf2py intent(in) B_0
Cf2py intent(in) bacc
Cf2py intent(in) tacc
Cf2py intent(in) epoch
Cf2py intent(in) tms
Cf2py intent(in) bhspin
Cf2py intent(in) tphys
Cf2py intent(in) zpars
Cf2py intent(in) bkick
Cf2py intent(out) bppout
Cf2py intent(out) bcmout

      if(using_cmc.eq.0)then
              CALL instar
      endif

*
* Save the initial state.
*

*      CE2flag = 0
      kstar1_bpp = 0
      kstar2_bpp = 0

      mass1_bpp = 0.d0
      mass2_bpp = 0.d0

      mass1i = mass(1)
      mass2i = mass(2)
      tbi = tb
      ecci = ecc
*
      zero = 0.d0
      ngtv = -1.d0
      ngtv2 = -2.d0
      twopi = 2.d0*ACOS(-1.d0)

* disrupt tracks if system get disrupted by a SN during the common
* envelope
      disrupt = .false.
* value for bcm[ii,37] which tracks binary state; 0 for binary, 1 for merger, 2 for disrupted
      binstate = 0
* value for bcm[ii,38] which tracks merger types; only set when binstate is 1
* the logic is to combine kstar values of merged objects. so 1313 or 0809.
      mergertype = -1
*Captures original sigma so after ECSN we can reset it.
      sigmahold = sigma
*memory for wind mass loss factor
      betahold = beta

** SET PULSAR VALUES HERE**
* PDK
      pulsar = 1 ! allows for pulsar physics; not a flag since we heart pulsars
      Kconst = 2.5d-49
      Bbot = 5e+7 !100.d0 or ~d+07.
      b_mdot_lim = -1.0e-11 !limiting accretion induced field decay with mdot as a proxy for
*                           accretion temperature and number of impurities.
      xihold = xi
      xip = 1 !Modifies NS wind ang. mom. accretion.
      formation(1) = 0 !helps determine formation channel of interesting systems.
      formation(2) = 0
      pisn_track(1) = 0 !tracks whether a PISN occurred for each
component.
      pisn_track(2) = 0
      merger = -1 !used in CMC to track systems that dynamically merge
      notamerger = 0 !if 0 you reset the merger NS product to new factory settings else you don't.
      mergemsp = 1 !if set to 1 any NS that merges with another star where the NS is an MSP stays an MSP...
      merge_mem = 0
      output = .false.  ! .true. turns on, .false. turns off.
*                       WARNING: can fill up the output file very quickly.
*                       With N=2e6 .stdout was 3.2 GB in 6 mins. If needed you can
*                       be more selective with outputting, but must add this yourself!
*      if(id1_pass.eq.1)then!.and.tphysf.gt.17.50d0.and.
**     &   tphysf.lt.17.6d0)then
*         output = .true.
*      endif
*
* Initialize the parameters.
*

      if(using_cmc.eq.0)then
          tphys = 0.d0
          bpp = 0.d0
          bcm = 0.d0
          bppout = 0.d0
          bcmout = 0.d0
      endif


* set bcm kick values to 0.0 initially
      vk1_bcm = 0.d0
      vk2_bcm = 0.d0
      vsys_bcm = 0.d0
      theta_bcm = 0.d0


*
* Set the seed for the random number generator.
*
*      idum1 = INT(sep*100)
      if(idum1.gt.0.and.using_cmc.eq.0) idum1 = -idum1

*
* Set the collision matrix.
*
      if(using_cmc.eq.0)then
          CALL zcnsts(z,zpars)
      endif

      kmin = 1
      kmax = 2
      sgl = .false.
      mt2 = MIN(mass(1),mass(2))
      kst = 0
      iter = 0 ! PDK addition, just incase you bail out before 4 loop (usually from multiple calls for one evolve)
*
      if(mt2.lt.tiny.or.tb.le.0.d0)then
         sgl = .true.
         if(mt2.lt.tiny)then
            mt2 = 0.d0
            if(mass(1).lt.tiny)then
               if(tphys.lt.tiny)then
                  mass0(1) = 0.01d0
                  mass(1) = mass0(1)
                  kst = 1
               else
                  kmin = 2
                  lumin(1) = 1.0d-10
                  rad(1) = 1.0d-10
                  massc(1) = 0.d0
                  dmt(1) = 0.d0
                  dmr(1) = 0.d0
               endif
               ospin(1) = 1.0d-10
               jspin(1) = 1.0d-10
               dtmi(1) = 5.0d+04 !5Gyr, added for use of single stars in evolv2.f
            else
               if(tphys.lt.tiny)then
                  mass0(2) = 0.01d0
                  mass(2) = mass0(2)
                  kst = 2
               else
                  kmax = 1
                  lumin(2) = 1.0d-10
                  rad(2) = 1.0d-10
                  massc(2) = 0.d0
                  dmt(2) = 0.d0
                  dmr(2) = 0.d0
               endif
               ospin(2) = 1.0d-10
               jspin(2) = 1.0d-10
               dtmi(2) = 5.0d+04 !5Gyr, added for use of single stars in evolv2.f
            endif
         endif
         ecc = -1.d0
         tb = 0.d0
         sep = 1.0d+10
         oorb = 0.d0
         jorb = 0.d0
         if(kstar(1).ne.14.d0.or.using_cmc.eq.0) bhspin(1) = 0.d0
         if(kstar(2).ne.14.d0.or.using_cmc.eq.0) bhspin(2) = 0.d0
         if(ospin(1).lt.0.0) ospin(1) = 1.0d-10
         if(ospin(2).lt.0.0) ospin(2) = 1.0d-10
         q(1) = 1.0d+10
         q(2) = 1.0d+10
         rol(1) = 1.0d+10
         rol(2) = 1.0d+10
      else
         tb = tb/yeardy
         sep = aursun*(tb*tb*(mass(1) + mass(2)))**(1.d0/3.d0)
         oorb = twopi/tb
         jorb = mass(1)*mass(2)/(mass(1)+mass(2))
     &          *SQRT(1.d0-ecc*ecc)*sep*sep*oorb
         if(ospin(1).lt.0.d0) ospin(1) = oorb
         if(ospin(2).lt.0.d0) ospin(2) = oorb
      endif
*
      do 500 , k = kmin,kmax
         age = tphys - epoch(k)
         mc = massc(k)
         rc = radc(k)
         CALL star(kstar(k),mass0(k),mass(k),tm,tn,tscls,lums,GB,zpars)
         CALL hrdiag(mass0(k),age,mass(k),tm,tn,tscls,lums,GB,zpars,
     &               rm,lum,kstar(k),mc,rc,me,re,k2,bhspin(k),k)
         aj(k) = age
         epoch(k) = tphys - age
         rad(k) = rm
         lumin(k) = lum
         teff(k) = 1000.d0*((1130.d0*lumin(k)/
     &                    (rad(k)**2.d0))**(1.d0/4.d0))
         massc(k) = mc
         radc(k) = rc
         menv(k) = me
         renv(k) = re
         k2str(k) = k2
         tms(k) = tm
         tbgb(k) = tscls(1)
*
         if(tphys.lt.tiny.and.ospin(k).le.0.001d0)then
            ospin(k) = 45.35d0*vrotf(mass(k),ST_tide)/rm
         endif
         jspin(k) = ospin(k)*(k2*rm*rm*(mass(k)-mc)+k3*rc*rc*mc)
         if(.not.sgl)then
            q(k) = mass(k)/mass(3-k)
            rol(k) = rl(q(k))*sep
            if(ST_tide.gt.0) rol(k) = rl(q(k))*sep*(1.d0-ecc)
         endif
         rol0(k) = rol(k)
         dmr(k) = 0.d0
         dmt(k) = 0.d0
         djspint(k) = 0.d0
         dtmi(k) = 1.0d+06
         B(k) = 0.d0 !PK
         if(kstar(k).ne.13)then
            bacc(k) = 0.d0
            tacc(k) = 0.d0
         endif
*
 500  continue
*
      if(output) write(*,*)'Init:',mass(1),mass(2),massc(1),massc(2),
     & rad(1),rad(2),kstar(1),kstar(2),sep,ospin(1),ospin(2),jspin(1),
     & jspin(2),sigma,eddfac,z,id1_pass,id2_pass,tphysf,tphys,iter,tsave
*
      if(mt2.lt.tiny)then
         sep = 0.d0
         if(kst.gt.0)then
            mass0(kst) = 0.d0
            mass(kst) = 0.d0
            kmin = 3 - kst
            kmax = kmin
         endif
      endif
*
* On the first entry the previous timestep is zero to prevent mass loss.
*
      if(using_cmc.eq.1)then
          dtm = 0.d0
      else
          dtm = 1.d0
      endif
      delet = 0.d0
      djorb = 0.d0
*
* Setup variables which control the output (if it is required).
*
      ip = 0
      jp = 0

      tsave = tphys
      isave = .true.
      iplot = .false.
      if(dtp.le.0.d0)then
         iplot = .true.
         isave = .false.
         tsave = tphysf
      elseif(dtp.gt.tphysf)then
         isave = .false.
         tsave = tphysf
      endif
      if(tphys.ge.tphysf) goto 140
*
 4    iter = 0
      intpol = 0
      inttry = .false.
      change = .false.
      prec = .false.
      snova = .false.
      coel = .false.
      com = .false.
      tphys0 = tphys
      ecc1 = ecc
      j1 = 1
      j2 = 2
      if(kstar(1).ge.10.and.kstar(1).le.14) dtmi(1) = 0.01d0
      if(kstar(2).ge.10.and.kstar(2).le.14) dtmi(2) = 0.01d0
      dm1 = 0.d0
      dm2 = 0.d0
*
 5    kw1 = kstar(1)
      kw2 = kstar(2)
*      WRITE(*,*)iter,dt,dtm,dtmi

*
      dt = 1.0d+06*dtm
      eqspin = 0.d0
      djtt = 0.d0
*
      if(output) write(*,*)'1st in 5: ',tphys,dt,kw1,kw2,
     & mass(1),mass(2),intpol,iter
*
      if(intpol.eq.0.and.ABS(dtm).gt.tiny.and..not.sgl)then
         vorb2 = acc1*(mass(1)+mass(2))/sep
         ivsqm = 1.d0/SQRT(1.d0-ecc*ecc)
         do 501 , k = 1,2
*
* Calculate wind mass loss from the previous timestep.
*
            if(neta.gt.tiny)then
               rlperi = rol(k)*(1.d0-ecc)
               if(ST_tide.gt.1) rlperi = rol(k)
               dmr(k) = mlwind(kstar(k),lumin(k),rad(k),mass(k),
     &                         massc(k),rlperi,z)
*
* Calculate how much of wind mass loss from companion will be
* accreted (Boffin & Jorissen, A&A 1988, 205, 155).
*
               if(beta.lt.0.d0)then !PK. following startrack
                  beta = 0.125
                  if(kstar(k).le.1)then
                     if(mass(k).gt.120.d0)then
                        beta = 7.d0
                     elseif(mass(k).le.1.4d0)then
                        beta = 0.5
                     else
                        beta = 7.d0*((mass(k)-1.4d0)/(120.d0-1.4d0))
     &                         + 0.5d0
                     endif
                  elseif(kstar(k).ge.7.and.kstar(k).le.9)then
                     if(mass(k).gt.120.d0)then
                        beta = 7.d0
                     elseif(mass(k).le.10.d0)then
                        beta = 0.125
                     else
                        beta = 7.d0*((mass(k)-10.d0)/(120.d0-10.d0))
     &                               + 0.125d0
                     endif
                  endif
               endif
               vwind2 = 2.d0*beta*acc1*mass(k)/rad(k)
               omv2 = (1.d0 + vorb2/vwind2)**(3.d0/2.d0)
               dmt(3-k) = ivsqm*acc2*dmr(k)*((acc1*mass(3-k)/vwind2)**2)
     &                    /(2.d0*sep*sep*omv2)
               dmt(3-k) = MIN(dmt(3-k),0.8d0*dmr(k))
               beta = betahold
            else
               dmr(k) = 0.d0
               dmt(3-k) = 0.d0
            endif
 501     continue
*
* Diagnostic for Symbiotic-type stars.
*
         if(neta.gt.tiny)then
            lacc = 3.14d+07*mass(j2)*dmt(j2)/rad(j2)
            lacc = lacc/lumin(j1)
         endif
*
* Calculate orbital angular momentum change due to wind mass loss.
*
         ecc2 = ecc*ecc
         omecc2 = 1.d0 - ecc2
         sqome2 = SQRT(omecc2)
*
         djorb = ((dmr(1)+q(1)*dmt(1))*mass(2)*mass(2) +
     &            (dmr(2)+q(2)*dmt(2))*mass(1)*mass(1))*
     &           sep*sep*sqome2*oorb/(mass(1)+mass(2))**2
         delet = ecc*(dmt(1)*(0.5d0/mass(1) + 1.d0/(mass(1)+mass(2))) +
     &                dmt(2)*(0.5d0/mass(2) + 1.d0/(mass(1)+mass(2))))
*
* For very close systems include angular momentum loss owing to
* gravitational radiation.
*
         if(sep.le.100000.d0)then
            djgr = 8.315d-10*mass(1)*mass(2)*(mass(1)+mass(2))/
     &             (sep*sep*sep*sep)
            f1 = (19.d0/6.d0) + (121.d0/96.d0)*ecc2
            sqome5 = sqome2**5
            delet1 = djgr*ecc*f1/sqome5
            djgr = djgr*jorb*(1.d0+0.875d0*ecc2)/sqome5
            djorb = djorb + djgr
            delet = delet + delet1
         endif
*
         do 502 , k = 1,2

* Evaluate convective/radiative limits for a variety of stars as based
* on the work of Belczynski et al. (2008). As option.
* Note only certain stars of type k = 0, 1, 2, 4, 5, 6, 9 **double check
* 0, 1 have range of 0.35-Mms,conv. Mms,conv is function of metalicity.
* 2 & 4 have a temperature dependence. Convective if Teff < 10**3.73
* 3, 5 & 6 are giants and have no radiative envelopes.
* 9's envelope is convective when M < Mhe,conv, Mhe,conv = 3.0Msun.
*
            if(ST_cr.le.0)then
               if(kstar(k).le.1)then
                  convradcomp(k) = 1.25d0
               else
                  convradcomp(k) = 99999999.d0
               endif
            else
               if(kstar(k).le.1)then
*                 Main sequence mass limit varying with metallicity
                  convradcomp(k) = 1.25d0
                  if(z.gt.0.001d0.and.z.lt.0.02d0)then
                     convradcomp(k) = 0.747d0 + 55.73d0*z - 1532*z*z
                  elseif(z.le.0.001d0)then
                     convradcomp(k) = 0.8d0
                  endif
               elseif(kstar(k).eq.2.or.kstar(k).eq.4)then
*                 H-rich HG and CHeB temperature limit
                  convradcomp(k) = 10.d0**3.73d0
               elseif(kstar(k).le.6)then
*                 No limit or all other giant stars
*                 (compare this large value to mass).
                  convradcomp(k) = 99999999.d0
               elseif(kstar(k).eq.9)then
*                 Mass limit for evolved He star
                  convradcomp(k) = 3.d0
               endif
            endif
*
* Calculate change in the intrinsic spin of the star.
*
*
* Pulsar wind spinup. PK.
*
            if(kstar(k).eq.13.and.pulsar.gt.0)then
* Place propeller stuff here eventually.
               if(xip.eq.1)then
* Modify spin angular momentum accretion according to Ruffert (1999)
* or magnetic field strength limit tested (but by no means established - in fact it
* is likely to change, especially when propeller and ablation are implemented)
* in Kiel et al. (2008).
                  if(B(k).gt.0.d0)then
                     xi = MIN(1.d0,(0.01d0*(2.0d+11/B(k)))+0.01d0)
                     xi = 0.01
                  else
                     xi = 0.01
                  endif
               endif
               djtx(k) = (2.d0/3.d0)*xi*dmt(k)*rad(3-k)*rad(3-k)*
     &                   ospin(3-k)
               djspint(k) = (2.d0/3.d0)*(dmr(k)*rad(k)*rad(k)*ospin(k))-
     &                      djtx(k)
               xi = xihold
               if(output) write(*,*)'502 1:',k,djspint(k),djtx(k),
     & dmt(k),rad(3-k),ospin(3-k),xi,xihold
            else
               djtx(k) = (2.d0/3.d0)*xi*dmt(k)*
     &                     rad(3-k)*rad(3-k)*ospin(3-k)
               djspint(k) = (2.d0/3.d0)*
     &                       (dmr(k)*rad(k)*rad(k)*ospin(k)) - djtx(k)
            endif
*
* Include magnetic braking for stars that have appreciable convective
* envelopes. This includes MS stars with M < 1.25, HG stars near the GB
* and giants. MB is not allowed for fully convective MS stars.
*
*            if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
*               djmb = 5.83d-16*menv(k)*(rad(k)*ospin(k))**3/mass(k)
*               djspint(k) = djspint(k) + djmb
*
*            if(mass(k).gt.0.35d0.and.kstar(k).lt.10.and.
*     &              menv(k).gt.0.0d0)then
*              if (ospin(k) .le. wx) djmb = kw3 * rad(k)**4.0d0 *
*     &              (ospin(k)/wsun)**3.0d0
*              if (ospin(k) .gt. wx) djmb = kw3 * rad(k)**4.0d0 *
*     &             (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
*              djspint(k) = djspint(k) + djmb
            djmb = 0.d0
            if(htpmb.eq.0)then
* HTP02 method
               if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
                  djmb = 5.83d-16*menv(k)*
     &                   (rad(k)*ospin(k))**3/mass(k)
                  djspint(k) = djspint(k) + djmb
               endif
            else
               if(ST_cr.le.0.and.mass(k).gt.0.35d0.and.
     &            kstar(k).lt.10.and.menv(k).gt.0.0d0)then
* Ivanova & Taam (2002) method
                  if(ospin(k).le.wx) djmb = kw3 * rad(k)**4.0d0 *
     &                (ospin(k)/wsun)**3.0d0
                  if(ospin(k).gt.wx) djmb = kw3 * rad(k)**4.0d0 *
     &                (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
                  djspint(k) = djspint(k) + djmb
               elseif(ST_cr.gt.0.and.menv(k).gt.0.d0.and.
     &            ((kstar(k).le.1.and.mass(k).gt.0.35d0.and.
     &              mass(k).le.convradcomp(k)).or.
     &              (kstar(k).eq.2.and.teff(k).le.convradcomp(k)).or.
     &              (kstar(k).eq.4.and.teff(k).le.convradcomp(k)).or.
     &              ((kstar(k).eq.3).or.(kstar(k).eq.5).or.
     &              (kstar(k).eq.6))))then
* Ivanova & Taam (2002) method
                  if(ospin(k).le.wx) djmb = kw3 * rad(k)**4.0d0 *
     &               (ospin(k)/wsun)**3.0d0
                  if(ospin(k).gt.wx) djmb = kw3 * rad(k)**4.0d0 *
     &               (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
                  djspint(k) = djspint(k) + djmb
               endif
            endif
* Limit to a 3% angular momentum change for the star owing to MB.
* This is found to work best with the maximum iteration of 20000,
* i.e. does not create an excessive number of iterations, while not
* affecting the evolution outcome when compared with a 2% restriction.
*
            if(djmb.gt.tiny)then
               dtj = 0.03d0*jspin(k)/ABS(djmb)
               dt = MIN(dt,dtj)
               if(output) write(*,*)'mb1:',tphys,dt,djmb,djt
            endif
*
            if(kstar(k).eq.13.and.pulsar.gt.0)then
*
* NS(pulsar) magnetic braking. PK.
* No contact binary NS system.
*
               if(bdecayfac.eq.0)then
                  if(B_0(k).eq.0.d0)then
                     B(k) = 0.d0
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny)then
                     B(k) = B_0(k)*exp(CK*bacc(k)) + Bbot
                  else
                     B(k) = B_0(k)*EXP((tphys-epoch(k)-tacc(k))/bconst)*
     &                       exp(CK*bacc(k)) + Bbot
                  endif
               else
                  if(B_0(k).eq.0.d0)then
                     B(k) = 0.d0
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny.and.
     &                bacc(k).eq.0.d0)then
                     B(k) = B_0(k) + Bbot
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny)then
                     B(k) = B_0(k)/(1.d0 + (bacc(k)/1.0d-6)) + Bbot
                  elseif(bacc(k).eq.0.d0)then
                     B(k) = B_0(k)*EXP((tphys-epoch(k)-tacc(k))/bconst)
     &                       + Bbot
                  else
                     B(k) = B_0(k)*EXP((tphys-epoch(k)-tacc(k))/bconst)/
     &                       (1.d0 + (bacc(k)/1.0d-6)) + Bbot
                  endif
               endif
               omdot = Kconst*B(k)*B(k)*ospin(k)**3
               djmb = 0.4d0*mass(k)*rad(k)*rad(k)*omdot
               djspint(k) = djspint(k) + djmb
               if(output) write(*,*)'502 2:',k,djspint(k),djmb
               if(djmb.gt.tiny)then
                  dtj = 0.1d0*(jspin(k)/ABS(djmb))
                  dt = MIN(dt,dtj)
               endif
            endif
*
* Calculate circularization, orbital shrinkage and spin up.
*
            dspint(k) = 0.d0
            if(((kstar(k).le.9.and.rad(k).ge.0.01d0*rol(k)).or.
     &         (kstar(k).ge.10.and.k.eq.j1)).and.tflag.gt.0)then
*
               raa2 = (rad(k)/sep)**2
               raa6 = raa2**3
*
* Hut's polynomials.
*
               f5 = 1.d0+ecc2*(3.d0+ecc2*0.375d0)
               f4 = 1.d0+ecc2*(1.5d0+ecc2*0.125d0)
               f3 = 1.d0+ecc2*(3.75d0+ecc2*(1.875d0+ecc2*7.8125d-02))
               f2 = 1.d0+ecc2*(7.5d0+ecc2*(5.625d0+ecc2*0.3125d0))
               f1 = 1.d0+ecc2*(15.5d0+ecc2*(31.875d0+ecc2*(11.5625d0
     &                  +ecc2*0.390625d0)))
*
               if(ST_cr.le.0.and.
     &            ((kstar(k).eq.1.and.mass(k).ge.1.25d0).or.
     &            kstar(k).eq.4.or.kstar(k).eq.7))then
*
* Radiative damping (Zahn, 1977, A&A, 57, 383 and 1975, A&A, 41, 329).
*
                  tc = 1.592d-09*(mass(k)**2.84d0)
                  f = 1.9782d+04*SQRT((mass(k)*rad(k)*rad(k))/sep**5)*
     &                tc*(1.d0+q(3-k))**(5.d0/6.d0)
                  tcqr = f*q(3-k)*raa6
                  rg2 = k2str(k)
               elseif(ST_cr.gt.0.and.
     &                ((kstar(k).le.1.and.mass(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.2.and.teff(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.4.and.teff(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.9.and.mass(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.7).or.(kstar(k).eq.8)))then
*
* Radiative damping (Zahn, 1977, A&A, 57, 383 and 1975, A&A, 41, 329).
*
                  tc = 1.592d-09*(mass(k)**2.84d0)
                  f = 1.9782d+04*SQRT((mass(k)*rad(k)*rad(k))/sep**5)*
     &                tc*(1.d0+q(3-k))**(5.d0/6.d0)
                  tcqr = f*q(3-k)*raa6
                  rg2 = k2str(k) !for startrack comparison this should be =0.31622777d0 (sqrt(0.1)).
               elseif(kstar(k).le.9)then
*
* Convective damping (Hut, 1981, A&A, 99, 126).
*
* In BSE paper Equation 30, the default scaling coefficient is 2./21
* the fprimc_array kstar dependent array that is fed in
* keeps this same coefficient by default but allows user to
* specify their own
*
                  tc = mr23yr*(menv(k)*renv(k)*(rad(k)-0.5d0*renv(k))/
     &                 (3.d0*lumin(k)))**(1.d0/3.d0)
                  ttid = twopi/(1.0d-10 + ABS(oorb - ospin(k)))
                  f = MIN(1.d0,(ttid/(2.d0*tc))**2)
                  tcqr = fprimc_array(kstar(k))*
     &                 f*q(3-k)*raa6*menv(k)/
     &                 (tc*mass(k))
                  rg2 = (k2str(k)*(mass(k)-massc(k)))/mass(k)
               elseif(ST_tide.le.0)then
*
* Degenerate damping (Campbell, 1984, MNRAS, 207, 433)
*
                  f = 7.33d-09*(lumin(k)/mass(k))**(5.d0/7.d0)
                  tcqr = f*q(3-k)*q(3-k)*raa2*raa2/(1.d0+q(3-k))
                  rg2 = k3
               endif
*
* Circularization.
*
               sqome3 = sqome2**3
               delet1 = 27.d0*tcqr*(1.d0+q(3-k))*raa2*(ecc/sqome2**13)*
     &                  (f3 - (11.d0/18.d0)*sqome3*f4*ospin(k)/oorb)
               tcirc = ecc/(ABS(delet1) + 1.0d-20)
               delet = delet + delet1
*
* Spin up of star.
*
               dspint(k) = (3.d0*q(3-k)*tcqr/(rg2*omecc2**6))*
     &                     (f2*oorb - sqome3*f5*ospin(k))
               if(output) write(*,*)'502 3:',k,dspint(k),tcqr
*
* Calculate the equilibrium spin at which no angular momentum
* can be transferred.
*
               eqspin = oorb*f2/(sqome3*f5)
*
* Calculate angular momentum change for the star owing to tides.
*
               djt = (k2str(k)*(mass(k)-massc(k))*rad(k)*rad(k) +
     &                k3*massc(k)*radc(k)*radc(k))*dspint(k)
               if(kstar(k).le.6.or.ABS(djt)/jspin(k).gt.0.1d0)then
                  djtt = djtt + djt
               endif
            endif
 502     continue
*
* Limit to 2% orbital angular momentum change.
*
         djtt = djtt + djorb
         if(ABS(djtt).gt.tiny)then
            dtj = 0.02d0*jorb/ABS(djtt)
            dt = MIN(dt,dtj)
         endif
         dtm = dt/1.0d+06
         if(output) write(*,*)'bin lim orb ang mom:',tphys,dt,kstar(1)
*
      elseif(ABS(dtm).gt.tiny.and.sgl)then
         do 503 , k = kmin,kmax
            if(neta.gt.tiny)then
               rlperi = 0.d0
               dmr(k) = mlwind(kstar(k),lumin(k),rad(k),mass(k),
     &                         massc(k),rlperi,z)
            else
               dmr(k) = 0.d0
            endif
            dmt(k) = 0.d0
            djspint(k) = (2.d0/3.d0)*dmr(k)*rad(k)*rad(k)*ospin(k)
            if(output) write(*,*)'503 1:',k,djspint(k)
*
* Evaluate convective/radiative limits for a variety of stars as based
* on the work of Belczynski et al. (2008). As option.
* Note only certain stars of type k = 0, 1, 2, 4, 5, 6, 9 **double check
* 0, 1 have range of 0.35-Mms,conv. Mms,conv is function of metalicity.
* 2 & 4 have a temperature dependence. Convective if Teff < 10**3.73
* 3, 5 & 6 are giants and have no radiative envelopes.
* 9's envelope is convective when M < Mhe,conv, Mhe,conv = 3.0Msun.
*
            if(ST_cr.le.0)then
               if(kstar(k).le.1)then
                  convradcomp(k) = 1.25d0
               else
                  convradcomp(k) = 99999999.d0
               endif
            else
               if(kstar(k).le.1)then
*                 Main sequence mass limit varying with metallicity
                  convradcomp(k) = 1.25d0
                  if(z.gt.0.001d0.and.z.lt.0.02d0)then
                     convradcomp(k) = 0.747d0 + 55.73d0*z - 1532*z*z
                  elseif(z.le.0.001d0)then
                     convradcomp(k) = 0.8d0
                  endif
               elseif(kstar(k).eq.2.or.kstar(k).eq.4)then
*                 H-rich HG and CHeB temperature limit
                  convradcomp(k) = 10.d0**3.73d0
               elseif(kstar(k).le.6)then
*                 No limit or all other giant stars
*                 (compare this large value to mass).
                  convradcomp(k) = 99999999.d0
               elseif(kstar(k).eq.9)then
*                 Mass limit for evolved He star
                  convradcomp(k) = 3.d0
               endif
            endif
*            if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
*               djmb = 5.83d-16*menv(k)*(rad(k)*ospin(k))**3/mass(k)
*               djspint(k) = djspint(k) + djmb
*             if(mass(k).gt.0.35d0.and.kstar(k).lt.10.and.
*     &              menv(k).gt.0.0d0)then
*                if (ospin(k) .le. wx) djmb = kw3 * rad(k)**4.0d0 *
*     &              (ospin(k)/wsun)**3.0d0
*                if (ospin(k) .gt. wx) djmb = kw3 * rad(k)**4.0d0 *
*     &             (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
*                djspint(k) = djspint(k) + djmb
*
*MB
            djmb = 0.d0
            if(htpmb.eq.0)then
               if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
                  djmb = 5.83d-16*menv(k)*(rad(k)*ospin(k))**3/mass(k)
                  djspint(k) = djspint(k) + djmb
               endif
            else
               if(ST_cr.le.0.and.
     &            mass(k).gt.0.35d0.and.kstar(k).lt.10.and.
     &            menv(k).gt.0.0d0)then
* Old BSE convective/radiative divide...
                   if(ospin(k).le.wx) djmb = kw3 * rad(k)**4.0d0 *
     &                 (ospin(k)/wsun)**3.0d0
                   if(ospin(k).gt.wx) djmb = kw3 * rad(k)**4.0d0 *
     &             (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
                   djspint(k) = djspint(k) + djmb
               elseif(ST_cr.gt.0.and.(menv(k).gt.0.d0.and.
     &            ((kstar(k).le.1.and.mass(k).gt.0.35d0.and.
     &              mass(k).le.convradcomp(k)).or.
     &              (kstar(k).eq.2.and.teff(k).le.convradcomp(k)).or.
     &              (kstar(k).eq.4.and.teff(k).le.convradcomp(k)).or.
     &              ((kstar(k).eq.3).or.(kstar(k).eq.5).or.
     &              (kstar(k).eq.6)))))then
* MB given in Ivanova & Taam (2002)
*            if(mass(k).gt.0.35d0.and.kstar(k).lt.10.and.
*     &              menv(k).gt.0.0d0)then
                  if(ospin(k).le.wx) djmb = kw3 * rad(k)**4.0d0 *
     &                (ospin(k)/wsun)**3.0d0
                  if(ospin(k).gt.wx) djmb = kw3 * rad(k)**4.0d0 *
     &               (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
                  djspint(k) = djspint(k) + djmb
               endif
            endif
*                if(output) write(*,*)'503 2:',k,djspint(k),djmb
            if(djmb.gt.tiny)then
               dtj = 0.03d0*jspin(k)/ABS(djmb)
               dt = MIN(dt,dtj)
            endif
            if(kstar(k).eq.13.and.pulsar.gt.0)then
*
* NS magnetic braking. PK.
* Single NS evolution.
*
               if(bdecayfac.eq.0)then
                  if(B_0(k).eq.0.d0)then
                     B(k) = 0.d0
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny)then
                     B(k) = B_0(k)*exp(CK*bacc(k)) + Bbot
                  else
                     B(k) = B_0(k)*EXP((tphys-epoch(k)-tacc(k))/bconst)*
     &                       exp(CK*bacc(k)) + Bbot
                  endif
               else
                  if(B_0(k).eq.0.d0)then
                     B(k) = 0.d0
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny.and.
     &                bacc(k).eq.0.d0)then
                     B(k) = B_0(k) + Bbot
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny)then
                     B(k) = B_0(k)/(1.d0 + (bacc(k)/1.0d-6)) + Bbot
                  elseif(bacc(k).eq.0.d0)then
                     B(k) = B_0(k)*EXP((tphys-epoch(k)-tacc(k))/bconst)
     &                       + Bbot
                  else
                     B(k) = B_0(k)*EXP((tphys-epoch(k)-tacc(k))/bconst)/
     &                       (1.d0 + (bacc(k)/1.0d-6)) + Bbot
                  endif
               endif
               omdot = Kconst*B(k)*B(k)*ospin(k)**3
               djmb = 0.4d0*mass(k)*rad(k)*rad(k)*omdot
               djspint(k) = djspint(k) + djmb
               if(output) write(*,*)'503 2:',k,djmb,djspint(k)
* Consider update of time-stepping due to dj, i.e. dt = dj/(dj/dt).
               if(djmb.gt.tiny)then
                  dtj = 0.1d0*(jspin(k)/ABS(djmb))
                  dt = MIN(dt,dtj)
               endif
            endif
 503     continue
         dtm = dt/1.0d+06
      endif
*
      do 504 , k = kmin,kmax
*
         dms(k) = (dmr(k) - dmt(k))*dt
         if(kstar(k).lt.10)then
            dml = mass(k) - massc(k)
            if(dml.lt.dms(k))then
               dml = MAX(dml,2.d0*tiny)
               dtm = (dml/dms(k))*dtm
               if(k.eq.2) dms(1) = dms(1)*dml/dms(2)
               dms(k) = dml
               dt = 1.0d+06*dtm
            endif
*
* Limit to 1% mass loss.
*
            if(dms(k).gt.0.01d0*mass(k))then
               dtm = 0.01d0*mass(k)*dtm/dms(k)
               if(k.eq.2) dms(1) = dms(1)*0.01d0*mass(2)/dms(2)
               dms(k) = 0.01d0*mass(k)
               dt = 1.0d+06*dtm
            endif
         endif
         if(output) write(*,*)'after 1p ml: ',tphys,k,dt,dtm
*
 504  continue
*
* Update mass and intrinsic spin (checking that the star is not spun
* past the equilibrium) and reset epoch for a MS (and possibly a HG) star.
*
      do 505 , k = kmin,kmax
*
         if(eqspin.gt.0.d0.and.ABS(dspint(k)).gt.tiny)then
            if(intpol.eq.0)then
               if(dspint(k).ge.0.d0)then
                  dspint(k) = MIN(dspint(k),(eqspin-ospin(k))/dt)
               else
                  dspint(k) = MAX(dspint(k),(eqspin-ospin(k))/dt)
               endif
               djt = (k2str(k)*(mass(k)-massc(k))*rad(k)*rad(k) +
     &                k3*massc(k)*radc(k)*radc(k))*dspint(k)
               djorb = djorb + djt
               djspint(k) = djspint(k) - djt
               if(output) write(*,*)'505: ',k,djt,djspint(k),jspin(k),dt
            endif
         endif
*
         if(output) write(*,*)'505 1:',tphys,k,kstar(k),djspint(k),
     & djspint(k)*dt,jspin(k),intpol
         jspin(k) = MAX(1.0d-10,jspin(k) - djspint(k)*dt)
         if(output) write(*,*)'505 2:',tphys,k,kstar(k),djspint(k),
     & djspint(k)*dt,jspin(k)
*
* Ensure that the star does not spin up beyond break-up.
*
         ospbru = twopi*SQRT(mass(k)*aursun**3/rad(k)**3)
         jspbru = (k2str(k)*(mass(k)-massc(k))*rad(k)*rad(k) +
     &             k3*massc(k)*radc(k)*radc(k))*ospbru
         if((jspin(k).gt.jspbru.or.
     &      (jspin(k).eq.1.0d-10.and.intpol.gt.0)).and.
     &      ABS(dtm).gt.tiny)then !PDK add check for jspin intpol issues here.
* If rapidly spinning star (generally NS) pushed over the edge (spins up so
* much so that jspin would have become negative according to bse, so it sets
* it to 1.d0-10) in intpol then give it the stars maximum spin.
            mew = 1.d0
            if(djtx(k).gt.0.d0.and.jspin(k).gt.1.d0-10)then !dont go in here if jspin hit wall.
               mew = MIN(mew,(jspin(k) - jspbru)/djtx(k))
            endif
            jspin(k) = jspbru
* If excess material should not be accreted, activate next line.
*           dms(k) = dms(k) + (1.d0 - mew)*dmt(k)*dt
         endif
* Update mass
         if(ABS(dms(k)).gt.tiny)then
            mass(k) = mass(k) - dms(k)
            if(kstar(k).le.2.or.kstar(k).eq.7)then
               m0 = mass0(k)
               mass0(k) = mass(k)
               CALL star(kstar(k),mass0(k),mass(k),tm,tn,tscls,
     &                   lums,GB,zpars)
               if(kstar(k).eq.2)then
                  if(GB(9).lt.massc(k).or.m0.gt.zpars(3))then
                     mass0(k) = m0
                  else
                     epoch(k) = tm + (tscls(1) - tm)*(aj(k)-tms(k))/
     &                               (tbgb(k) - tms(k))
                     epoch(k) = tphys - epoch(k)
                  endif
               else
                  epoch(k) = tphys - aj(k)*tm/tms(k)
               endif
            endif
* Update NS magnetic field owing to accretion, as a function of mass accreted. PK.
            if(kstar(k).eq.13.and.pulsar.gt.0)then
               if(dms(k).lt.0.d0)then !negative dms is mass gained.
* When propeller ev. include .not.prop here...
                  b_mdot = dms(k)/dt
                  if(b_mdot_lim.gt.0.d0.and.b_mdot.gt.b_mdot_lim)then
                     bacc(k) = bacc(k) - dms(k)
                     tacc(k) = tacc(k) + dtm
                  elseif(b_mdot_lim.le.0.d0)then
                     bacc(k) = bacc(k) - dms(k)
                     tacc(k) = tacc(k) + dtm
                  endif
               endif
            endif
         endif
*
 505  continue
*
      if(.not.sgl)then
*
         ecc1 = ecc1 - delet*dt
         ecc = MAX(ecc1,0.d0)
         if(ecc.lt.1.0d-10) ecc = 0.d0
*
         if(ecc.ge.1.d0) goto 135
*
         jorb = jorb - djorb*dt
         sep = (mass(1) + mass(2))*jorb*jorb/
     &         ((mass(1)*mass(2)*twopi)**2*aursun**3*(1.d0-ecc*ecc))
         tb = (sep/aursun)*SQRT(sep/(aursun*(mass(1)+mass(2))))
         oorb = twopi/tb
      endif
*
* Advance the time.
*
      if(intpol.eq.0)then
         tphys0 = tphys
         dtm0 = dtm
      endif
      tphys = tphys + dtm

      if(output) write(*,*)'time upd:',tsave, tphys,dtm,
     &                      kstar(1),kstar(2),ecc
*
      do 6 , k = kmin,kmax
*
* Acquire stellar parameters (M, R, L, Mc & K*) at apparent evolution age.
*
         age = tphys - epoch(k)
         aj0(k) = age
         kw = kstar(k)
         m0 = mass0(k)
         mt = mass(k)
         mc = massc(k)
         if(intpol.eq.0) mcxx(k) = mc
         if(intpol.gt.0) mc = mcxx(k)
         mass00(k) = m0
*
* Masses over 100Msun should probably not be trusted in the
* evolution formulae.
*
         if(mt.gt.100.d0)then
*            WRITE(99,*)' MASS EXCEEDED ',mass1i,mass2i,tbi,ecci,mt,
*     & tphysf,id1_pass,id2_pass
*            goto 140
         endif
*
         CALL star(kw,m0,mt,tm,tn,tscls,lums,GB,zpars)
         CALL hrdiag(m0,age,mt,tm,tn,tscls,lums,GB,zpars,
     &               rm,lum,kw,mc,rc,me,re,k2,bhspin(k),k)
*
         if(kw.ne.15)then
            ospin(k) = jspin(k)/(k2*(mt-mc)*rm*rm+k3*mc*rc*rc)
         endif
*
* At this point there may have been a supernova.
*
         if((kw.ne.kstar(k).and.kstar(k).le.12.and.
     &      (kw.eq.13.or.kw.eq.14)).or.(ABS(merger).ge.20.d0))then
            if(formation(k).ne.11) formation(k) = 1
            if(kw.eq.13.and.ecsn.gt.0.d0)then
               if(kstar(k).le.6)then
                  if(mass0(k).le.zpars(5))then
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = sigmahold/sigmadiv
                        sigma = -sigma
                     else
                        sigma = -1.d0*sigmadiv
                     endif
                     formation(k) = 2
                  endif
               elseif(kstar(k).ge.7.and.kstar(k).le.9)then
                  if(mass(k).gt.ecsn_mlow.and.mass(k).le.ecsn)then
* BSE orgi: 1.6-2.25, Pod: 1.4-2.5, StarTrack: 1.83-2.25 (all in Msun)
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = sigmahold/sigmadiv
                        sigma = -sigma
                     else
                        sigma = -1.d0*sigmadiv
                     endif
                     formation(k) = 2
                  endif
               elseif(formation(k).eq.11)then
* MIC
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = sigmahold/sigmadiv
                     sigma = -sigma
                  else
                     sigma = -1.d0*sigmadiv
                  endif
                  formation(k) = 5
               elseif(kstar(k).ge.10.or.kstar(k).eq.12)then
* AIC formation, will never happen here but...
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = sigmahold/sigmadiv
                     sigma = -sigma
                  else
                     sigma = -1.d0*sigmadiv
                  endif
                  formation(k) = 4
               elseif(merger.ge.20.d0)then
                  sigma = merger
                  fallback = 0.d0
                  if(merger.ge.200.d0)then!estimate CC SN
                     formation(k) = 1
                  else
                     formation(k) = 5
                  endif
               elseif(merger.le.-20.d0)then
                  sigma = ABS(merger)
                  fallback = 0.d0
                  if(merger.ge.200.d0)then!estimate CC SN
*Sourav:Possible bug in the line above. merger should really be sigms!!
*                  if(sigma.ge.200.d0)then!estimate CC SN
                     formation(k) = 1
                  else
                     formation(k) = 5
                  endif
               endif
            elseif(kw.eq.13.and.aic.gt.0)then
               if(formation(k).eq.11)then
* MIC
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = sigmahold/sigmadiv
                     sigma = -sigma
                  else
                     sigma = -1.d0*sigmadiv
                  endif
                  formation(k) = 5
               elseif(kstar(k).ge.10.or.kstar(k).eq.12)then
* AIC formation, will never happen here but...
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = sigmahold/sigmadiv
                     sigma = -sigma
                  else
                     sigma = -1.d0*sigmadiv
                  endif
                  formation(k) = 4
               endif
            elseif(ABS(merger).ge.20.d0)then
               sigma = ABS(merger)
               fallback = 0.d0
               if(merger.ge.200.d0)then!estimate CC SN
                  formation(k) = 1
               else
                  formation(k) = 5
               endif
            endif
            if(sgl)then
               evolve_type = 14.d0 + FLOAT(k)
               CALL writebpp(jp,tphys,evolve_type,
     &                      mass(1),mass(2),kstar(1),kstar(2),
     &                      sep,tb,ecc,rrl1,rrl2,bkick,
     &                      aj(1),aj(2),tms(1),tms(2),
     &                      massc(1),massc(2),rad(1),rad(2))
               CALL kick(kw,mass(k),mt,0.d0,0.d0,-1.d0,0.d0,vk,k,
     &                   0.d0,fallback,bkick,disrupt)
               sigma = sigmahold !reset sigma after possible ECSN kick dist. Remove this if u want some kick link to the intial pulsar values...
* set kick values for the bcm array
               if(bkick(13).gt.0.d0)then
                  vk1_bcm=bkick(13)
               endif
               if(bkick(14).gt.0.d0)then
                  vk2_bcm=bkick(14)
               endif
               if(bkick(17).gt.0.d0)then
                  vsys_bcm=bkick(17)
               endif
               if(bkick(20).gt.0.d0)then
                  theta_bcm=bkick(20)
               endif

            else
               evolve_type = 14.d0 + FLOAT(k)
               CALL writebpp(jp,tphys,evolve_type,
     &                       mass(1),mass(2),kstar(1),kstar(2),
     &                       sep,tb,ecc,rrl1,rrl2,bkick,
     &                       aj(1),aj(2),tms(1),tms(2),
     &                       massc(1),massc(2),rad(1),rad(2))

               CALL kick(kw,mass(k),mt,mass(3-k),ecc,sep,jorb,vk,k,
     &                   rad(3-k),fallback,bkick,
     &                   disrupt)
               sigma = sigmahold !reset sigma after possible ECSN kick dist. Remove this if u want some kick link to the intial pulsar values...
* set kick values for the bcm array
               if(bkick(13).gt.0.d0)then
                  vk1_bcm=bkick(13)
               endif
               if(bkick(14).gt.0.d0)then
                  vk2_bcm=bkick(14)
               endif
               if(bkick(17).gt.0.d0)then
                  vsys_bcm=bkick(17)
               endif
               if(bkick(20).gt.0.d0)then
                  theta_bcm=bkick(20)
               endif
               if(mass(3-k).lt.0.d0)then
                  if(kstar(3-k).lt.0.d0) mt = mt-mass(3-k) !ignore TZ object
                  if(kw.eq.13.and.mt.gt.mxns) kw = 14
                  CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
                  kstar(k) = kw
                  mass(k) = mt
                  epoch(k) = tphys - age
                  kstar(3-k) = 15
                  mass(3-k) = 0.d0
                  coel = .true.
                  binstate = 1
                  goto 135
               endif
               if(ecc.gt.1.d0)then
                  kstar(k) = kw
                  mass(k) = mt
                  epoch(k) = tphys - age
                  goto 135
               endif
               tb = (sep/aursun)*SQRT(sep/(aursun*(mt+mass(3-k))))
               oorb = twopi/tb
            endif

            merger = -1.d0
            snova = .true.
         endif
*
         if(kw.ne.kstar(k))then
            change = .true.
            mass(k) = mt
            dtmi(k) = 0.01d0
            if(kw.eq.15)then
               kstar(k) = kw
               goto 135
            endif
            mass0(k) = m0
            epoch(k) = tphys - age
         endif
*
*
* Force new NS or BH to have a birth spin peirod and magnetic field.
*
         if(kstar(k).eq.13.or.kstar(k).eq.14)then
            if(tphys-epoch(k).lt.tiny)then
               if(kstar(k).eq.13.and.pulsar.gt.0)then
*                  write(93,*)'birth start: ',tphys,k,B_0(k),ospin(k)
*                  CALL FLUSH(93)
 170              u1 = ran3(idum1)
                  if(u1.ge.1.d0) goto 170
                  u2 = ran3(idum1)
                  s = sqrt(-2.d0*LOG(1.d0-u1))*COS(twopi*u2)
                  s = 0.7d0*s - 0.6d0
                  if(s.ge.0.013d0.or.s.le.-1.5d0) goto 170
                  ospin(k) = (twopi*yearsc)/(10.d0**s)
 174              u1 = ran3(idum1)
                  if(u1.ge.1.d0) goto 174
                  u2 = ran3(idum1)
                  s = sqrt(-2.d0*LOG(1.d0-u1))*COS(twopi*u2)
                  s = 0.68d0*s + 12.6d0
                  if(s.lt.11.5d0.or.s.gt.13.8d0) goto 174
                  B_0(k) = 10.d0**s
                  bacc(k) = 0.d0 ! If it has been a NS before reset
                  tacc(k) = 0.d0
                  if((merger.le.-2.d0.and.merger.gt.-20.d0).or.
     &                merge_mem.eq.1)then
* Reset as MSP.
 175                 u1 = ran3(idum1)
                     u2 = ran3(idum1)
                     if(u1.gt.0.9999d0) u1 = 0.9999d0
                     if(u2.gt.1.d0) u2 = 1.d0
                     s = SQRT(-2.d0*LOG(1.d0-u1))*COS(twopi*u2)
*                  s = 0.7d0*s - 0.6d0
                     s = 0.5d0*s - 2.25d0
*                  if(s.ge.0.013.or.s.le.-1.5) goto 173
*                  if(s.ge.-2.0457d0.or.s.le.-2.53d0) goto 175
                     if(s.ge.-1.6457d0.or.s.le.-2.53d0) goto 175
                     ospin(k) = (twopi*yearsc)/(10.d0**s)!have commented this out to keeps same spin
*                  write(*,*)'P=',s
 176                 u1 = ran3(idum1)
                     u2 = ran3(idum1)
                     if(u1.gt.0.9999d0) u1 = 0.9999d0
                     if(u2.gt.1.d0) u2 = 1.d0
                     s = SQRT(-2.d0*LOG(1.d0-u1))*COS(twopi*u2)
                     s = 0.3d0*s + 8.38d0
                     if(s.lt.8.d0.or.s.gt.8.778d0) goto 176
                     B_0(k) = 10.d0**s
                  endif
               else
                  ospin(k) = 2.0d+08
               endif
               bacc(k) = 0.d0 !make sure if its been a NS before its now a new one...
               tacc(k) = 0.d0
               jspin(k) = k3*rc*rc*mc*ospin(k)
               if(output) write(*,*)'SN: ',k,kstar(k),ospin(k),sigma
               sigma = sigmahold !reset sigma after possible ECSN kick dist.
            endif
         endif
         merge_mem = 0
*
* Set radius derivative for later interpolation.
*
         if(ABS(dtm).gt.tiny)then
            rdot(k) = ABS(rm - rad(k))/dtm
         else
            rdot(k) = 0.d0
         endif
*
*     Base new time scale for changes in radius & mass on stellar type.
*
         dt = dtmi(k)
         CALL deltat(kw,age,tm,tn,tscls,dt,dtr)
         if(output) write(*,*)'post deltat:',tphys,dt,dtr,kw,
     & age,intpol,iter,k,kmin,kmax
*
* Choose minimum of time-scale and remaining interval.
*
         dtmi(k) = MIN(dt,dtr)
*
* Save relevent solar quantities.
*
         aj(k) = age
         kstar(k) = kw
         rad(k) = rm
         lumin(k) = lum
         teff(k) = 1000.d0*((1130.d0*lumin(k)/
     &                    (rad(k)**2.d0))**(1.d0/4.d0))
         massc(k) = mc
         radc(k) = rc
         menv(k) = me
         renv(k) = re
         k2str(k) = k2
         tms(k) = tm
         tbgb(k) = tscls(1)
*
 6    continue
*
      if(.not.sgl)then
*
* Determine the mass ratios.
*
         do 506 , k = 1,2
            q(k) = mass(k)/mass(3-k)
 506     continue
*
* Determine the Roche lobe radii and adjust the radius derivative.
*
         do 507 , k = 1,2
            rol(k) = rl(q(k))*sep
            if(ST_tide.gt.0) rol(k) = rl(q(k))*sep*(1.d0-ecc)
            if(ABS(dtm).gt.tiny)then
               rdot(k) = rdot(k) + (rol(k) - rol0(k))/dtm
               rol0(k) = rol(k)
            endif
 507     continue
      else
         do 508 , k = kmin,kmax
            rol(k) = 10000.d0*rad(k)
 508     continue
      endif
*
      if((tphys.lt.tiny.and.ABS(dtm).lt.tiny.and.
     &    (mass2i.lt.0.1d0.or..not.sgl)).or.snova)then
          evolve_type = 1.d0
          rrl1 = rad(1)/rol(1)
          rrl2 = rad(2)/rol(2)
          CALL writebpp(jp,tphys,evolve_type,
     &                  mass(1),mass(2),kstar(1),kstar(2),sep,
     &                  tb,ecc,rrl1,rrl2,bkick,
     &                  aj(1),aj(2),tms(1),tms(2),
     &                  massc(1),massc(2),rad(1),rad(2))
         DO jj = 13,20
            bkick(jj) = 0.0
         ENDDO
         if(snova)then
            bpp(jp,11) = 2.0
            dtm = 0.d0
            goto 4
         endif
      endif
*
      if((isave.and.tphys.ge.tsave).or.iplot)then
         if(sgl.or.(rad(1).lt.rol(1).and.rad(2).lt.rol(2)).
     &      or.tphys.lt.tiny)then
            if(B_0(1).eq.0.d0)then !PK.
               b01_bcm = 0.d0
            elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
               b01_bcm = B_0(1)
            else
               b01_bcm = B(1)
            endif
            if(B_0(2).eq.0.d0)then
               b02_bcm = 0.d0
            elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
               b02_bcm = B_0(2)
            else
               b02_bcm = B(2)
            endif
            teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
            teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
            rrl1 = rad(1)/rol(1)
            rrl2 = rad(2)/rol(2)
            deltam1_bcm = dmt(1) - dmr(1)
            deltam2_bcm = dmt(2) - dmr(2)
* Check if PISN occurred, and if so overwrite formation
            if(pisn_track(1).ne.0) formation(1) = pisn_track(1)
            if(pisn_track(2).ne.0) formation(2) = pisn_track(2)
            CALL writebcm(ip,tphys,kstar(1),mass0(1),mass(1),
     &                    lumin(1),rad(1),teff1,massc(1),
     &                    radc(1),menv(1),renv(1),epoch(1),
     &                    ospin(1),deltam1_bcm,rrl1,kstar(2),mass0(2),
     &                    mass(2),lumin(2),rad(2),teff2,massc(2),
     &                    radc(2),menv(2),renv(2),epoch(2),ospin(2),
     &                    deltam2_bcm,rrl2,tb,sep,ecc,b01_bcm,b02_bcm,
     &                    vk1_bcm,vk2_bcm,vsys_bcm,theta_bcm,
     &                    formation(1),formation(2),binstate,mergertype)
            if(isave) tsave = tsave + dtp
            if(output) write(*,*)'bcm1',kstar(1),kstar(2),mass(1),
     & mass(2),rad(1),rad(2),ospin(1),ospin(2),jspin(1)
*     & mass(2),rad(1),rad(2),ospin(1),ospin(2),B(1),B(2),jspin(1)
         endif
      endif
*
* If not interpolating set the next timestep.
*
      if(intpol.eq.0)then
*         WRITE(*,*)'you should see this to advance the time'
         if(output) write(*,*)'nxt t, prior:',tphys,dtm,dtmi(1),dtmi(2)
         dtm = MAX(1.0d-07*tphys,MIN(dtmi(1),dtmi(2)))
         dtm = MIN(dtm,tsave-tphys)
         if(output) write(*,*)'nxt t, after:',tphys,dtm,dtmi(1),dtmi(2)
         if(iter.eq.0) dtm0 = dtm
      endif
      if(sgl) goto 98
*
* Set j1 to the donor - the primary
* and j2 to the accretor - the secondary.
*
      if(intpol.eq.0)then
         if(rad(1)/rol(1).ge.rad(2)/rol(2))then
            j1 = 1
            j2 = 2
         else
            j1 = 2
            j2 = 1
         endif
      endif
*
* Test whether Roche lobe overflow has begun.
*
      if(rad(j1).gt.rol(j1))then
*
* Interpolate back until the primary is just filling its Roche lobe.
*
         if(rad(j1).ge.1.002d0*rol(j1))then
            if(intpol.eq.0) tphys00 = tphys
            intpol = intpol + 1
            if(iter.eq.0) goto 7
            if(inttry) goto 7
            if(intpol.ge.100)then
               WRITE(99,*)' INTPOL EXCEEDED ',mass1i,mass2i,tbi,ecci
               goto 140
            endif
            dr = rad(j1) - 1.001d0*rol(j1)
            if(ABS(rdot(j1)).lt.tiny.or.prec)then
               goto 7
            endif
            dtm = -dr/ABS(rdot(j1))
            if(ABS(tphys0-tphys).gt.tiny) dtm = MAX(dtm,tphys0-tphys)
            if(kstar(1).ne.kw1)then
               kstar(1) = kw1
               mass0(1) = mass00(1)
               epoch(1) = tphys - aj0(1)
            endif
            if(kstar(2).ne.kw2)then
               kstar(2) = kw2
               mass0(2) = mass00(2)
               epoch(2) = tphys - aj0(2)
            endif
            change = .false.
         else
*
* Enter Roche lobe overflow
*
            if(tphys.ge.tphysf) goto 140
            goto 7
         endif
      else
*
* Check if already interpolating.
*
         if(intpol.gt.0)then
            intpol = intpol + 1
            if(intpol.ge.80)then
               inttry = .true.
            endif
            if(ABS(rdot(j1)).lt.tiny)then
               prec = .true.
               dtm = 1.0d-07*tphys
            else
               dr = rad(j1) - 1.001d0*rol(j1)
               dtm = -dr/ABS(rdot(j1))
            endif
            if((tphys+dtm).ge.tphys00)then
*
* If this occurs then most likely the star is a high mass type 4
* where the radius can change very sharply or possibly there is a
* discontinuity in the radius as a function of time and HRDIAG
* needs to be checked!
*
               dtm = 0.5d0*(tphys00 - tphys0)
               dtm = MAX(dtm,1.0d-10)
               prec = .true.
            endif
            tphys0 = tphys
         endif
      endif
*
* Check for collision at periastron.
*
      pd = sep*(1.d0 - ecc)
      if(pd.lt.(rad(1)+rad(2)).and.intpol.eq.0) goto 130
*
* Go back for the next step or interpolation.
*
 98   continue
      if(tphys.ge.tphysf.and.intpol.eq.0) goto 140
      if(change)then
         change = .false.
         evolve_type = 2.d0
         rrl1 = rad(1)/rol(1)
         rrl2 = rad(2)/rol(2)
         CALL writebpp(jp,tphys,evolve_type,
     &                 mass(1),mass(2),kstar(1),kstar(2),sep,
     &                 tb,ecc,rrl1,rrl2,bkick,
     &                 aj(1),aj(2),tms(1),tms(2),
     &                 massc(1),massc(2),rad(1),rad(2))
         DO jj = 13,20
            bkick(jj) = 0.0
         ENDDO
      endif
*
      iter = iter + 1
*
      if(iter.ge.loop)then
         WRITE(99,*)' MAXIMUM ITER EXCEEDED ',mass1i,mass2i,tbi,ecci,
     & tphysf,id1_pass,id2_pass
         goto 140
      endif
      goto 5
*
* Set the nuclear timescale in years and slow-down factor.
*
 7    km0 = dtm0*1.0d+03/tb
      if(km0.lt.tiny) km0 = 0.5d0
*
* Force co-rotation of primary and orbit to ensure that the tides do not
* lead to unstable Roche (not currently used).
*
*     if(ospin(j1).gt.1.05d0*oorb)then
*        ospin(j1) = oorb
*        jspin(j1) = (k2str(j1)*rad(j1)*rad(j1)*(mass(j1)-massc(j1))+
*    &                k3*radc(j1)*radc(j1)*massc(j1))*ospin(j1)
*     endif
*
      if(ST_tide.gt.0)then
         sep = sep*(1-ecc)
         ecc = 0.d0
         tb = (sep/aursun)*SQRT(sep/(aursun*(mass(1)+mass(2))))
         oorb = twopi/tb
         jorb = (mass(1)*mass(2)/(mass(1)+mass(2)))*
     &          sqrt(1.d0-ecc*ecc)*sep*sep*oorb
* Note: this will modify pulsar spin period
         if(kstar(1).lt.13)then
            ospin(1) = oorb
            jspin(1) = (k2str(1)*rad(1)*rad(1)*(mass(1)-massc(1))+
     &                   k3*radc(1)*radc(1)*massc(1))*ospin(1)
         endif
         if(kstar(2).lt.13)then
            ospin(2) = oorb
            jspin(2) = (k2str(2)*rad(2)*rad(2)*(mass(2)-massc(2))+
     &                   k3*radc(2)*radc(2)*massc(2))*ospin(2)
         endif
         km0 = dtm0*1.0d+03/tb
         if(km0.lt.tiny) km0 = 0.5d0
         rol(1) = rl(q(1))*sep !okay like this 'cos sep is peri. dist.
         rol(2) = rl(q(2))*sep
      endif
      iter = 0
      coel = .false.
      change = .false.
      radx(j1) = MAX(radc(j1),rol(j1))
      radx(j2) = rad(j2)
*
      evolve_type = 3.0
      rrl1 = rad(1)/rol(1)
      rrl2 = rad(2)/rol(2)
      CALL writebpp(jp,tphys,evolve_type,
     &              mass(1),mass(2),kstar(1),kstar(2),sep,
     &              tb,ecc,rrl1,rrl2,bkick,
     &              aj(1),aj(2),tms(1),tms(2),
     &              massc(1),massc(2),rad(1),rad(2))
      DO jj = 13,20
         bkick(jj) = 0.0
      ENDDO
*
      if(iplot.and.tphys.gt.tiny)then
          if(B_0(1).eq.0.d0)then !PK.
              b01_bcm = 0.d0
          elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
              b01_bcm = B_0(1)
          else
              b01_bcm = B(1)
          endif
          if(B_0(2).eq.0.d0)then
              b02_bcm = 0.d0
          elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
              b02_bcm = B_0(2)
          else
              b02_bcm = B(2)
          endif
          teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
          teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
          rrl1 = rad(1)/rol(1)
          rrl2 = rad(2)/rol(2)
          deltam1_bcm = 0.0
          deltam2_bcm = 0.0
* Check if PISN occurred, and if so overwrite formation
          if(pisn_track(1).ne.0) formation(1) = pisn_track(1)
          if(pisn_track(2).ne.0) formation(2) = pisn_track(2)
          CALL writebcm(ip,tphys,kstar(1),mass0(1),mass(1),
     &                  lumin(1),rad(1),teff1,massc(1),
     &                  radc(1),menv(1),renv(1),epoch(1),
     &                  ospin(1),deltam1_bcm,rrl1,kstar(2),mass0(2),
     &                  mass(2),lumin(2),rad(2),teff2,massc(2),
     &                  radc(2),menv(2),renv(2),epoch(2),ospin(2),
     &                  deltam2_bcm,rrl2,tb,sep,ecc,b01_bcm,b02_bcm,
     &                  vk1_bcm,vk2_bcm,vsys_bcm,theta_bcm,
     &                  formation(1),formation(2),binstate,mergertype)
         if(output) write(*,*)'bcm2:',kstar(1),kstar(2),mass(1),
     & mass(2),rad(1),rad(2),ospin(1),ospin(2),jspin(1)
*     & mass(2),rad(1),rad(2),ospin(1),ospin(2),B(1),B(2),jspin(1)
      endif
*
* Eddington limit for accretion on to the secondary in one orbit.
*
 8    dme = 2.08d-03*eddfac*(1.d0/(1.d0 + zpars(11)))*rad(j2)*tb
      supedd = .false.
      novae = .false.
      disk = .false.
*
* Determine whether the transferred material forms an accretion
* disk around the secondary or hits the secondary in a direct
* stream, by using eq.(1) of Ulrich & Burger (1976, ApJ, 206, 509)
* fitted to the calculations of Lubow & Shu (1974, ApJ, 198, 383).
*
*     if(kstar(j2).ge.10) disk = .true.
      rmin = 0.0425d0*sep*(q(j2)*(1.d0+q(j2)))**(1.d0/4.d0)
      if(rmin.gt.rad(j2)) disk = .true.
*
* Kelvin-Helmholtz time from the modified classical expression.
*
      do 13 , k = 1,2
         tkh(k) = 1.0d+07*mass(k)/(rad(k)*lumin(k))
         if(kstar(k).le.1.or.kstar(k).eq.7.or.kstar(k).ge.10)then
            tkh(k) = tkh(k)*mass(k)
         else
            tkh(k) = tkh(k)*(mass(k) - massc(k))
         endif
 13   continue
*
* Dynamical timescale for the primary.
*
      tdyn = 5.05d-05*SQRT(rad(j1)**3/mass(j1))

*
* Set default qcrit values and identify special cases.
*

      if(qcflag.eq.0)then
*
* Use the BSE equations and defaults:
* If q1 = m_donor/m_acc > qc then common envelope
*

         if(kstar(j1).eq.0)then
            qc = 0.695
         elseif(kstar(j1).eq.1)then
            qc = 3.d0
         elseif(kstar(j1).eq.2)then
            qc = 4.d0
         elseif(kstar(j1).eq.3)then
            qc = (1.67d0-zpars(7)+2.d0*(massc(j1)/mass(j1))**5)/2.13d0
         elseif(kstar(j1).eq.4)then
            qc = 3.d0
         elseif(kstar(j1).eq.5)then
            qc = (1.67d0-zpars(7)+2.d0*(massc(j1)/mass(j1))**5)/2.13d0
         elseif(kstar(j1).eq.6)then
            qc = (1.67d0-zpars(7)+2.d0*(massc(j1)/mass(j1))**5)/2.13d0
         elseif(kstar(j1).eq.7)then
            qc = 3.0d0
         elseif(kstar(j1).eq.8)then
            qc = 0.784d0
         elseif(kstar(j1).eq.9)then
            qc = 0.784d0
         elseif(kstar(j1).ge.10)then
            qc = 0.628
         endif
      elseif(qcflag.eq.1)then
*
* Use the BSE equations and Hjellming & Webbink, 1987, ApJ, 318, 794.
* for the GB/AGB:
* If q1 = m_donor/m_acc > qc then common envelope
*
         if(kstar(j1).eq.0)then
            qc = 0.695
         elseif(kstar(j1).eq.1)then
            qc = 3.d0
         elseif(kstar(j1).eq.2)then
            qc = 4.d0
         elseif(kstar(j1).eq.3)then
            qc = 0.362 + 1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
         elseif(kstar(j1).eq.4)then
            qc = 3.d0
         elseif(kstar(j1).eq.5)then
            qc = 0.362 + 1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
         elseif(kstar(j1).eq.6)then
            qc = 0.362 + 1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
         elseif(kstar(j1).eq.7)then
            qc = 3.0d0
         elseif(kstar(j1).eq.8)then
            qc = 0.784d0
         elseif(kstar(j1).eq.9)then
            qc = 0.784d0
         elseif(kstar(j1).ge.10)then
            qc = 0.628
         endif

      elseif(qcflag.eq.2)then
*
* Use the binary_c prescriptions taken from Claeys+2014 Table 2
* If q1 = m_donor/m_acc > qc then common envelope
*
         if(kstar(j2).lt.10)then
             if(kstar(j1).eq.0)then
                qc = 0.695
             elseif(kstar(j1).eq.1)then
                qc = 1.6d0
             elseif(kstar(j1).eq.2)then
                qc = 4.d0
             elseif(kstar(j1).eq.3)then
               qc = (1.67d0-zpars(7)+
     &               2.d0*(massc(j1)/mass(j1))**5)/2.13d0
             elseif(kstar(j1).eq.4)then
                qc = 3.d0
             elseif(kstar(j1).eq.5)then
               qc = (1.67d0-zpars(7)+
     &               2.d0*(massc(j1)/mass(j1))**5)/2.13d0
             elseif(kstar(j1).eq.6)then
               qc = (1.67d0-zpars(7)+
     &               2.d0*(massc(j1)/mass(j1))**5)/2.13d0
             elseif(kstar(j1).eq.7)then
                qc = 3.0d0
             elseif(kstar(j1).eq.8)then
                qc = 4.0d0
             elseif(kstar(j1).eq.9)then
                qc = 0.784d0
             elseif(kstar(j1).ge.10)then
                qc = 3.0d0
             endif
         elseif(kstar(j2).ge.10)then
             if(kstar(j1).eq.0)then
                qc = 1.0d0
             elseif(kstar(j1).eq.1)then
                qc = 1.0d0
             elseif(kstar(j1).eq.2)then
                qc = 4.7619d0
             elseif(kstar(j1).eq.3)then
                qc = 1.15d0
             elseif(kstar(j1).eq.4)then
                qc = 3.d0
             elseif(kstar(j1).eq.5)then
                qc = 1.15d0
             elseif(kstar(j1).eq.6)then
                qc = 1.15d0
             elseif(kstar(j1).eq.7)then
                qc = 3.0d0
             elseif(kstar(j1).eq.8)then
               qc = 4.7619d0
             elseif(kstar(j1).eq.9)then
                qc = 1.15d0
             elseif(kstar(j1).ge.10)then
                qc = 0.625d0
             endif
         endif
      elseif(qcflag.eq.3)then
*
* Use the binary_c prescriptions taken from Claeys+2014 Table 2
* but w/ Hjellming & Webbing for GB/AGB
* If q1 = m_donor/m_acc > qc then common envelope
*
         if(kstar(j2).lt.10)then
             if(kstar(j1).eq.0)then
                qc = 0.695
             elseif(kstar(j1).eq.1)then
                qc = 1.6d0
             elseif(kstar(j1).eq.2)then
                qc = 4.d0
             elseif(kstar(j1).eq.3)then
               qc = 0.362 +
     &              1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
             elseif(kstar(j1).eq.4)then
                qc = 3.d0
             elseif(kstar(j1).eq.5)then
               qc = 0.362 +
     &              1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
             elseif(kstar(j1).eq.6)then
               qc = 0.362 +
     &              1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
             elseif(kstar(j1).eq.7)then
                qc = 3.0d0
             elseif(kstar(j1).eq.8)then
                qc = 4.0d0
             elseif(kstar(j1).eq.9)then
                qc = 0.784d0
             elseif(kstar(j1).ge.10)then
                qc = 3.0d0
             endif
         elseif(kstar(j2).ge.10)then
             if(kstar(j1).eq.0)then
                qc = 1.0d0
             elseif(kstar(j1).eq.1)then
                qc = 1.0d0
             elseif(kstar(j1).eq.2)then
                qc = 4.7619d0
             elseif(kstar(j1).eq.3)then
                qc = 1.15d0
             elseif(kstar(j1).eq.4)then
                qc = 3.d0
             elseif(kstar(j1).eq.5)then
                qc = 1.15d0
             elseif(kstar(j1).eq.6)then
                qc = 1.15d0
             elseif(kstar(j1).eq.7)then
                qc = 3.0d0
             elseif(kstar(j1).eq.8)then
               qc = 4.7619d0
             elseif(kstar(j1).eq.9)then
                qc = 1.15d0
             elseif(kstar(j1).ge.10)then
                qc = 0.625d0
             endif
         endif
      elseif(qcflag.eq.4)then
*
* Use the StarTrack prescriptions taken from Belczynski+2008
* section 5.1
* If q1 = m_donor/m_acc > qc then common envelope
*
* Note: this does not do the WD mass ratios exactly the same.
* We do the standard 0.628 mass ratio from BSE since we don't
* compute the mass transfer rates the same
         if(kstar(j1).eq.0)then
            qc = 3.d0
         elseif(kstar(j1).eq.1)then
            qc = 3.d0
         elseif(kstar(j1).eq.2)then
            qc = 3.d0
         elseif(kstar(j1).eq.3)then
            qc = 3.d0
         elseif(kstar(j1).eq.4)then
            qc = 3.d0
         elseif(kstar(j1).eq.5)then
            qc = 3.d0 
         elseif(kstar(j1).eq.6)then
            qc = 3.d0 
         elseif(kstar(j1).eq.7)then
            qc = 1.7d0
         elseif(kstar(j1).eq.8)then
            qc = 3.5
         elseif(kstar(j1).eq.9)then
            qc = 3.5
         elseif(kstar(j1).ge.10)then
            qc = 0.628
         endif
      endif
*
* Allow for manually overriding qcrit values with fixed
* values supplied from ini file.
*
      qc_fixed = qcrit_array(kstar(j1)+1)
      if(qc_fixed.ne.0)then
         qc = qc_fixed
      endif

      if(kstar(j1).eq.0.and.q(j1).gt.qc)then
*
* This will be dynamical mass transfer of a similar nature to
* common-envelope evolution.  The result is always a single
* star placed in *2.
*
         CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
         taum = SQRT(tkh(j1)*tdyn)
         dm1 = mass(j1)
         if(kstar(j2).le.1)then
*
* Restrict accretion to thermal timescale of secondary.
*
            dm2 = taum/tkh(j2)*dm1
            mass(j2) = mass(j2) + dm2
*
* Rejuvenate if the star is still on the main sequence.
*
            mass0(j2) = mass(j2)
            CALL star(kstar(j2),mass0(j2),mass(j2),tmsnew,tn,
     &                tscls,lums,GB,zpars)
* If the star has no convective core then the effective age decreases,
* otherwise it will become younger still.
            if(mass(j2).lt.0.35d0.or.mass(j2).gt.1.25d0)then
               aj(j2) = tmsnew/tms(j2)*aj(j2)*(mass(j2) - dm2)/mass(j2)
            else
               aj(j2) = tmsnew/tms(j2)*aj(j2)
            endif
            epoch(j2) = tphys - aj(j2)
         elseif(kstar(j2).le.6)then
*
* Add all the material to the giant's envelope.
*
            dm2 = dm1
            mass(j2) = mass(j2) + dm2
            if(kstar(j2).eq.2)then
               mass0(j2) = mass(j2)
               CALL star(kstar(j2),mass0(j2),mass(j2),tmsnew,tn,tscls,
     &                   lums,GB,zpars)
               aj(j2) = tmsnew + tscls(1)*(aj(j2)-tms(j2))/tbgb(j2)
               epoch(j2) = tphys - aj(j2)
            endif
         elseif(kstar(j2).le.12)then
*
* Form a new giant envelope.
*
            dm2 = dm1
            kst = ktype(kstar(j1),kstar(j2))
            if(kst.gt.100) kst = kst - 100
            if(kst.eq.4)then
               aj(j2) = aj(j2)/tms(j2)
               massc(j2) = mass(j2)
            endif
*
* Check for planets or low-mass WDs.
*
            if((kstar(j2).eq.10.and.mass(j2).lt.0.05d0).or.
     &         (kstar(j2).ge.11.and.mass(j2).lt.0.1d0))then
               kst = kstar(j1)
               mass(j1) = mass(j2) + dm2
               mass(j2) = 0.d0
            else
               mass(j2) = mass(j2) + dm2
               CALL gntage(massc(j2),mass(j2),kst,zpars,
     &                     mass0(j2),aj(j2))
               epoch(j2) = tphys - aj(j2)
            endif
            kstar(j2) = kst
         else
*
* The neutron star or black hole simply accretes at the Eddington rate.
*
            dm2 = MIN(dme*taum/tb,dm1)
            if(dm2.lt.dm1) supedd = .true.
            mass(j2) = mass(j2) + dm2
         endif
         coel = .true.
         binstate = 1
         if(mass(j2).gt.0.d0)then
            mass(j1) = 0.d0
            kstar(j1) = 15
         else
            kstar(j1) = kstar(j2)
            kstar(j2) = 15
         endif
         goto 135
      elseif(((ABS(ABS(2*kstar(j1)-11)-3).eq.2.or.kstar(j1).eq.9)
     &        .and.(q(j1).gt.qc.or.radx(j1).le.radc(j1))).or.
     &        (kstar(j1).eq.2.and.q(j1).gt.qc).or.
     &        (kstar(j1).eq.4.and.q(j1).gt.qc))then

*
* Common-envelope evolution.
*
         m1ce = mass(j1)
         m2ce = mass(j2)
         kcomp1 = kstar(j1) !PDK
         kcomp2 = kstar(j2)
         if(j1.eq.2)then
             switchedCE = .true.
         else
             switchedCE = .false.
         endif
         evolve_type = 7.d0
         CALL writebpp(jp,tphys,evolve_type,
     &                 mass(1),mass(2),
     &                 kstar(1),kstar(2),sep,
     &                 tb,ecc,rrl1,rrl2,bkick,
     &                 aj(1),aj(2),tms(1),tms(2),
     &                 massc(1),massc(2),rad(1),rad(2))

         CALL comenv(mass0(j1),mass(j1),massc(j1),aj(j1),jspin(j1),
     &               kstar(j1),mass0(j2),mass(j2),massc(j2),aj(j2),
     &               jspin(j2),kstar(j2),zpars,ecc,sep,jorb,coel,j1,j2,
     &               vk,bkick,formation(j1),formation(j2),
     &               bhspin(j1),bhspin(j2),binstate,mergertype,
     &               jp,tphys,switchedCE,rad,tms,evolve_type,disrupt)
         if(binstate.eq.1.d0)then
             sep = 0.d0
             tb = 0.d0
         elseif(binstate.eq.2.d0)then
             sep = -1.d0
             tb = -1.d0
         endif
         if(j1.eq.2.and.kcomp2.eq.13.and.kstar(j2).eq.15.and.
     &      kstar(j1).eq.13)then !PK.
* In CE the NS got switched around. Do same to formation.
            formation(j1) = formation(j2)
            bkick(1) = 3-bkick(1)
         endif
         if(j1.eq.1.and.kcomp2.eq.13.and.kstar(j2).eq.15.and.
     &      kstar(j1).eq.13)then !PK.
* In CE the NS got switched around. Do same to formation.
            formation(j1) = formation(j2)
            bkick(1) = 3-bkick(1)
         endif

* set kick values for the bcm array
         if(bkick(13).gt.0.d0)then
             vk1_bcm=bkick(13)
         endif
         if(bkick(14).gt.0.d0)then
             vk2_bcm=bkick(14)
         endif
         if(bkick(17).gt.0.d0)then
             vsys_bcm=bkick(17)
         endif
         if(bkick(20).gt.0.d0)then
             theta_bcm=bkick(20)
         endif
*
         evolve_type = 8.0
         mass1_bpp = mass(1)
         mass2_bpp = mass(2)
         if(kstar(1).eq.15) mass1_bpp = mass0(1)
         if(kstar(2).eq.15) mass2_bpp = mass0(2)
         rrl1 = rad(1)/rol(1)
         rrl2 = rad(2)/rol(2)
         CALL writebpp(jp,tphys,evolve_type,
     &                 mass1_bpp,mass2_bpp,
     &                 kstar(1),kstar(2),sep,
     &                 tb,ecc,rrl1,rrl2,bkick,
     &                 aj(1),aj(2),tms(1),tms(2),
     &                 massc(1),massc(2),rad(1),rad(2))
         DO jj = 13,20
            bkick(jj) = 0.0
         ENDDO
*
         epoch(j1) = tphys - aj(j1)
         if(coel)then
            com = .true.
            goto 135
         endif
         epoch(j2) = tphys - aj(j2)
         if(ecc.gt.1.d0)then
            if(kstar(1).ge.13)then
               rc = corerd(kstar(1),mass(1),mass(1),zpars(2))
               ospin(1) = jspin(1)/(k3*rc*rc*mass(1))
            endif
            if(kstar(2).ge.13)then
               rc = corerd(kstar(2),mass(2),mass(2),zpars(2))
               ospin(2) = jspin(2)/(k3*rc*rc*mass(2))
            endif
            goto 135
         endif
*
* Next step should be made without changing the time.
*
         dm1 = m1ce - mass(j1)
         dm2 = mass(j2) - m2ce
         dm22 = dm2
         dtm = 0.d0
*
* Reset orbital parameters as separation may have changed.
*
         tb = (sep/aursun)*SQRT(sep/(aursun*(mass(1)+mass(2))))
         oorb = twopi/tb
      elseif(kstar(j1).ge.10.and.kstar(j1).le.12.and.
     &       q(j1).gt.qc)then
*
* Dynamic transfer from a white dwarf.  Secondary will have KW > 9.
*
         CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
         taum = SQRT(tkh(j1)*tdyn)
         dm1 = mass(j1)
         if(eddfac.lt.10.d0)then
            dm2 = MIN(dme*taum/tb,dm1)
            if(dm2.lt.dm1) supedd = .true.
         else
            dm2 = dm1
         endif
         mass(j2) = mass(j2) + dm2
*
         if(kstar(j1).eq.10.and.kstar(j2).eq.10)then
*
* Assume the energy released by ignition of the triple-alpha reaction
* is enough to destroy the star.
*
            kstar(j2) = 15
            mass(j2) = 0.d0
         elseif(kstar(j1).eq.10.or.kstar(j2).gt.10)then
*
* Should be helium overflowing onto a CO or ONe core in which case the
* helium swells up to form a giant envelope so a HeGB star is formed.
* Allowance for the rare case of CO or ONe flowing onto He is made.
*
            kst = 9
            if(kstar(j2).eq.10) massc(j2) = dm2
            CALL gntage(massc(j2),mass(j2),kst,zpars,mass0(j2),aj(j2))
            kstar(j2) = kst
            epoch(j2) = tphys - aj(j2)
         elseif(kstar(j2).le.12)then
            mass0(j2) = mass(j2)
            if(kstar(j1).eq.12.and.kstar(j2).eq.11)then
*
* Mixture of ONe and CO will result in an ONe product.
*
               kstar(j2) = 12
            endif
            if(kstar(j1).eq.11.and.kstar(j2).eq.11)then !PK.
*
* Following Startrack of merger of two CO will result in an ONe or NS product
* (depending upon mass, if kstar = 12 and mass > Mecsn then hrdiag will update
* accordingly).
*
               kstar(j2) = 12
            endif
            formation(j2) = 11
         endif
         kstar(j1) = 15
         mass(j1) = 0.d0
*
* Might be a supernova that destroys the system.
*
         if(kstar(j2).le.11.and.mass(j2).gt.mch)then
            kstar(j2) = 15
            mass(j2) = 0.d0
         endif
         coel = .true.
         binstate = 1
         goto 135
      elseif(kstar(j1).eq.13)then
*
* Gamma ray burster?
*
         CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
         dm1 = mass(j1)
         mass(j1) = 0.d0
         kstar(j1) = 15
         dm2 = dm1
         mass(j2) = mass(j2) + dm2
         kstar(j2) = 14
         coel = .true.
         binstate = 1
         goto 135
      elseif(kstar(j1).eq.14)then
*
* Both stars are black holes.  Let them merge quietly.
*
         CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
         dm1 = mass(j1)
         mass(j1) = 0.d0
         kstar(j1) = 15
         dm2 = dm1
         mass(j2) = mass(j2) + dm2
         coel = .true.
         binstate = 1
         goto 135
      else
*
* Mass transfer in one Kepler orbit.
*
*
* KB: adding in stable mass transfer factor from
*     eqs 10-11 of Claeys+2014
*
         if(qcflag.gt.1.and.qcflag.le.3)then
            if(q(j1).gt.1)then
               f_fac=1000.d0
            else
               f_fac=1000*q(j1)*
     &               EXP(-0.5d0*(-LOG(q(j1))/0.15d0)**2)
               if(f_fac.lt.1)then
                  f_fac=1
               endif
            endif
            dm1 = f_fac*3.0d-06*tb*(LOG(rad(j1)/rol(j1))**3)*
     &            MIN(mass(j1),5.d0)**2
         else
            dm1 = 3.0d-06*tb*(LOG(rad(j1)/rol(j1))**3)*
     &            MIN(mass(j1),5.d0)**2
         endif
         if(kstar(j1).eq.2)then
            mew = (mass(j1) - massc(j1))/mass(j1)
            dm1 = MAX(mew,0.01d0)*dm1
         elseif(kstar(j1).ge.10)then
*           dm1 = dm1*1.0d+03/MAX(rad(j1),1.0d-04)
            dm1 = dm1*1.0d+03*mass(j1)/MAX(rad(j1),1.0d-04)
         endif
         kst = kstar(j2)
*
* Possibly mass transfer needs to be reduced if primary is rotating
* faster than the orbit (not currently implemented).
*
*        spnfac = MIN(3.d0,MAX(ospin(j1)/oorb,1.d0))
*        dm1 = dm1/spnfac**2
*
* Limit mass transfer to the thermal rate for remaining giant-like stars
* and to the dynamical rate for all others.
*
         if(kstar(j1).ge.2.and.kstar(j1).le.9.and.kstar(j1).ne.7)then
***
* JH_temp ... this may be good for HG RLOF??
*           if(kstar(j1).eq.2)then
*              mew = rad(j1)/rol(j1) - 1.d0
*              mew = 2.d0*mew
*              dm1 = dm1*10.d0**mew
*           endif
***
            dm1 = MIN(dm1,mass(j1)*tb/tkh(j1))
         elseif(rad(j1).gt.10.d0*rol(j1).or.(kstar(j1).le.1.and.
     &          kstar(j2).le.1.and.q(j1).gt.qc))then
*
* Allow the stars to merge with the product in *1.
*
            CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
            m1ce = mass(j1)
            m2ce = mass(j2)
            if((kstar(1).ge.10.and.kstar(1).le.12).and.
     &         (kstar(2).ge.10.and.kstar(2).le.12))then
               formation(1) = 11
               formation(2) = 11
            endif
            CALL mix(mass0,mass,aj,kstar,zpars,bhspin)
            dm1 = m1ce - mass(j1)
            dm2 = mass(j2) - m2ce
*
* Next step should be made without changing the time.
*
            dtm = 0.d0
            epoch(1) = tphys - aj(1)
            coel = .true.
            binstate = 1
            goto 135
         else
            dm1 = MIN(dm1,mass(j1)*tb/tdyn)
         endif
*
* Calculate wind mass loss from the stars during one orbit.
*
         vorb2 = acc1*(mass(1)+mass(2))/sep
         ivsqm = 1.d0/SQRT(1.d0-ecc*ecc)
         do 14 , k = 1,2
            if(neta.gt.tiny)then
               if(beta.lt.0.d0)then !PK. following startrack
                  beta = 0.125
                  if(kstar(k).le.1)then
                     if(mass(k).gt.120.d0)then
                        beta = 7.d0
                     elseif(mass(k).le.1.4d0)then
                        beta = 0.5
                     else
                        beta = 7.d0*((mass(k)-1.4d0)/(120.d0-1.4d0))
     &                         + 0.5d0
                     endif
                  elseif(kstar(k).ge.7.and.kstar(k).le.9)then
                     if(mass(k).gt.120.d0)then
                        beta = 7.d0
                     elseif(mass(k).le.10.d0)then
                        beta = 0.125
                     else
                        beta = 7.d0*((mass(k)-10.d0)/(120.d0-10.d0))
     &                               + 0.125d0
                     endif
                  endif
               endif
               rlperi = rol(k)*(1.d0-ecc)
               dmr(k) = mlwind(kstar(k),lumin(k),radx(k),
     &                         mass(k),massc(k),rlperi,z)
               vwind2 = 2.d0*beta*acc1*mass(k)/radx(k)
               omv2 = (1.d0 + vorb2/vwind2)**(3.d0/2.d0)
               dmt(3-k) = ivsqm*acc2*dmr(k)*((acc1*mass(3-k)/vwind2)**2)
     &                    /(2.d0*sep*sep*omv2)
               dmt(3-k) = MIN(dmt(3-k),dmr(k))
               beta = betahold
            else
               dmr(k) = 0.d0
               dmt(3-k) = 0.d0
            endif
 14      continue
*
         do 15 , k = 1,2
            dms(k) = (dmr(k)-dmt(k))*tb
 15      continue
*
* Increase time-scale to relative mass loss of 0.5% but not more than twice.
* KM is the number of orbits for the timestep.
*
         km = MIN(2.d0*km0,5.0d-03/
     &            MAX(ABS(dm1+dms(j1))/mass(j1),dms(j2)/mass(j2)))
         km0 = km
*
*       Modify time-step & mass loss terms by speed-up factor.
*
         dt = km*tb
         dtm = dt/1.0d+06
*
* Take the stellar evolution timestep into account but don't let it
* be overly restrictive for long lived phases.
*
         if(iter.le.1000) dtm = MIN(dtm,dtmi(1),dtmi(2))
         dtm = MIN(dtm,tsave-tphys)
         dt = dtm*1.0d+06
         km = dt/tb
*
* Decide between accreted mass by secondary and/or system mass loss.
*
         taum = mass(j2)/dm1*tb
         if(kstar(j2).le.2.or.kstar(j2).eq.4)then
*
* Limit according to the thermal timescale of the secondary.
*
            dm2 = MIN(1.d0,10.d0*taum/tkh(j2))*dm1
         elseif(kstar(j2).ge.7.and.kstar(j2).le.9)then
*
* Naked helium star secondary swells up to a core helium burning star
* or SAGB star unless the primary is also a helium star.
*
            if(kstar(j1).ge.7)then
               dm2 = MIN(1.d0,10.d0*taum/tkh(j2))*dm1
            else
               dm2 = dm1
               dmchk = dm2 - 1.05d0*dms(j2)
               if(dmchk.gt.0.d0.and.dm2/mass(j2).gt.1.0d-04)then
                  kst = MIN(6,2*kstar(j2)-10)
                  if(kst.eq.4)then
                     aj(j2) = aj(j2)/tms(j2)
                     mcx = mass(j2)
                  else
                     mcx = massc(j2)
                  endif
                  mt2 = mass(j2) + km*(dm2 - dms(j2))
                  CALL gntage(mcx,mt2,kst,zpars,mass0(j2),aj(j2))
                  epoch(j2) = tphys + dtm - aj(j2)
               endif
            endif
         elseif(kstar(j1).le.6.and.
     &           (kstar(j2).ge.10.and.kstar(j2).le.12))then
*
* White dwarf secondary.
*
            if(dm1/tb.lt.2.71d-07)then
               if(dm1/tb.lt.1.03d-07)then
*
* Accrete until a nova explosion blows away most of the accreted material.
*
                  novae = .true.
                  dm2 = MIN(dm1,dme)
                  if(dm2.lt.dm1) supedd = .true.
                  dm22 = epsnov*dm2
               else
*
* Steady burning at the surface
*
                  dm2 = dm1
               endif
            else
*
* Make a new giant envelope.
*
               dm2 = dm1
*
* Check for planets or low-mass WDs.
*
               if((kstar(j2).eq.10.and.mass(j2).lt.0.05d0).or.
     &            (kstar(j2).ge.11.and.mass(j2).lt.0.5d0))then
                  kst = kstar(j2)
               else
                  kst = MIN(6,3*kstar(j2)-27)
                  mt2 = mass(j2) + km*(dm2 - dms(j2))
                  CALL gntage(massc(j2),mt2,kst,zpars,mass0(j2),aj(j2))
                  epoch(j2) = tphys + dtm - aj(j2)
*
                  DO jj = 13,20
                     bkick(jj) = 0.0
                  ENDDO
               endif
*
            endif
         elseif(kstar(j2).ge.10)then
*
* Impose the Eddington limit.
*
            dm2 = MIN(dm1,dme)
            if(dm2.lt.dm1) supedd = .true.
* Can add pulsar propeller evolution here if need be. PK.
*
*
         else
*
* We have a giant whose envelope can absorb any transferred material.
*
            dm2 = dm1
         endif
         if(.not.novae) dm22 = dm2
*
         if(kst.ge.10.and.kst.le.12)then
            mt2 = mass(j2) + km*(dm22 - dms(j2))
            if(kstar(j1).le.10.and.kst.eq.10.and.mt2.ge.0.7d0)then
*
* HeWD can only accrete helium-rich material up to a mass of 0.7 when
* it is destroyed in a possible Type 1a SN.
*
               mass(j1) = mass(j1) - km*(dm1 + dms(j1))
               mass(j2) = 0.d0
               kstar(j2) = 15
               goto 135
            elseif(kstar(j1).le.10.and.kst.ge.11)then
*
* CO and ONeWDs accrete helium-rich material until the accumulated
* material exceeds a mass of 0.15 when it ignites. For a COWD with
* mass less than 0.95 the system will be destroyed as an ELD in a
* possible Type 1a SN. COWDs with mass greater than 0.95 and ONeWDs
* will survive with all the material converted to ONe (JH 30/09/99).
*
** Now changed to an ELD for all COWDs when 0.15 accreted (JH 11/01/00).
*
               if((mt2-mass0(j2)).ge.0.15d0)then
                  if(kst.eq.11)then
                     mass(j1) = mass(j1) - km*(dm1 + dms(j1))
                     mass(j2) = 0.d0
                     kstar(j2) = 15
                     goto 135
                  endif
                  mass0(j2) = mt2
               endif
            else
               mass0(j2) = mt2
            endif
*
* If the Chandrasekhar limit is exceeded for a white dwarf then destroy
* the white dwarf in a supernova. If the WD is ONe then a neutron star
* will survive the supernova and we let HRDIAG take care of this when
* the stars are next updated.
*
            if(kst.eq.10.or.kst.eq.11)then
               if(mt2.ge.mch)then
                  dm1 = mch - mass(j2) + km*dms(j2)
                  mass(j1) = mass(j1) - dm1 - km*dms(j1)
                  mass(j2) = 0.d0
                  kstar(j2) = 15
                  goto 135
               endif
            endif
         endif
*
*       Modify mass loss terms by speed-up factor.
*
         dm1 = km*dm1
         dm2 = km*dm2
         dm22 = km*dm22
         dme = km*dme
*
* Calculate orbital angular momentum change due to system mass loss.
*
         djorb = ((dmr(1)+q(1)*dmt(1))*mass(2)*mass(2) +
     &            (dmr(2)+q(2)*dmt(2))*mass(1)*mass(1))/
     &           (mass(1)+mass(2))**2
         djorb = djorb*dt
*
* For super-Eddington mass transfer rates, for gamma = -2.0,
* and for novae systems, assume that material is lost from
* the system as if a wind from the secondary.
* If gamma = -1.0 then assume the lost material carries with it
* the specific angular momentum of the primary and for all
* gamma > 0.0 assume that it takes away a fraction gamma of
* the orbital angular momentum.
*
         if(supedd.or.novae.or.gamma.lt.-1.5d0)then
            djorb = djorb + (dm1 - dm22)*mass(j1)*mass(j1)/
     &              (mass(1)+mass(2))**2
         elseif(gamma.ge.0.d0)then
            djorb = djorb + gamma*(dm1 - dm2)
         else
            djorb = djorb + (dm1 - dm2)*mass(j2)*mass(j2)/
     &              (mass(1)+mass(2))**2
         endif
*
         ecc2 = ecc*ecc
         omecc2 = 1.d0 - ecc2
         sqome2 = SQRT(omecc2)
*
         djorb = djorb*sep*sep*sqome2*oorb
         delet = 0.d0
*
* For very close systems include angular momentum loss mechanisms.
*
         if(sep.le.100000.d0)then
            djgr = 8.315d-10*mass(1)*mass(2)*(mass(1)+mass(2))/
     &             (sep*sep*sep*sep)
            f1 = (19.d0/6.d0) + (121.d0/96.d0)*ecc2
            sqome5 = sqome2**5
            delet1 = djgr*ecc*f1/sqome5
            djgr = djgr*jorb*(1.d0+0.875d0*ecc2)/sqome5
            djorb = djorb + djgr*dt
            delet = delet + delet1*dt
         endif
*
         do 602 , k = 1,2
*
            dms(k) = km*dms(k)
            if(kstar(k).lt.10) dms(k) = MIN(dms(k),mass(k) - massc(k))
*
* Calculate change in the intrinsic spin of the star.
*
* Spin up via wind accretion. NSs are allowed to vary the angular momentum accretion efficiency. PK.
            if(kstar(k).eq.13.and.xip.eq.1.and.pulsar.gt.0)then
               if(B(k).gt.0.d0)then
                  xi = MIN(1.d0,(0.01d0*(2.0d+11/B(k)))+0.01d0)
                  xi = 0.01
               else
                  xi = 0.01
               endif
            else
               xi = xihold
            endif
            djspint(k) = (2.d0/3.d0)*(dmr(k)*radx(k)*radx(k)*ospin(k) -
     &                   xi*dmt(k)*radx(3-k)*radx(3-k)*ospin(3-k))
            djspint(k) = djspint(k)*dt
*
* Evaluate convective/radiative limits for a variety of stars as based
* on the work of Belczynski et al. (2008). As option.
* Note only certain stars of type k = 0, 1, 2, 4, 5, 6, 9 **double check
* 0, 1 have range of 0.35-Mms,conv. Mms,conv is function of metalicity.
* 2 & 4 have a temperature dependence. Convective if Teff < 10**3.73
* 3, 5 & 6 are giants and have no radiative envelopes.
* 9's envelope is convective when M < Mhe,conv, Mhe,conv = 3.0Msun.
*
            if(ST_cr.le.0)then
               if(kstar(k).le.1)then
                  convradcomp(k) = 1.25d0
               else
                  convradcomp(k) = 9999999999.d0 !doesn't work well with startrack_tide = .false.
               endif
            else
               if(kstar(k).le.1)then
*                 Main sequence mass limit varying with metallicity
                  convradcomp(k) = 1.25d0
                  if(z.gt.0.001d0.and.z.lt.0.02d0)then
                     convradcomp(k) = 0.747d0 + 55.73d0*z - 1532*z*z
                  elseif(z.le.0.001d0)then
                     convradcomp(k) = 0.8d0
                  endif
               elseif(kstar(k).eq.2.or.kstar(k).eq.4)then
*                 H-rich HG and CHeB temperature limit
                  convradcomp(k) = 10.d0**3.73d0
               elseif(kstar(k).le.6)then
*                 No limit or all other giant stars
*                 (compare this large value to mass).
                  convradcomp(k) = 9999999999.d0
               elseif(kstar(k).eq.9)then
*                 Mass limit for evolved He star
                  convradcomp(k) = 3.d0
               endif
            endif
*
*            if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
*               djmb = 5.83d-16*menv(k)*(rad(k)*ospin(k))**3/mass(k)
*               djspint(k) = djspint(k) + djmb*dt
*            if(mass(k).gt.0.35d0.and.kstar(k).lt.10.and.
*     &              menv(k).gt.0.0d0)then
*                if (ospin(k) .le. wx) djmb = kw3 * rad(k)**4.0d0 *
*     &              (ospin(k)/wsun)**3.0d0
*                if (ospin(k) .gt. wx) djmb = kw3 * rad(k)**4.0d0 *
*     &             (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
*                djspint(k) = djspint(k) + djmb
*            endif
* MB
            djmb = 0.d0
            if(htpmb.eq.0)then
* HTP02 method
               if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
                  djmb = 5.83d-16*menv(k)*(rad(k)*ospin(k))**3/mass(k)
                  djspint(k) = djspint(k) + djmb*dt
               endif
            else
               if(ST_cr.le.0.and.
     &            (mass(k).gt.0.35d0.and.kstar(k).lt.10.and.
     &            menv(k).gt.0.0d0))then
* Ivanova & Taam (2003)
                   if (ospin(k).le.wx) djmb = kw3 * rad(k)**4.0d0 *
     &                 (ospin(k)/wsun)**3.0d0
                   if (ospin(k).gt.wx) djmb = kw3 * rad(k)**4.0d0 *
     &                (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
                   djspint(k) = djspint(k) + djmb
               elseif(ST_cr.gt.0.and.(menv(k).gt.0.d0.and.
     &            ((kstar(k).le.1.and.mass(k).gt.0.35d0.and.
     &              mass(k).le.convradcomp(k)).or.
     &              (kstar(k).eq.2.and.teff(k).le.convradcomp(k)).or.
     &              (kstar(k).eq.4.and.teff(k).le.convradcomp(k)).or.
     &              ((kstar(k).eq.3).or.(kstar(k).eq.5).or.
     &              (kstar(k).eq.6)))))then
* MB given in Ivanova & Taam (2003)
*            if(mass(k).gt.0.35d0.and.kstar(k).lt.10.and.
*     &              menv(k).gt.0.0d0)then
                  if(ospin(k).le.wx) djmb = kw3 * rad(k)**4.0d0 *
     &                (ospin(k)/wsun)**3.0d0
                  if(ospin(k).gt.wx) djmb = kw3 * rad(k)**4.0d0 *
     &               (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
                  djspint(k) = djspint(k) + djmb
               endif
            endif
            if(kstar(k).eq.13.and.pulsar.gt.0)then
               if(bdecayfac.eq.0)then
                  if(B_0(k).eq.0.d0)then
                     B(k) = 0.d0
                  elseif((tphys-epoch(k)-tacc(k)).le.tiny)then
                     B(k) = B_0(k)*exp(CK*bacc(k)) + Bbot
                  else
                     B(k) = B_0(k)*exp((tphys-epoch(k)-tacc(k))/bconst)*
     &                      exp(CK*bacc(k)) + Bbot
                  endif
               else
                  if(B_0(k).eq.0.d0)then
                     B(k) = 0.d0
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny.and.
     &                bacc(k).eq.0.d0)then
                     B(k) = B_0(k) + Bbot
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny)then
                     B(k) = B_0(k)/(1.d0 + (bacc(k)/1.0d-6)) + Bbot
                  elseif(bacc(k).eq.0.d0)then
                     B(k) = B_0(k)*EXP((tphys-epoch(k)-tacc(k))/bconst)
     &                       + Bbot
                  else
                     B(k) = B_0(k)*EXP((tphys-epoch(k)-tacc(k))/bconst)/
     &                       (1.d0 + (bacc(k)/1.0d-6)) + Bbot
                  endif
               endif
            endif
*
 602     continue
*
* Adjust the spin angular momentum of each star owing to mass transfer
* and conserve total angular momentum.
*
         djt = dm1*radx(j1)*radx(j1)*ospin(j1)
         djspint(j1) = djspint(j1) + djt
         djorb = djorb - djt
         if(disk)then
*
* Alter spin of the degenerate secondary by assuming that material
* falls onto the star from the inner edge of a Keplerian accretion
* disk and that the system is in a steady state.
*
            djt = dm2*twopi*aursun*SQRT(aursun*mass(j2)*radx(j2))
            djspint(j2) = djspint(j2) - djt
            djorb = djorb + djt
*
         else
*
* No accretion disk.
* Calculate the angular momentum of the transferred material by
* using the radius of the disk (see Ulrich & Burger) that would
* have formed if allowed.
*
            rdisk = 1.7d0*rmin
            djt = dm2*twopi*aursun*SQRT(aursun*mass(j2)*rdisk)
            djspint(j2) = djspint(j2) - djt
            djorb = djorb + djt
*
         endif
         djtx(2) = djt
*
* Adjust the secondary spin if a nova eruption has occurred.
*
         if(novae)then
            djt = (dm2 - dm22)*radx(j2)*radx(j2)*ospin(j2)
            djspint(j2) = djspint(j2) + djt
            djtx(2) = djtx(2) - djt
         endif
*
* Calculate circularization, orbital shrinkage and spin up.
*
         do 603 , k = 1,2
*
* Evaluate convective/radiative limits for a variety of stars as based
* on the work of Belczynski et al. (2008). As option.
* Note only certain stars of type k = 0, 1, 2, 4, 5, 6, 9 **double check
* 0, 1 have range of 0.35-Mms,conv. Mms,conv is function of metalicity.
* 2 & 4 have a temperature dependence. Convective if Teff < 10**3.73
* 3, 5 & 6 are giants and have no radiative envelopes.
* 9's envelope is convective when M < Mhe,conv, Mhe,conv = 3.0Msun.
*
            if(ST_cr.le.0)then
               if(kstar(k).le.1)then
                  convradcomp(k) = 1.25d0
               else
                  convradcomp(k) = 99999999.d0
               endif
            else
               if(kstar(k).le.1)then
*                 Main sequence mass limit varying with metallicity
                  convradcomp(k) = 1.25d0
                  if(z.gt.0.001d0.and.z.lt.0.02d0)then
                     convradcomp(k) = 0.747d0 + 55.73d0*z - 1532*z*z
                  elseif(z.le.0.001d0)then
                     convradcomp(k) = 0.8d0
                  endif
               elseif(kstar(k).eq.2.or.kstar(k).eq.4)then
*                 H-rich HG and CHeB temperature limit
                  convradcomp(k) = 10.d0**3.73d0
               elseif(kstar(k).le.6)then
*                 No limit or all other giant stars
*                 (compare this large value to mass).
                  convradcomp(k) = 99999999.d0
               elseif(kstar(k).eq.9)then
*                 Mass limit for evolved He star
                  convradcomp(k) = 3.d0
               endif
            endif
*
            dspint(k) = 0.d0
            if(((kstar(k).le.9.and.rad(k).ge.0.01d0*rol(k)).or.
     &         (kstar(k).ge.10.and.k.eq.j1)).and.tflag.gt.0)then
*
               raa2 = (radx(k)/sep)**2
               raa6 = raa2**3
*
               f5 = 1.d0+ecc2*(3.d0+ecc2*0.375d0)
               f4 = 1.d0+ecc2*(1.5d0+ecc2*0.125d0)
               f3 = 1.d0+ecc2*(3.75d0+ecc2*(1.875d0+ecc2*7.8125d-02))
               f2 = 1.d0+ecc2*(7.5d0+ecc2*(5.625d0+ecc2*0.3125d0))
               f1 = 1.d0+ecc2*(15.5d0+ecc2*(31.875d0+ecc2*(11.5625d0
     &                  +ecc2*0.390625d0)))
*
               if(ST_cr.le.0.and.
     &            ((kstar(k).eq.1.and.mass(k).ge.1.25d0).or.
     &            kstar(k).eq.4.or.kstar(k).eq.7))then
*
* Radiative damping (Zahn, 1977, A&A, 57, 383 and 1975, A&A, 41, 329).
*
                  tc = 1.592d-09*(mass(k)**2.84d0)
                  f = 1.9782d+04*SQRT((mass(k)*radx(k)*radx(k))/sep**5)*
     &                tc*(1.d0+q(3-k))**(5.d0/6.d0)
                  tcqr = f*q(3-k)*raa6
                  rg2 = k2str(k)
               elseif(ST_cr.gt.0.and.
     &                ((kstar(k).le.1.and.mass(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.2.and.teff(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.4.and.teff(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.9.and.mass(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.7).or.(kstar(k).eq.8)))then
*
* Radiative damping (Zahn, 1977, A&A, 57, 383 and 1975, A&A, 41, 329).
*
                  tc = 1.592d-09*(mass(k)**2.84d0)
                  f = 1.9782d+04*SQRT((mass(k)*rad(k)*rad(k))/sep**5)*
     &                tc*(1.d0+q(3-k))**(5.d0/6.d0)
                  tcqr = f*q(3-k)*raa6
                  rg2 = k2str(k)
               elseif(kstar(k).le.9)then
* Convective damping

* In BSE paper Equation 30, the default scaling coefficient is 2./21
* the fprimc_array kstar dependent array that is fed in
* keeps this same coefficient by default but allows user to
* specify their own
*
                  renv(k) = MIN(renv(k),radx(k)-radc(k))
                  renv(k) = MAX(renv(k),1.0d-10)
                  tc = mr23yr*(menv(k)*renv(k)*(radx(k)-0.5d0*renv(k))/
     &                 (3.d0*lumin(k)))**(1.d0/3.d0)
                  ttid = twopi/(1.0d-10 + ABS(oorb - ospin(k)))
                  f = MIN(1.d0,(ttid/(2.d0*tc))**2)
                  tcqr = fprimc_array(kstar(k))*
     &                 f*q(3-k)*raa6*menv(k)/
     &                 (tc*mass(k))
                  rg2 = (k2str(k)*(mass(k)-massc(k)))/mass(k)
               elseif(ST_tide.le.0)then
*Degenerate damping
                  f = 7.33d-09*(lumin(k)/mass(k))**(5.d0/7.d0)
                  tcqr = f*q(3-k)*q(3-k)*raa2*raa2/(1.d0+q(3-k))
                  rg2 = k3
               endif
               sqome3 = sqome2**3
               delet1 = 27.d0*tcqr*(1.d0+q(3-k))*raa2*(ecc/sqome2**13)*
     &                  (f3 - (11.d0/18.d0)*sqome3*f4*ospin(k)/oorb)
               tcirc = ecc/(ABS(delet1) + 1.0d-20)
               delet = delet + delet1*dt
               dspint(k) = (3.d0*q(3-k)*tcqr/(rg2*omecc2**6))*
     &                     (f2*oorb - sqome3*f5*ospin(k))
               eqspin = oorb*f2/(sqome3*f5)
               if(dt.gt.0.d0)then
                  if(dspint(k).ge.0.d0)then
                     dspint(k) = MIN(dt*dspint(k),eqspin-ospin(k))/dt
                  else
                     dspint(k) = MAX(dt*dspint(k),eqspin-ospin(k))/dt
                  endif
               endif
               djt = (k2str(k)*(mass(k)-massc(k))*radx(k)*radx(k) +
     &                k3*massc(k)*radc(k)*radc(k))*dspint(k)
               djorb = djorb + djt*dt
               djspint(k) = djspint(k) - djt*dt
*
            endif
*
            jspin(k) = MAX(1.0d-10,jspin(k) - djspint(k))
*
* Ensure that the star does not spin up beyond break-up, and transfer
* the excess angular momentum back to the orbit.
*
            ospbru = twopi*SQRT(mass(k)*aursun**3/radx(k)**3)
            jspbru = (k2str(k)*(mass(k)-massc(k))*radx(k)*radx(k) +
     &                k3*massc(k)*radc(k)*radc(k))*ospbru
            if(jspin(k).gt.jspbru)then
               mew = 1.d0
               if(djtx(2).gt.0.d0)then
                  mew = MIN(mew,(jspin(k) - jspbru)/djtx(2))
               endif
               djorb = djorb - (jspin(k) - jspbru)
               jspin(k) = jspbru
* If excess material should not be accreted, activate next line.
*              dm22 = (1.d0 - mew)*dm22
            endif
*
 603     continue
*
* Update the masses.
*
         kstar(j2) = kst
         mass(j1) = mass(j1) - dm1 - dms(j1)
         if(kstar(j1).le.1.or.kstar(j1).eq.7) mass0(j1) = mass(j1)
         mass(j2) = mass(j2) + dm22 - dms(j2)
         if(kstar(j2).le.1.or.kstar(j2).eq.7) mass0(j2) = mass(j2)
         if(kstar(j2).eq.13.and.pulsar.gt.0)then
* if propeller add and if(.not.prop)then here... PK.
            b_mdot = (dm2-dms(j2))/dt
            if(b_mdot_lim.gt.0.d0.and.b_mdot.gt.b_mdot_lim)then
               bacc(j2) = bacc(j2) + (dm2-dms(j2))
               tacc(j2) = tacc(j2) + dtm
            elseif(b_mdot_lim.le.0.d0)then
               bacc(j2) = bacc(j2) + (dm2-dms(j2))
               tacc(j2) = tacc(j2) + dtm
            endif
         endif
*
* For a HG star check if the initial mass can be reduced.
*
         if(kstar(j1).eq.2.and.mass0(j1).le.zpars(3))then
            m0 = mass0(j1)
            mass0(j1) = mass(j1)
            CALL star(kstar(j1),mass0(j1),mass(j1),tmsnew,tn,tscls,
     &                lums,GB,zpars)
            if(GB(9).lt.massc(j1))then
               mass0(j1) = m0
            endif
         endif
         if(kstar(j2).eq.2.and.mass0(j2).le.zpars(3))then
            m0 = mass0(j2)
            mass0(j2) = mass(j2)
            CALL star(kstar(j2),mass0(j2),mass(j2),tmsnew,tn,tscls,
     &                lums,GB,zpars)
            if(GB(9).lt.massc(j2))then
               mass0(j2) = m0
            endif
         endif
*
         ecc = ecc - delet
         ecc = MAX(ecc,0.d0)
         if(ecc.lt.1.0d-10) ecc = 0.d0
*
         if(ecc.ge.1.d0) goto 135
*
* Ensure that Jorb does not become negative which could happen if the
* primary overfills its Roche lobe initially. In this case we simply
* allow contact to occur.
*
         jorb = MAX(1.d0,jorb - djorb)
         sep = (mass(1) + mass(2))*jorb*jorb/
     &         ((mass(1)*mass(2)*twopi)**2*aursun**3*(1.d0-ecc*ecc))
         tb = (sep/aursun)*SQRT(sep/(aursun*(mass(1)+mass(2))))
         oorb = twopi/tb
*
      endif
*
* Always rejuvenate the secondary and age the primary if they are on
* the main sequence.
*
      if(kstar(j1).le.2.or.kstar(j1).eq.7)then
         CALL star(kstar(j1),mass0(j1),mass(j1),tmsnew,tn,tscls,
     &             lums,GB,zpars)
         if(kstar(j1).eq.2)then
            aj(j1) = tmsnew + (tscls(1) - tmsnew)*(aj(j1)-tms(j1))/
     &                        (tbgb(j1) - tms(j1))
         else
            aj(j1) = tmsnew/tms(j1)*aj(j1)
         endif
         epoch(j1) = tphys - aj(j1)
      endif
*
      if(kstar(j2).le.2.or.kstar(j2).eq.7)then
         CALL star(kstar(j2),mass0(j2),mass(j2),tmsnew,tn,tscls,
     &             lums,GB,zpars)
         if(kstar(j2).eq.2)then
            aj(j2) = tmsnew + (tscls(1) - tmsnew)*(aj(j2)-tms(j2))/
     &                        (tbgb(j2) - tms(j2))
         elseif((mass(j2).lt.0.35d0.or.mass(j2).gt.1.25d0).
     &           and.kstar(j2).ne.7)then
            aj(j2) = tmsnew/tms(j2)*aj(j2)*(mass(j2) - dm22)/mass(j2)
         else
            aj(j2) = tmsnew/tms(j2)*aj(j2)
         endif
         epoch(j2) = tphys - aj(j2)
      endif
*
* Obtain the stellar parameters for the next step.
*
      tphys = tphys + dtm
      do 90 , k = 1,2
         age = tphys - epoch(k)
         m0 = mass0(k)
         mt = mass(k)
         mc = massc(k)
*
* Masses over 100Msun should probably not be trusted in the
* evolution formulae.
*
         if(mt.gt.100.d0)then
*            WRITE(99,*)' MASS EXCEEDED ',mass1i,mass2i,tbi,ecci,mt,
*     & tphysf,id1_pass,id2_pass
*            goto 140
         endif
         kw = kstar(k)
         CALL star(kw,m0,mt,tm,tn,tscls,lums,GB,zpars)
         CALL hrdiag(m0,age,mt,tm,tn,tscls,lums,GB,zpars,
     &               rm,lum,kw,mc,rc,me,re,k2,bhspin(k),k)
*
* Check for a supernova and correct the semi-major axis if so.
*
         if(kw.ne.kstar(k).and.kstar(k).le.12.and.
     &      (kw.eq.13.or.kw.eq.14))then
            dms(k) = mass(k) - mt
            if(formation(k).ne.11) formation(k) = 1
            if(kw.eq.13.and.ecsn.gt.0.d0)then
               if(kstar(k).le.6)then
                  if(mass0(k).le.zpars(5))then
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = sigmahold/sigmadiv
                        sigma = -sigma
                     else
                        sigma = -1.d0*sigmadiv
                     endif
                     formation(k) = 2
                  endif
               elseif(kstar(k).ge.7.and.kstar(k).le.9)then
                  if(mass(k).gt.ecsn_mlow.and.mass(k).le.ecsn)then
* BSE orgi: 1.6-2.25, Pod: 1.4-2.5, StarTrack: 1.83-2.25 (all in Msun)
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = sigmahold/sigmadiv
                        sigma = -sigma
                     else
                        sigma = -1.d0*sigmadiv
                     endif
                     formation(k) = 2
                  endif
               elseif(formation(k).eq.11)then
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = sigmahold/sigmadiv
                     sigma = -sigma
                  else
                     sigma = -1.d0*sigmadiv
                  endif
                  formation(k) = 5
               elseif(kstar(k).ge.10.or.kstar(k).eq.12)then
* AIC formation, will never happen here but...
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = sigmahold/sigmadiv
                     sigma = -sigma
                  else
                     sigma = -1.d0*sigmadiv
                  endif
                  formation(k) = 4
               endif
            endif

            evolve_type = 14.d0 + FLOAT(k)
            CALL writebpp(jp,tphys,evolve_type,
     &                    mass(1),mass(2),kstar(1),kstar(2),
     &                    sep,tb,ecc,rrl1,rrl2,bkick,
     &                    aj(1),aj(2),tms(1),tms(2),
     &                    massc(1),massc(2),rad(1),rad(2))
            CALL kick(kw,mass(k),mt,mass(3-k),ecc,sep,jorb,vk,k,
     &                rad(3-k),fallback,bkick,disrupt)
            sigma = sigmahold !reset sigma after possible ECSN kick dist. Remove this if u want some kick link to the intial pulsar values...

* set kick values for the bcm array
            if(bkick(13).gt.0.d0)then
               vk1_bcm=bkick(13)
            endif
            if(bkick(14).gt.0.d0)then
               vk2_bcm=bkick(14)
            endif
            if(bkick(17).gt.0.d0)then
               vsys_bcm=bkick(17)
            endif
            if(bkick(20).gt.0.d0)then
               theta_bcm=bkick(20)
            endif

            if(mass(3-k).lt.0.d0)then
               if(kstar(3-k).lt.0.d0) mt = mt-mass(3-k)
               if(kw.eq.13.and.mt.gt.mxns) kw = 14
               CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
               kstar(k) = kw
               mass(k) = mt
               epoch(k) = tphys - age
               kstar(3-k) = 15
               mass(3-k) = 0.d0
               coel = .true.
               binstate = 1
            endif
            if(ecc.gt.1.d0)then
               kstar(k) = kw
               mass(k) = mt
               epoch(k) = tphys - age
               goto 135
            endif
            tb = (sep/aursun)*SQRT(sep/(aursun*(mt+mass(3-k))))
            oorb = twopi/tb
         endif
         if(kw.ne.kstar(k))then
            change = .true.
            if((kw.eq.13.or.kw.eq.14).and.kstar(k).le.12)then
               snova = .true.
            endif
            mass(k) = mt
            if(kw.eq.15)then
               kstar(k) = kw
               goto 135
            endif
            mass0(k) = m0
            epoch(k) = tphys - age
         endif
*
*     Determine stellar evolution timescale for nuclear burning types.
*
         if(kw.le.9)then
            CALL deltat(kw,age,tm,tn,tscls,dt,dtr)
            dtmi(k) = MIN(dt,dtr)
*           dtmi(k) = dtr
            dtmi(k) = MAX(1.0d-07,dtmi(k))
         else
            dtmi(k) = 1.0d+10
         endif
*        dtmi(k) = MAX((tn-age),1.0d-07)
*
* Save relevent solar quantities.
*
         aj(k) = age
         kstar(k) = kw
         rad(k) = rm
         radx(k) = rm
         lumin(k) = lum
         teff(k) = 1000.d0*((1130.d0*lumin(k)/
     &                    (rad(k)**2.d0))**(1.d0/4.d0))
         massc(k) = mc
         radc(k) = rc
         menv(k) = me
         renv(k) = re
         k2str(k) = k2
         tms(k) = tm
         tbgb(k) = tscls(1)
*
 90   continue
*
      do 100 , k = 1,2
         q(k) = mass(k)/mass(3-k)
         rol(k) = rl(q(k))*sep
         if(ST_tide.gt.0) rol(k) = rl(q(k))*sep*(1.d0-ecc)
 100  continue
      if(rad(j1).gt.rol(j1)) radx(j1) = MAX(radc(j1),rol(j1))
      do 110 , k = 1,2
         ospin(k) = jspin(k)/(k2str(k)*(mass(k)-massc(k))*radx(k)*
     &              radx(k) + k3*massc(k)*radc(k)*radc(k))
 110  continue
*
      if((isave.and.tphys.ge.tsave).or.iplot)then
          if(B_0(1).eq.0.d0)then !PK.
              b01_bcm = 0.d0
          elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
              b01_bcm = B_0(1)
          else
              b01_bcm = B(1)
          endif
          if(B_0(2).eq.0.d0)then
              b02_bcm = 0.d0
          elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
              b02_bcm = B_0(2)
          else
              b02_bcm = B(2)
          endif
          teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
          teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
          rrl1 = rad(1)/rol(1)
          rrl2 = rad(2)/rol(2)
          dt = MAX(dtm,1.0d-12)*1.0d+06
          if(j1.eq.1)then
              deltam1_bcm = (-1.0*dm1 - dms(1))/dt
              deltam2_bcm = (dm2 - dms(2))/dt
          else
              deltam1_bcm = (dm2 - dms(1))/dt
              deltam2_bcm = (-1.0*dm1 - dms(2))/dt
          endif
* Check if PISN occurred, and if so overwrite formation
          if(pisn_track(1).ne.0) formation(1) = pisn_track(1)
          if(pisn_track(2).ne.0) formation(2) = pisn_track(2)
          CALL writebcm(ip,tphys,kstar(1),mass0(1),mass(1),
     &                  lumin(1),rad(1),teff1,massc(1),
     &                  radc(1),menv(1),renv(1),epoch(1),
     &                  ospin(1),deltam1_bcm,rrl1,kstar(2),mass0(2),
     &                  mass(2),lumin(2),rad(2),teff2,massc(2),
     &                  radc(2),menv(2),renv(2),epoch(2),ospin(2),
     &                  deltam2_bcm,rrl2,tb,sep,ecc,b01_bcm,b02_bcm,
     &                  vk1_bcm,vk2_bcm,vsys_bcm,theta_bcm,
     &                  formation(1),formation(2),binstate,mergertype)
         if(isave) tsave = tsave + dtp
         if(output) write(*,*)'bcm3:',kstar(1),kstar(2),mass(1),
     & mass(2),rad(1),rad(2),ospin(1),ospin(2),jspin(1)
*     & mass(2),rad(1),rad(2),ospin(1),ospin(2),B(1),B(2),jspin(1)
      endif
*
      if(tphys.ge.tphysf) goto 140
*
      if(change)then
         change = .false.
         evolve_type = 2.0
         rrl1 = rad(1)/rol(1)
         rrl2 = rad(2)/rol(2)
         CALL writebpp(jp,tphys,evolve_type,
     &                 mass(1),mass(2),kstar(1),kstar(2),sep,
     &                 tb,ecc,rrl1,rrl2,bkick,
     &                 aj(1),aj(2),tms(1),tms(2),
     &                 massc(1),massc(2),rad(1),rad(2))
         DO jj = 13,20
            bkick(jj) = 0.0
         ENDDO
      endif
*
* Test whether the primary still fills its Roche lobe.
*
      if(rad(j1).gt.rol(j1).and..not.snova)then
*
* Test for a contact system
*
         if(rad(j2).gt.rol(j2)) goto 130
         iter = iter + 1
         goto 8
      else
         evolve_type = 4.0
         rrl1 = rad(1)/rol(1)
         rrl2 = rad(2)/rol(2)
         CALL writebpp(jp,tphys,evolve_type,
     &                 mass(1),mass(2),kstar(1),kstar(2),sep,
     &                 tb,ecc,rrl1,rrl2,bkick,
     &                 aj(1),aj(2),tms(1),tms(2),
     &                 massc(1),massc(2),rad(1),rad(2))
         DO jj = 13,20
            bkick(jj) = 0.0
         ENDDO
         dtm = 0.d0
         goto 4
      endif
*
 130  continue
*
* Contact system.
*
      coel = .true.
      binstate = 1
      CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
*
* If *1 or *2 is giant-like this will be common-envelope evolution.
*
      m1ce = mass(j1)
      m2ce = mass(j2)
      rrl1 = MIN(999.999d0,rad(1)/rol(1))
      rrl2 = MIN(999.999d0,rad(2)/rol(2))
*
      evolve_type = 5.0
      CALL writebpp(jp,tphys,evolve_type,
     &              mass(1),mass(2),kstar(1),kstar(2),sep,
     &              tb,ecc,rrl1,rrl2,bkick,
     &              aj(1),aj(2),tms(1),tms(2),
     &              massc(1),massc(2),rad(1),rad(2))
      DO jj = 13,20
         bkick(jj) = 0.0
      ENDDO
*
      kcomp1 = kstar(j1)
      kcomp2 = kstar(j2)
*
      if(output) write(*,*)'coal r/rl1 & r/rl2 > 0',tphys,kcomp1,kcomp2,
     & m1ce,m2ce
*
      if(kstar(j1).ge.2.and.kstar(j1).le.9.and.kstar(j1).ne.7)then
         if(j1.eq.2)then
             switchedCE = .true.
         else
             switchedCE = .false.
         endif
         evolve_type = 7.d0
         CALL writebpp(jp,tphys,evolve_type,
     &                 mass(1),mass(2),
     &                 kstar(1),kstar(2),sep,
     &                 tb,ecc,rrl1,rrl2,bkick,
     &                 aj(1),aj(2),tms(1),tms(2),
     &                 massc(1),massc(2),rad(1),rad(2))
         CALL comenv(mass0(j1),mass(j1),massc(j1),aj(j1),jspin(j1),
     &               kstar(j1),mass0(j2),mass(j2),massc(j2),aj(j2),
     &               jspin(j2),kstar(j2),zpars,ecc,sep,jorb,coel,j1,j2,
     &               vk,bkick,formation(j1),formation(j2),
     &               bhspin(j1),bhspin(j2),binstate,mergertype,
     &               jp,tphys,switchedCE,rad,tms,evolve_type,disrupt)
         if(output) write(*,*)'coal1:',tphys,kstar(j1),kstar(j2),coel,
     & mass(j1),mass(j2)
         if(j1.eq.2.and.kcomp2.eq.13.and.kstar(j2).eq.15.and.
     &      kstar(j1).eq.13)then !PK.
* In CE the NS got switched around. Do same to formation.
            formation(j1) = formation(j2)
            bkick(1) = 3-bkick(1)
         endif
         if(j1.eq.1.and.kcomp2.eq.13.and.kstar(j2).eq.15.and.
     &      kstar(j1).eq.13)then !PK.
* In CE the NS got switched around. Do same to formation.
            formation(j1) = formation(j2)
            bkick(1) = 3-bkick(1)
         endif
         com = .true.
         if(com.and..not.coel.and..not.disrupt)then
* if it went through common envelope
* did not disrupt (from one of the objects going SN)
* and did not merge in common envelope
* then system is still in binary
            binstate = 0
            mergertype = -1
         elseif(com.and..not.coel.and.disrupt)then
* if it went through common envelope
* and did disrupt (from one of the objects going SN)
* and did not merge in common envelope
* then system should be marked as disrupted
            binstate = 2
            mergertype = -1
         endif
* else it merged in the common envelope
         if(binstate.eq.1.d0)then
             sep = 0.d0
             tb = 0.d0
         elseif(binstate.eq.2.d0)then
             sep = -1.d0
             tb = -1.d0
         endif
      elseif(kstar(j2).ge.2.and.kstar(j2).le.9.and.kstar(j2).ne.7)then
         if(j1.eq.1)then
             switchedCE = .true.
         else
             switchedCE = .false.
         endif
         evolve_type = 7.d0
         CALL writebpp(jp,tphys,evolve_type,
     &                 mass(1),mass(2),
     &                 kstar(1),kstar(2),sep,
     &                 tb,ecc,rrl1,rrl2,bkick,
     &                 aj(1),aj(2),tms(1),tms(2),
     &                 massc(1),massc(2),rad(1),rad(2))
         CALL comenv(mass0(j2),mass(j2),massc(j2),aj(j2),jspin(j2),
     &               kstar(j2),mass0(j1),mass(j1),massc(j1),aj(j1),
     &               jspin(j1),kstar(j1),zpars,ecc,sep,jorb,coel,j1,j2,
     &               vk,bkick,formation(j1),formation(j2),
     &               bhspin(j2),bhspin(j1),binstate,mergertype,
     &               jp,tphys,switchedCE,rad,tms,evolve_type,disrupt)
         if(output) write(*,*)'coal2:',tphys,kstar(j1),kstar(j2),coel,
     & mass(j1),mass(j2)
         if(j2.eq.2.and.kcomp1.eq.13.and.kstar(j1).eq.15.and.
     &      kstar(j2).eq.13)then !PK.
* In CE the NS got switched around. Do same to formation.
            formation(j2) = formation(j1)
            bkick(1) = 3-bkick(1)
         endif
         if(j2.eq.1.and.kcomp1.eq.13.and.kstar(j1).eq.15.and.
     &      kstar(j2).eq.13)then !PK.
* In CE the NS got switched around. Do same to formation.
            formation(j2) = formation(j1)
            bkick(1) = 3-bkick(1)
         endif
         com = .true.
         if(com.and..not.coel.and..not.disrupt)then
* if it went through common envelope
* did not disrupt (from one of the objects going SN)
* and did not merge in common envelope
* then system is still in binary
            binstate = 0
            mergertype = -1
         elseif(com.and..not.coel.and.disrupt)then
* if it went through common envelope
* and did disrupt (from one of the objects going SN)
* and did not merge in common envelope
* then system should be marked as disrupted
            binstate = 2
            mergertype = -1
         endif
* else it merged in the common envelope
         if(binstate.eq.1.d0)then
             sep = 0.d0
             tb = 0.d0
         elseif(binstate.eq.2.d0)then
             sep = -1.d0
             tb = -1.d0
         endif
      else
         CALL mix(mass0,mass,aj,kstar,zpars,bhspin)
      endif

* set kick values for the bcm array
      if(bkick(13).gt.0.d0)then
         vk1_bcm=bkick(13)
      endif
      if(bkick(14).gt.0.d0)then
         vk2_bcm=bkick(14)
      endif
      if(bkick(17).gt.0.d0)then
         vsys_bcm=bkick(17)
      endif
      if(bkick(20).gt.0.d0)then
         theta_bcm=bkick(20)
      endif

      if(com)then
          evolve_type = 8.0
          mass1_bpp = mass(1)
          mass2_bpp = mass(2)
          if(kstar(1).eq.15) mass1_bpp = mass0(1)
          if(kstar(2).eq.15) mass2_bpp = mass0(2)
          rrl1 = MIN(rrl1,0.99d0)
          rrl2 = MIN(rrl2,0.99d0)
          CALL writebpp(jp,tphys,evolve_type,
     &                  mass1_bpp,mass2_bpp,
     &                  kstar(1),kstar(2),sep,
     &                  tb,ecc,rrl1,rrl2,bkick,
     &                  aj(1),aj(2),tms(1),tms(2),
     &                  massc(1),massc(2),rad(1),rad(2))
         DO jj = 13,20
            bkick(jj) = 0.0
         ENDDO
      endif
      epoch(1) = tphys - aj(1)
      epoch(2) = tphys - aj(2)
      if(.not.coel)then
*
* Next step should be made without changing the time.
*
         if(ecc.gt.1.d0)then
            if(kstar(1).ge.13)then
               rc = corerd(kstar(1),mass(1),mass(1),zpars(2))
               ospin(1) = jspin(1)/(k3*rc*rc*mass(1))
            endif
            if(kstar(2).ge.13)then
               rc = corerd(kstar(2),mass(2),mass(2),zpars(2))
               ospin(2) = jspin(2)/(k3*rc*rc*mass(2))
            endif
            goto 135
         endif
         dtm = 0.d0
*
* Reset orbital parameters as separation may have changed.
*
         tb = (sep/aursun)*SQRT(sep/(aursun*(mass(1)+mass(2))))
         oorb = twopi/tb
         goto 4
      endif
*
 135  continue
*
      sgl = .true.
      if(kstar(1).eq.13.and.mergemsp.eq.1.and.
     &   notamerger.eq.0)then
         s = (twopi*yearsc)/ospin(1)
         if(s.lt.0.03d0.and.B(1).gt.0.d0)then
            merge_mem = 1
         endif
      endif
      if(kstar(2).eq.13.and.mergemsp.eq.1.and.
     &   notamerger.eq.0)then
         s = (twopi*yearsc)/ospin(2)
         if(s.lt.0.03d0.and.B(2).gt.0.d0)then
            merge_mem = 1
         endif
      endif
      if(kstar(1).ne.15.or.kstar(2).ne.15)then
         if(com)then
            com = .false.
         else
            mass1_bpp = mass(1)
            mass2_bpp = mass(2)
            if(kstar(1).eq.15) mass1_bpp = mass0(1)
            if(kstar(2).eq.15) mass2_bpp = mass0(2)
            if(coel)then
                evolve_type = 6.0
                CALL writebpp(jp,tphys,evolve_type,
     &                        mass1_bpp,mass2_bpp,
     &                        kstar(1),kstar(2),0.d0,
     &                        0.d0,-1.d0,0.d0,ngtv,bkick,
     &                        aj(1),aj(2),tms(1),tms(2),
     &                        massc(1),massc(2),rad(1),rad(2))
            elseif(ecc.gt.1.d0)then
*
* Binary dissolved by a supernova or tides.
*
                evolve_type = 11.0
                binstate = 2
                mergertype = -1
                tb = -1.d0
                sep = -1.d0
                ecc = -1.d0
                CALL writebpp(jp,tphys,evolve_type,
     &                        mass1_bpp,mass2_bpp,
     &                        kstar(1),kstar(2),sep,
     &                        tb,ecc,0.d0,ngtv2,bkick,
     &                        aj(1),aj(2),tms(1),tms(2),
     &                        massc(1),massc(2),rad(1),rad(2))
            else
                evolve_type = 9.0
                CALL writebpp(jp,tphys,evolve_type,
     &                        mass1_bpp,mass2_bpp,
     &                        kstar(1),kstar(2),0.d0,
     &                        0.d0,0.d0,0.d0,ngtv,bkick,
     &                        aj(1),aj(2),tms(1),tms(2),
     &                        massc(1),massc(2),rad(1),rad(2))
            endif
            DO jj = 13,20
               bkick(jj) = 0.0
            ENDDO
         endif
         if(kstar(2).eq.15)then
            kmax = 1
            rol(2) = -1.d0*rad(2)
            dtmi(2) = tphysf
         elseif(kstar(1).eq.15)then
            kmin = 2
            rol(1) = -1.d0*rad(1)
            dtmi(1) = tphysf
         endif
* Makes sure coalesced NSs are reset. PK.
         if(kstar(1).eq.13.and.ecc.le.1.d0.and.pulsar.gt.0.and.
     &      notamerger.eq.0)then
            age = 0.d0
            epoch(1) = tphys
         endif
         if(kstar(2).eq.13.and.ecc.le.1.d0.and.pulsar.gt.0.and.
     &      notamerger.eq.0)then
            age = 0.d0
            epoch(2) = tphys
         endif
         ecc = -1.d0
         if(binstate.eq.2)then
*            Check if disrupted then we want sep=ecc=porb=-1
             sep = -1.d0
         elseif(binstate.eq.1)then
*            check if merge then sep=0
             tb = 0.d0
             sep = 0.d0
         endif
         dtm = 0.d0
         coel = .false.
         goto 4
      endif
*
 140  continue
*
      if(com)then
         com = .false.
      else
          mass1_bpp = mass(1)
          mass2_bpp = mass(2)

          if(kstar(1).eq.15.and.bpp(jp,4).lt.15.0)then
              mass1_bpp = mass0(1)
          endif

          if(kstar(2).eq.15.and.bpp(jp,5).lt.15.0)then
              mass2_bpp = mass0(2)
          endif

          if(coel)then
              evolve_type = 6.0
              CALL writebpp(jp,tphys,evolve_type,
     &                      mass1_bpp,mass2_bpp,
     &                      kstar(1),kstar(2),0.d0,
     &                      0.d0,-1.d0,0.d0,ngtv,bkick,
     &                      aj(1),aj(2),tms(1),tms(2),
     &                      massc(1),massc(2),rad(1),rad(2))
          elseif(kstar(1).eq.15.and.kstar(2).eq.15)then
*
* Cases of accretion induced supernova or single star supernova.
* No remnant is left in either case.
*
              evolve_type = 9.0
              CALL writebpp(jp,tphys,evolve_type,
     &                      mass1_bpp,mass2_bpp,
     &                      kstar(1),kstar(2),0.d0,
     &                      0.d0,0.d0,0.d0,ngtv2,bkick,
     &                      aj(1),aj(2),tms(1),tms(2),
     &                      massc(1),massc(2),rad(1),rad(2))
          else
              evolve_type = 10.0
              rrl1 = rad(1)/rol(1)
              rrl2 = rad(2)/rol(2)
              CALL writebpp(jp,tphys,evolve_type,
     &                      mass1_bpp,mass2_bpp,
     &                      kstar(1),kstar(2),sep,
     &                      tb,ecc,rrl1,rrl2,bkick,
     &                      aj(1),aj(2),tms(1),tms(2),
     &                      massc(1),massc(2),rad(1),rad(2))
          endif
          DO jj = 13,20
              bkick(jj) = 0.0
          ENDDO
      endif
*
      if((isave.and.tphys.ge.tsave).or.iplot)then
          if(B_0(1).eq.0.d0)then !PK.
              b01_bcm = 0.d0
          elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
              b01_bcm = B_0(1)
          else
              b01_bcm = B(1)
          endif
          if(B_0(2).eq.0.d0)then
              b02_bcm = 0.d0
          elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
              b02_bcm = B_0(2)
          else
              b02_bcm = B(2)
          endif
          teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
          teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
          rrl1 = rad(1)/rol(1)
          rrl2 = rad(2)/rol(2)
          dt = MAX(dtm,1.0d-12)*1.0d+06
          if(j1.eq.1)then
              deltam1_bcm = (-1.0*dm1 - dms(1))/dt
              deltam2_bcm = (dm2 - dms(2))/dt
          else
              deltam1_bcm = (dm2 - dms(1))/dt
              deltam2_bcm = (-1.0*dm1 - dms(2))/dt
          endif
* Check if PISN occurred, and if so overwrite formation
          if(pisn_track(1).ne.0) formation(1) = pisn_track(1)
          if(pisn_track(2).ne.0) formation(2) = pisn_track(2)
          CALL writebcm(ip,tphys,kstar(1),mass0(1),mass(1),
     &                  lumin(1),rad(1),teff1,massc(1),
     &                  radc(1),menv(1),renv(1),epoch(1),
     &                  ospin(1),deltam1_bcm,rrl1,kstar(2),mass0(2),
     &                  mass(2),lumin(2),rad(2),teff2,massc(2),
     &                  radc(2),menv(2),renv(2),epoch(2),ospin(2),
     &                  deltam2_bcm,rrl2,tb,sep,ecc,b01_bcm,b02_bcm,
     &                  vk1_bcm,vk2_bcm,vsys_bcm,theta_bcm,
     &                  formation(1),formation(2),binstate,mergertype)
         if(output) write(*,*)'bcm4:',kstar(1),kstar(2),mass(1),
     & mass(2),rad(1),rad(2),ospin(1),ospin(2),jspin(1),
     & tphys,tphysf
*     & mass(2),rad(1),rad(2),ospin(1),ospin(2),B(1),B(2),jspin(1),
         if(isave) tsave = tsave + dtp
         if(tphysf.le.0.d0)then
            ip = ip + 1
            do 145 , k = 1,42
               bcm(ip,k) = bcm(ip-1,k)
 145        continue
         endif
*

      elseif((kstar(1).eq.15.and.kstar(2).eq.15))then
         tphys = tphysf
         evolve_type = 10.0
         goto 135
      endif
      tphysfhold = tphysf
      tphysf = tphys
      if(sgl)then
         if(ecc.ge.0.d0.and.ecc.le.1.d0) ecc = -1.d0
         tb = -1.d0
      endif
      tb = tb*yeardy

      if(jp.ge.1000)then
         WRITE(*,*)' STOP: EVOLV2 ARRAY ERROR '
*         CALL exit(0)
*         STOP
      elseif(jp.ge.40)then
         WRITE(99,*)' EVOLV2 ARRAY WARNING ',mass1i,mass2i,tbi,ecci,jp
      endif
      if(iter.ge.loop)then
         WRITE(99,*)'ITER>=LOOP:',jp,tphys,tphysfhold,dtp,kstar,age,kst,
     & id1_pass,id2_pass,mass(1),mass(2),iter,loop
*         CALL exit(0)
*         STOP
      endif
      bcm(ip+1,1) = -1.0
      bpp(jp+1,1) = -1.0
      if(using_cmc.eq.0)then
          bppout = bpp
          bcmout = bcm
      endif
*

      END SUBROUTINE evolv2
***

***
        SUBROUTINE WRITEBPP(jp,tphys,evolve_type,
     &                      mass1,mass2,kstar1,kstar2,sep,
     &                      tb,ecc,rrl1,rrl2,
     &                      aj1,aj2,tms1,tms2,
     &                      massc1,massc2,rad1,rad2,
     &                      mass0_1,mass0_2,lumin1,lumin2,
     &                      teff1,teff2,radc1,radc2,menv1,
     &                      menv2,renv1,renv2,ospin1,ospin2,
     &                      b_0_1,b_0_2,bacc1,bacc2,tacc1,tacc2,
     &                      epoch1,epoch2,bhspin1,bhspin2)
        IMPLICIT NONE
        INCLUDE 'const_bse.h'
*
* Write results to bpp array.
*
*     Author : Scott Coughlin
*     Date :   12th March 2019
*
        REAL*8 mass1,mass2
        REAL*8 evolve_type,sep,tb,ecc,tphys,rrl1,rrl2
        REAL*8 aj1,aj2,tms1,tms2,massc1,massc2,rad1,rad2
        REAL*8 mass0_1,mass0_2,lumin1,lumin2,radc1,radc2
        REAL*8 menv1,menv2,renv1,renv2,ospin1,ospin2
        REAL*8 b_0_1,b_0_2,bacc1,bacc2,tacc1,tacc2,epoch1,epoch2
        REAL*8 bhspin1,bhspin2,teff1,teff2
        REAL*8 tb_write,sep_cubed
        INTEGER jp
        INTEGER kstar1,kstar2
        REAL*8 yeardy,aursun,rsunau
        PARAMETER(yeardy=365.24d0,aursun=214.95d0)

        rsunau = 1/aursun
        jp = MIN(900,jp + 1)
        bpp(jp,1) = tphys
        bpp(jp,2) = mass1
        bpp(jp,3) = mass2
        bpp(jp,4) = float(kstar1)
        bpp(jp,5) = float(kstar2)
        bpp(jp,6) = sep
        if(tb.le.0.d0)then
* system was disrupted and tb=-1 and should stay that way
            bpp(jp,7) = tb
        else
            sep_cubed = (sep*rsunau)*(sep*rsunau)*(sep*rsunau)
            tb_write = sqrt(sep_cubed/(mass1+mass2))
            bpp(jp,7) = tb_write*yeardy
        endif
        bpp(jp,8) = ecc
        bpp(jp,9) = rrl1
        bpp(jp,10) = rrl2
        bpp(jp,11) = evolve_type
        bpp(jp,12) = aj1
        bpp(jp,13) = aj2
        bpp(jp,14) = tms1
        bpp(jp,15) = tms2
        bpp(jp,16) = massc1
        bpp(jp,17) = massc2
        bpp(jp,18) = rad1
        bpp(jp,19) = rad2
        bpp(jp,20) = mass0_1
        bpp(jp,21) = mass0_2
        bpp(jp,22) = lumin1
        bpp(jp,23) = lumin2
        bpp(jp,24) = teff1
        bpp(jp,25) = teff2
        bpp(jp,26) = radc1
        bpp(jp,27) = radc2
        bpp(jp,28) = menv1
        bpp(jp,29) = menv2
        bpp(jp,30) = renv1
        bpp(jp,31) = renv2
        bpp(jp,32) = ospin1
        bpp(jp,33) = ospin2
        bpp(jp,34) = b_0_1
        bpp(jp,35) = b_0_2
        bpp(jp,36) = bacc1
        bpp(jp,37) = bacc2
        bpp(jp,38) = tacc1
        bpp(jp,39) = tacc2
        bpp(jp,40) = epoch1
        bpp(jp,41) = epoch2
        bpp(jp,42) = bhspin1
        bpp(jp,43) = bhspin2
        END

***
        SUBROUTINE WRITEBCM(ip,tphys,kstar_1,mass0_1,mass_1,
     &                      lumin_1,rad_1,teff_1,massc_1,
     &                      radc_1,menv_1,renv_1,epoch_1,
     &                      ospin_1,deltam_1,RRLO_1,kstar_2,mass0_2,
     &                      mass_2,lumin_2,rad_2,teff_2,massc_2,radc_2,
     &                      menv_2,renv_2,epoch_2,ospin_2,deltam_2,
     &                      RRLO_2,porb,sep,ecc,B_0_1,B_0_2,
     &                      SN_1,SN_2,bin_state,merger_type)
        IMPLICIT NONE
        INCLUDE 'const_bse.h'
*
* Write results to bcm array.
*
*     Author : Scott Coughlin
*     Date :   12th March 2019
*
        REAL*8 tphys,mass0_1,mass_1,lumin_1,rad_1,teff_1
        REAL*8 massc_1,radc_1,menv_1,renv_1,epoch_1
        REAL*8 ospin_1,deltam_1,RRLO_1,porb_write,sep_cubed
        REAL*8 mass0_2,mass_2,lumin_2,rad_2,teff_2,massc_2
        REAL*8 radc_2,menv_2,renv_2,epoch_2,ospin_2,deltam_2
        REAL*8 RRLO_2,porb,sep,ecc,B_0_1,B_0_2
        INTEGER kstar_1,kstar_2,SN_1,SN_2,bin_state,merger_type
        INTEGER ip
        REAL*8 yeardy,aursun,rsunau
        PARAMETER(yeardy=365.24d0,aursun=214.95d0)

        rsunau = 1/aursun

        ip = ip + 1
        bcm(ip,1) = tphys
        bcm(ip,2) = float(kstar_1)
        bcm(ip,3) = mass0_1
        bcm(ip,4) = mass_1
        bcm(ip,5) = lumin_1
        bcm(ip,6) = rad_1
        bcm(ip,7) = teff_1
        bcm(ip,8) = massc_1
        bcm(ip,9) = radc_1
        bcm(ip,10) = menv_1
        bcm(ip,11) = renv_1
        bcm(ip,12) = epoch_1
        bcm(ip,13) = ospin_1
        bcm(ip,14) = deltam_1
        bcm(ip,15) = RRLO_1
        bcm(ip,16) = float(kstar_2)
        bcm(ip,17) = mass0_2
        bcm(ip,18) = mass_2
        bcm(ip,19) = lumin_2
        bcm(ip,20) = rad_2
        bcm(ip,21) = teff_2
        bcm(ip,22) = massc_2
        bcm(ip,23) = radc_2
        bcm(ip,24) = menv_2
        bcm(ip,25) = renv_2
        bcm(ip,26) = epoch_2
        bcm(ip,27) = ospin_2
        bcm(ip,28) = deltam_2
        bcm(ip,29) = RRLO_2
        if(porb.le.0.d0)then
* system was disrupted and porb=-1 and should stay that way
            bcm(ip,30) = porb
        else
            sep_cubed = (sep*rsunau)*(sep*rsunau)*(sep*rsunau)
            porb_write = sqrt(sep_cubed/(mass_1+mass_2))
            bcm(ip,30) = porb_write*yeardy
        endif
        bcm(ip,31) = sep
        bcm(ip,32) = ecc
        bcm(ip,33) = B_0_1
        bcm(ip,34) = B_0_2
        bcm(ip,35) = float(SN_1)
        bcm(ip,36) = float(SN_2)
        bcm(ip,37) = bin_state
        bcm(ip,38) = merger_type

        END

***
      SUBROUTINE kick(kw,m1,m1n,m2,ecc,sep,jorb,vk,snstar,
     &                r2,fallback,sigmahold,kick_info,disrupt,bkick)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
* Updated JRH kick routine by PDK (see Kiel & Hurley 2009).
*
* Here theta is the \omega angle within the HTP02 paper (thus phi is phi).
* Also, mu is the \nu angle in the HTP02 paper and omega its azimuth
*
* Produces a random SN kick.
* Evolution was added for binaries in which the kick creates
* an eccentricity of greater than unity (i.e. hyperbolic orbit).
*
* Specific kick magnitudes, angles, eccentric anomaly, and random seeds
* can be supplied in the initialization file with natal_kick_array, a
* (2,5) array with the first row being for snstar=1 and second for snstar=2
*
* SBC (September 2020)
* put bkick array back in for compatibility with CMC. bkick array is not used
* for COSMIC BSE in anyway
*
* MJZ/SBC (April 2020)
* kick_info is a (2,17) array that tracks information about the supernova
* kicks. This allows us to track the total change to the systemic
* velocity and the total change in the orbital plane tilt after both
* supernovae, as well as reproduce systems.
* The first row contains information about the first supernova that
* occurs, the second row the second supernova.
* Note that some values the second row will take into account the
* effect of the first SN (e.g., kick_info[2,10] is the total systemic
* velocity after both supernovae).
*
* kick_info[i,1]: snstar of exploding star
* kick_info[i,2]: disrupted (0=no, 1=yes)
* kick_info[i,3]: magnitude of the natal kick
* kick_info[i,4-5]: phi and theta (in the frame of the exploding star)
* kick_info[i,6]: eccentric anamoly
* kick_info[i,7-9]: change in 3D systemic velocity of the binary, or the
*       change in 3D velocity of snstar=1 if the system is disrupted
* kick_info[i,10]: magnitude of systemic velocity of the binary if bound
*       or magnitude of total velocity of snstar=1 if disrupted,
*       accounting for both SNe
* kick_info[i,11-13]: change in 3D velocity of the snstar=2 if system
*       is disrupted
* kick_info[i,14]: magnitude of velocity of snstar=2 if disrupted,
*       accounting for both SNe
* kick_info[i,15]: (total) tilt of the orbital plane after each SN
*       w.r.t. the original angular momentum axis after each SN
* kick_info[i,16]: azimuthal angle of the orbital plane w.r.t. spins
* kick_info[i,17]: random seed at the start of call to kick.f
*
* For cmc kick_info array is zero, not negative.
      integer kw,k,snstar,sn,safety

      real*8 m1,m2,m1n,mbi,mbf,mdif
      real*8 ecc,sep,sepn,jorb,ecc2
      real*8 pi,twopi,gmrkm,yearsc,rsunkm
      parameter(yearsc=3.1557d+07,rsunkm=6.96d+05)
      real*8 mm,em,dif,der,del,r
      real*8 u1,u2,vk,v(4),s,theta,phi
      real*8 sphi,cphi,stheta,ctheta,salpha,calpha
      real*8 x_tilt,y_tilt,z_tilt
      real*8 mu,cmu,smu,omega,comega,somega
      real*8 cmu1,smu1,comega1,somega1
      real*8 vr,vr2,vk2,vn2,hn2
      real*8 vs(3),v1,v2,v3
      real*8 mx1,mx2,r2
      real*8 sigmah,RotInvX
      real*8 signs,sigc,psins,psic,cpsins,spsins,cpsic,spsic
      real*8 csigns
      real*8 semilatrec,cangleofdeath,angleofdeath,energy
      real*8 fallback,sigmahold,bound
      real*8 mean_mns,mean_mej,alphakick,betakick
      real*8 bkick(20)
* Output
      logical output,disrupt
*
      real*8 kick_info(2,17)
      real ran3,xx
      external ran3
*
      output = .false. !useful for debugging...
      safety = 0

* Set up empty arrays and constants
      do k = 1,3
         vs(k) = 0.d0
      enddo
      u1 = 0.d0
      u2 = 0.d0
      vk = 0.d0
      pi = ACOS(-1.d0)
      twopi = 2.d0*pi
* Conversion factor to ensure velocities are in km/s using mass and
* radius in solar units.
      gmrkm = 1.906125d+05

* Set values for mean NS mass and mean ejecta as in Giacobbo & Mapelli 2020
      mean_mns = 1.2d0
      mean_mej = 9.0d0
* Set values for alpha and beta as in Bray & Eldridge 2016
      alphakick = 70.0d0
      betakick = 120.0d0

* find whether this is the first or second supernova
      if(using_cmc.eq.0)then
          if(kick_info(1,1).eq.0) sn=1
          if(kick_info(1,1).gt.0) sn=2
      else
          if(bkick(1).eq.0) sn=1
          if(bkick(1).gt.0) sn=2
      endif

      if(using_cmc.eq.0)then
* check if we have supplied a randomseed for this SN from kick_info
* already
          if(natal_kick_array(snstar,5).gt.0.d0)then
* if we have we need to run ran3 enough times until
* we are at the same state of the random number generator
* as we were before
              do while (natal_kick_array(snstar,5).ne.idum1
     &                          .and.safety.le.20)
                  xx = RAN3(idum1)
                  safety = safety + 1
              end do
          endif
      endif
* save the current idum1
      natal_kick_array(snstar,5) = idum1
      kick_info(sn,17) = idum1

* set the SNstar of the exploding object in the kick_info array
      kick_info(sn,1) = snstar

* if the system was disrupted from the first supernova, marked as disrupted
      if(kick_info(1,2).eq.1) kick_info(2,2)=1

* sigma is negative for ECSN
      if((sigma.lt.0.d0).and.(kickflag.eq.0))then
         sigma = -1.d0*sigma
* for kick prescriptions other than default, revert to original sigma
      elseif((sigma.lt.0.d0).and.(kickflag.lt.0))then
         sigma = sigmahold
      endif
      sigmah = sigma

* scale down BH kicks if bhsigmafrac is specified
      if(kickflag.eq.0)then
         if(kw.eq.14.or.(kw.eq.13.and.(m1n.ge.mxns)))then
            sigma = sigmah*bhsigmafrac
         endif
      endif

*
* Find the initial separation by randomly choosing a mean anomaly.
      if(sep.gt.0.d0.and.ecc.ge.0.d0)then

* check is user supplied mean anomaly
         if((natal_kick_array(snstar,4).ge.(0.d0)).and.
     &       (natal_kick_array(snstar,4).le.(360.d0)))then

             mm = natal_kick_array(snstar,4)*pi/180.d0
* per supplied kick value we mimic a call to random number generator
             xx = RAN3(idum1)

* Solve for the eccentric anomaly from the mean anomaly
* https://en.wikipedia.org/wiki/Eccentric_anomaly
             em = mm

             if(mm.eq.0.d0) goto 3

  4          dif = em - ecc*SIN(em) - mm
             if(ABS(dif/mm).le.1.0d-04) goto 3
             der = 1.d0 - ecc*COS(em)
             del = dif/der
             em = em - del
             goto 4

         endif

         xx = RAN3(idum1)
         mm = xx*twopi
         em = mm
 2       dif = em - ecc*SIN(em) - mm
         if(ABS(dif/mm).le.1.0d-04) goto 3
         der = 1.d0 - ecc*COS(em)
         del = dif/der
         em = em - del
         goto 2
 3       continue
         r = sep*(1.d0 - ecc*COS(em))
*
* Find the initial relative velocity vector.
* With a randomly selected quadrant of the orbit.
         salpha = SQRT((sep*sep*(1.d0-ecc*ecc))/(r*(2.d0*sep-r)))
         calpha = (-1.d0*ecc*SIN(em))/SQRT(1.d0-ecc*ecc*COS(em)*COS(em))
         vr2 = gmrkm*(m1+m2)*(2.d0/r - 1.d0/sep)
         vr = SQRT(vr2)
      else
         vr = 0.d0
         vr2 = 0.d0
         salpha = 0.d0
         calpha = 0.d0
      endif
* Before we draw the kick from the maxwellian and then scale it
* as desired, let us see if a pre-supplied natal kick maganitude
* was passed.
      if(natal_kick_array(snstar,1).ge.0.d0)then
          vk = natal_kick_array(snstar,1)
          vk2 = vk*vk
* per supplied kick value we mimic a call to random number generator
          xx = RAN3(idum1)
          xx = RAN3(idum1)
          xx = RAN3(idum1)
          xx = RAN3(idum1)
      else
* Generate Kick Velocity using Maxwellian Distribution (Phinney 1992).
* Use Henon's method for pairwise components (Douglas Heggie 22/5/97).
          do 20 k = 1,2
             u1 = RAN3(idum1)
             u2 = RAN3(idum1)
             if(u1.gt.0.9999d0) u1 = 0.9999d0
             if(u2.gt.1.d0) u2 = 1.d0
* Generate two velocities from polar coordinates S & THETA.
             s = -2.d0*LOG(1.d0 - u1)
             s = sigma*SQRT(s)
             theta = twopi*u2
             v(2*k-1) = s*COS(theta)
             v(2*k) = s*SIN(theta)
 20          continue
          vk2 = v(1)*v(1) + v(2)*v(2) + v(3)*v(3)
          vk = SQRT(vk2)

          if(kickflag.eq.0)then
* Limit BH kick with fallback mass fraction.
             if(kw.eq.14.and.bhflag.eq.0)then
                vk2 = 0.d0
                vk = 0.d0
             elseif(kw.eq.14.and.bhflag.eq.1)then
                 fallback = MIN(fallback,1.d0)
                 vk = MAX((1.d0-fallback)*vk,0.d0)
                 vk2 = vk*vk
             elseif(kw.eq.14.and.bhflag.eq.2)then
                vk = vk * mxns / m1n
                vk2 = vk*vk
             endif
          elseif(kickflag.eq.-1)then
* Use kick scaling from Giacobbo & Mapelli 2020, Eq. 1
             vk = vk * ((m1-m1n)/mean_mej) * (mean_mns/m1n)
             vk2 = vk*vk
          elseif(kickflag.eq.-2)then
* Use kick scaling from Giacobbo & Mapelli 2020, Eq. 2
             vk = vk * ((m1-m1n)/mean_mej)
             vk2 = vk*vk
          elseif(kickflag.eq.-3)then
* Use kick scaling from Bray & Eldridge 2016, Eq. 1
             vk = alphakick * ((m1-m1n)/m1n) + betakick
             vk2 = vk*vk
          endif

      endif
      sigma = sigmah

* save natal kick velocity in the kick_info array and natal_kick_array
      kick_info(sn,3) = vk
      if(using_cmc.eq.0)then
          natal_kick_array(snstar,1) = vk
      endif
* Before we randomly draw a phi and theta for the natal kick,
* see if a pre-supplied set of phi/theta is passed
      if((natal_kick_array(snstar,2).ge.(-90.d0)).and.
     &       (natal_kick_array(snstar,2).le.(90.d0)))then
          phi = natal_kick_array(snstar,2)*pi/180.d0
          sphi = SIN(phi)
* per supplied kick value we mimic a call to random number generator
          xx = RAN3(idum1)
          xx = RAN3(idum1)
      else
* CLR - Allow for a restricted opening angle for SN kicks
*       Only relevant for binaries, obviously
*       Default value for polar_kick_angle = 90.0
          bound = SIN((90.d0 - polar_kick_angle)*pi/180.d0)
          sphi = (1.d0-bound)*ran3(idum1) + bound
          phi = ASIN(sphi)
* MJZ - The constrained kick will hit at either the north
*       or south pole, so randomly choose the hemisphere
          if(RAN3(idum1).ge.0.5)then
            phi = -phi
            sphi = SIN(phi)
          endif
      endif
      cphi = COS(phi)

      if((natal_kick_array(snstar,3).ge.(0.d0)).and.
     &       (natal_kick_array(snstar,3).le.(360.d0)))then
          theta = natal_kick_array(snstar,3)*pi/180.d0
* per supplied kick value we mimic a call to random number generator
           xx = RAN3(idum1)
      else
          theta = twopi*ran3(idum1)
      endif
      stheta = SIN(theta)
      ctheta = COS(theta)

*     save theta and phi (exploding star frame) in the kick_info and
*     natal_kick_array
      kick_info(sn,4) = phi*180/pi
      kick_info(sn,5) = theta*180/pi
      if(using_cmc.eq.0)then
          natal_kick_array(snstar,2) = phi*180/pi
          natal_kick_array(snstar,3) = theta*180/pi
      endif

* If the system is already disrupted, apply this kick only to the
* exploding star, and skip ahead.
      if(sn.eq.2.and.kick_info(1,2).eq.1)then
         if(snstar.eq.1)then
            kick_info(sn,7) = vk*COS(theta)*SIN(phi)
            kick_info(sn,8) = vk*SIN(theta)*SIN(phi)
            kick_info(sn,9) = vk*COS(phi)
         elseif(snstar.eq.2)then
            kick_info(sn,11) = vk*COS(theta)*SIN(phi)
            kick_info(sn,12) = vk*SIN(theta)*SIN(phi)
            kick_info(sn,13) = vk*COS(phi)
         endif
         GOTO 73
      endif

* CLR - if the orbit has already been kicked, then any polar kick
*       needs to be tilted as well (since L_hat and S_hat are no longer
*       aligned).
* MJZ - to track the total angular change in the binary's orbital plane,
*       we use both the value of \mu and \omega from the first SN.
*       We first rotate by \mu about the x-axis, then by \omega
*       about the z-axis.
*       We do this when the system has already had one SN (sn=2)
*  NOTE: This prescription does not account for realignment between SNe!
      if(sn.eq.2)then
        cmu = COS(kick_info(1,15)*pi/180)
        smu = SIN(kick_info(1,15)*pi/180)
        comega = COS(kick_info(1,16)*pi/180)
        somega = SIN(kick_info(1,16)*pi/180)

        x_tilt = ctheta*cphi*comega + smu*sphi*somega -
     &                   cmu*cphi*stheta*somega
        y_tilt = cmu*cphi*comega*stheta + ctheta*cphi*somega -
     &                   comega*smu*sphi
        z_tilt = cmu*sphi + cphi*smu*stheta

        phi = ASIN(z_tilt)
        sphi = z_tilt
        cphi = COS(phi)
        theta = ATAN(y_tilt/x_tilt)
        stheta = SIN(theta)
        ctheta = COS(theta)
      endif

      if(sep.le.0.d0.or.ecc.lt.0.d0) goto 90

*
* Determine the magnitude of the new relative velocity.
* CLR - fixed a spurious minus sign in the parenthesis here; only
*       relevant for eccentric orbits
      vn2 = vk2+vr2-2.d0*vk*vr*(ctheta*cphi*salpha+stheta*cphi*calpha)
* Calculate the new semi-major axis.
      sep = 2.d0/r - vn2/(gmrkm*(m1n+m2))
      sep = 1.d0/sep
* Determine the magnitude of the cross product of the separation vector
* and the new relative velocity.
      v1 = vk2*sphi*sphi
      v2 = (vk*ctheta*cphi-vr*salpha)**2
      v3 = vk2*stheta*stheta*cphi*cphi
      hn2 = r*r*(v1 + v2)
* Calculate the new eccentricity.
      ecc2 = 1.d0 - hn2/(gmrkm*sep*(m1n+m2))
      ecc2 = MAX(0.d0,ecc2)
      ecc = SQRT(ecc2)
* Calculate the new orbital angular momentum taking care to convert
* hn to units of Rsun^2/yr.
      jorb = (m1n*m2/(m1n+m2))*SQRT(hn2)*(yearsc/rsunkm)
* Determine the polar angle (mu) and azimuthal angle (omega)
* between the new and old orbital angular momentum vectors
      cmu = (vr*salpha-vk*ctheta*cphi)/SQRT(v1 + v2)
      mu = ACOS(cmu)
      smu = SIN(mu)

      comega = (vr*salpha-vk*ctheta*cphi)/SQRT(v3 + v2)
      omega = ACOS(comega)
      somega = SIN(omega)

* Write angle between initial and current orbital angular momentum vectors
* and mean anomaly if system is still bound
      if(sn.eq.1.and.ecc.le.1)then
        kick_info(sn,15) = mu*180/pi
        kick_info(sn,16) = omega*180/pi
        kick_info(sn,6) = mm*180/pi
        if(using_cmc.eq.0)then
            natal_kick_array(snstar,4) = mm*180/pi
        endif
      elseif(sn.eq.2)then
* MJZ - Here we calculate the total change in the orbital plane
*       from both SN. Note that these angles mu and omega are in
*       typical spherical coordinates rather than colateral coordinates,
*       so the rotations are slightly different than above.
*       We rotate about z-axis by omega1 then y-axis by mu1
        cmu1 = COS(kick_info(1,15)*pi/180)
        smu1 = SIN(kick_info(1,15)*pi/180)
        comega1 = COS(kick_info(1,16)*pi/180)
        somega1 = SIN(kick_info(1,16)*pi/180)

        x_tilt = cmu1*comega*comega1*smu + cmu*smu1
     &                - cmu1*smu*somega*somega1
        y_tilt = comega1*smu*somega + comega*smu*somega1
        z_tilt = cmu*cmu1 + smu*smu1*somega*somega1
     &               - comega*comega1*smu*smu1

        kick_info(sn,15) = ACOS(z_tilt)*180/pi
* If both kicks were 0 then x_tilt for SN2 will be 0 since smu=0
        if(x_tilt.eq.0)then
          kick_info(sn,16) = 0
        else
          kick_info(sn,16) = ATAN(y_tilt/x_tilt)*180/pi
        endif
        kick_info(sn,6) = mm*180/pi
        if(using_cmc.eq.0)then
            natal_kick_array(snstar,4) = mm*180/pi
        endif

      endif

* Determine if orbit becomes hyperbolic.
 90   continue

* Calculate systemic velocity
      mx1 = vk*m1n/(m1n+m2)
      mx2 = vr*(m1-m1n)*m2/((m1n+m2)*(m1+m2))
      vs(1) = mx1*ctheta*cphi + mx2*salpha
      vs(2) = mx1*stheta*cphi + mx2*calpha
      vs(3) = mx1*sphi
*
* See if system was disrupted
      if(ecc.gt.1.d0)then
         disrupt = .true.
* Set that it is disrupted in the kick_info array
         kick_info(sn,2) = 1
*
*************************
* Kiel & Hurley method: * Similar to Belczynski et al. (2008) method.
*************************
* Find the semimajor axis and semiminor axis.
*         sepn = hn2/(gmrkm*(m1n+m2)*(ecc*ecc - 1.d0))
         sepn = -sep
*         bb = sqrt(ecc*ecc-1.d0)*sepn
* Direction for hyperbolic velocity in x (csig) and y (ssig).
         csigns = 1.d0/ecc
* Calculate the velocity magnitude at infinity for hyperbolic orbit.
         v1 = SQRT((gmrkm*(m1n+m2))/sepn)
         signs = ACOS(MIN(1.d0,csigns))
         sigc = signs
* Calculating position of NS compared to companion for
* rotation calculation around the z-axis.
         semilatrec = gmrkm*(m1n+m2)
         semilatrec = hn2/semilatrec
         cangleofdeath = (1.d0/ecc)*((semilatrec/r) - 1.d0)
         angleofdeath = ACOS(MIN(1.d0,cangleofdeath))
* Find which hemisphere (in x) the NS/companion originated in...
         psins = angleofdeath
         if((stheta*cphi - calpha).gt.0.d0) psins = -psins
         psic = psins
* Accounting for rotation in x-y plane due to SN event.
         cpsins = COS(signs-psins)
         spsins = SIN(signs-psins)
         cpsic = COS(sigc-psic)
         spsic = SIN(sigc-psic)
* Inverse rotation matrix accounting for our assumed alignment of
* the post-SN orbital angular mometum with the z-axis.
*         RotInvX = vr*salpha + vk*(sphi - ctheta*cphi)
*         mbi = RotInvX
*         RotInvZ = vr*salpha - vk*(ctheta*cphi+sphi)
*         RotInvX = RotInvX/SQRT(RotInvX*RotInvX + RotInvZ*RotInvZ)
*         RotInvZ = RotInvZ/SQRT(mbi*mbi + RotInvZ*RotInvZ)
         RotInvX = cmu
*
         mbi = m1+m2
         mbf = m1n+m2
         mdif = m1 - m1n
* Energy calculation, for interest - should be positive for unbound system.
         energy = vn2/2.d0 - gmrkm*(m1n+m2)/r
*
* Set values in the kick_info array for this disrupted system
* First specify that the system was disrupted from this SN
         kick_info(sn,2) = 1
* Now save the velocity of each star. Note that kick_info[4-6] is for snstar=1.
         if(snstar.eq.1)then
            kick_info(sn,7) = ((m1n/mbf)*vk*ctheta*cphi +
     &           (mdif*m2)/(mbi*mbf)*vr*salpha) -
     &           v1*(spsins)*RotInvX*(m2/mbf)
*
            kick_info(sn,8) = (m1n/mbf)*vk*stheta*cphi +
     &           (mdif*m2)/(mbi*mbf)*vr*calpha -
     &           v1*(cpsins)*(m2/mbf)
*
            kick_info(sn,9) = (m1n/mbf)*vk*sphi
*
            kick_info(sn,11) = ((mdif*m2)/(mbi*mbf)*vr*salpha +
     &           (m1n/mbf)*vk*ctheta*cphi) +
     &           v1*(spsic)*(m1n/mbf)*RotInvX
*
            kick_info(sn,12) = (mdif*m2)/(mbi*mbf)*vr*calpha +
     &           (m1n/mbf)*vk*stheta*cphi +
     &           v1*(cpsic)*(m1n/mbf)
*
            kick_info(sn,13) = (m1n/mbf)*vk*sphi

            bkick(1) = float(snstar)
            bkick(2) = kick_info(sn,7)
            bkick(3) = kick_info(sn,8)
            bkick(4) = kick_info(sn,9)
            bkick(5) = float(snstar)
            bkick(6) = kick_info(sn,11)
            bkick(7) = kick_info(sn,12)
            bkick(8) = kick_info(sn,13)

            if(psins.lt.0.d0)then
               if(r2.gt.sepn*(ecc - 1.d0))then
                  kick_info(sn,7) = vs(1)
                  kick_info(sn,8) = vs(2)
                  kick_info(sn,9) = vs(3)
                  kick_info(sn,11) = 0.d0
                  kick_info(sn,12) = 0.d0
                  kick_info(sn,13) = 0.d0
                  bkick(2) = vs(1)
                  bkick(3) = vs(2)
                  bkick(4) = vs(3)
                  bkick(6) = 0.d0
                  bkick(7) = 0.d0
                  bkick(8) = 0.d0
                  m2 = -1.d0*m2
               endif
            endif
*
         elseif(snstar.eq.2)then
            kick_info(sn,11) = ((m1n/mbf)*vk*ctheta*cphi +
     &           (mdif*m2)/(mbi*mbf)*vr*salpha) -
     &           v1*(spsins)*RotInvX*(m2/mbf)
*
            kick_info(sn,12) = (m1n/mbf)*vk*stheta*cphi +
     &           (mdif*m2)/(mbi*mbf)*vr*calpha -
     &           v1*(cpsins)*(m2/mbf)
*
            kick_info(sn,13) = (m1n/mbf)*vk*sphi
*
            kick_info(sn,7) = ((mdif*m2)/(mbi*mbf)*vr*salpha +
     &           (m1n/mbf)*vk*ctheta*cphi) +
     &           v1*(spsic)*(m1n/mbf)*RotInvX
*
            kick_info(sn,8) = (mdif*m2)/(mbi*mbf)*vr*calpha +
     &           (m1n/mbf)*vk*stheta*cphi +
     &           v1*(cpsic)*(m1n/mbf)
*
            kick_info(sn,9) = (m1n/mbf)*vk*sphi

            bkick(5) = float(snstar)
            bkick(6) = kick_info(sn,11)
            bkick(7) = kick_info(sn,12)
            bkick(8) = kick_info(sn,13)
            bkick(9) = float(snstar)
            bkick(10) = kick_info(sn,7)
            bkick(11) = kick_info(sn,8)
            bkick(12) = kick_info(sn,9)

            if(psins.lt.0.d0)then
               if(r2.gt.sepn*(ecc - 1.d0))then
                  kick_info(sn,7) = vs(1)
                  kick_info(sn,8) = vs(2)
                  kick_info(sn,9) = vs(3)
                  kick_info(sn,11) = 0.d0
                  kick_info(sn,12) = 0.d0
                  kick_info(sn,13) = 0.d0
                  bkick(6) = vs(1)
                  bkick(7) = vs(2)
                  bkick(8) = vs(3)
                  bkick(10) = 0.d0
                  bkick(11) = 0.d0
                  bkick(12) = 0.d0
                  m2 = -1.d0*m2
               endif
            endif
*
         endif
         ecc = MIN(ecc,99.99d0)
      endif
*
* If system survives the SN, save the components of the change in
* centre-of-mass velocity
      if(ecc.lt.1.d0)then
         kick_info(sn,7) = vs(1)
         kick_info(sn,8) = vs(2)
         kick_info(sn,9) = vs(3)
         kick_info(sn,11) = 0
         kick_info(sn,12) = 0
         kick_info(sn,13) = 0
      endif

      if(ecc.lt.1.d0)then
*         if(ecc.eq.1.d0.or.ecc.lt.0.d0) m2 = -1.d0 * m2
* 1st time with kick.
         if(bkick(1).le.0.d0)then
            bkick(1) = float(snstar)
            bkick(2) = vs(1)
            bkick(3) = vs(2)
            bkick(4) = vs(3)
* 2nd time with kick.
         elseif(bkick(5).le.0.d0)then
            bkick(5) = float(snstar)
            bkick(6) = vs(1)
            bkick(7) = vs(2)
            bkick(8) = vs(3)
* 2nd time with kick if already disrupted.
* MJZ - would this if statement ever be hit?
         elseif(bkick(5).gt.0.d0)then
            bkick(9) = float(snstar)
            bkick(10) = vs(1)
            bkick(11) = vs(2)
            bkick(12) = vs(3)
         endif
      endif

* In the impossible chance that the system is exactly parabolic...
      if(ecc.eq.1.d0.and.snstar.eq.1)then
         kick_info(sn,7) = vs(1)
         kick_info(sn,8) = vs(2)
         kick_info(sn,9) = vs(3)
         kick_info(sn,11) = -vs(1)
         kick_info(sn,12) = -vs(2)
         kick_info(sn,13) = -vs(3)
         bkick(1) = float(snstar)
         bkick(2) = vs(1)
         bkick(3) = vs(2)
         bkick(4) = vs(3)
         bkick(5) = float(snstar)
         bkick(6) = -vs(1)
         bkick(7) = -vs(2)
         bkick(8) = -vs(3)
      elseif(ecc.eq.1.d0.and.snstar.eq.2)then
         kick_info(sn,7) = -vs(1)
         kick_info(sn,8) = -vs(2)
         kick_info(sn,9) = -vs(3)
         kick_info(sn,11) = vs(1)
         kick_info(sn,12) = vs(2)
         kick_info(sn,13) = vs(3)
         bkick(5) = float(snstar)
         bkick(6) = vs(1)
         bkick(7) = vs(2)
         bkick(8) = vs(3)
         bkick(9) = float(snstar)
         bkick(10) = -vs(1)
         bkick(11) = -vs(2)
         bkick(12) = -vs(3)
      endif

* Uncomment to randomly rotate system velocities
      CALL randomness3(idum1,
     &            kick_info(sn,7),kick_info(sn,8),kick_info(sn,9),
     &            kick_info(sn,11),kick_info(sn,12),kick_info(sn,13))
*
* Put a cap on the eccentricity
      if(ecc.gt.99.9d0) ecc = 99.9d0

* For systems that were distrupted in the first SN, skip to here
 73   continue
*
* Set systemic velocity magnitudes in the kick_info array
* For first SN, this should be identical to the magnitude
* of the three component vectors. For the second SN, this
* will be the systemic velocity relative to the initial frame.
      if(sn.eq.1)then
         kick_info(sn,10) = SQRT(kick_info(sn,7)*kick_info(sn,7) +
     &              kick_info(sn,8)*kick_info(sn,8) +
     &              kick_info(sn,9)*kick_info(sn,9))
         kick_info(sn,14) = SQRT(kick_info(sn,11)*kick_info(sn,11) +
     &              kick_info(sn,12)*kick_info(sn,12) +
     &              kick_info(sn,13)*kick_info(sn,13))
      elseif(sn.eq.2)then
         kick_info(sn,10) = SQRT(
     &      (kick_info(1,7)+kick_info(2,7))*
     &      (kick_info(1,7)+kick_info(2,7)) +
     &      (kick_info(1,8)+kick_info(2,8))*
     &      (kick_info(1,8)+kick_info(2,8)) +
     &      (kick_info(1,9)+kick_info(2,9))*
     &      (kick_info(1,9)+kick_info(2,9)))
         kick_info(sn,14) = SQRT(
     &      (kick_info(1,11)+kick_info(2,11))*
     &      (kick_info(1,11)+kick_info(2,11)) +
     &      (kick_info(1,12)+kick_info(2,12))*
     &      (kick_info(1,12)+kick_info(2,12)) +
     &      (kick_info(1,13)+kick_info(2,13))*
     &      (kick_info(1,13)+kick_info(2,13)))
      endif

* Write some output information
*
      RETURN
      END
***
      SUBROUTINE randomness3(idum,vx1,vy1,vz1,vx2,vy2,vz2)
*
      implicit none
*
      INTEGER idum
      real ran3
      external ran3
      REAL*8 vx1,vy1,vz1,alpha,gamma,beta,pi,twopi,vx2,vy2,vz2
      REAL*8 cg,sg,ca,sa,cb,sb,vx1s,vy1s,vz1s,vx2s,vy2s,vz2s
*
* Introduce random orientation of binary system to the Galaxy/GC... u bastard.
*
      pi = ACOS(-1.d0)
      twopi = 2.d0*pi
      alpha = twopi*ran3(idum) - pi
      gamma = twopi*ran3(idum) - pi
      beta = pi*ran3(idum) - (pi/2.d0)
*      write(80,*)alpha,gamma,beta
      cg = COS(gamma)
      sg = SIN(gamma)
      ca = COS(alpha)
      sa = SIN(alpha)
      cb = COS(beta)
      sb = SIN(beta)
*
* Randomized orientation
*
      vx1s = vx1
      vy1s = vy1
      vz1s = vz1
      vx2s = vx2
      vy2s = vy2
      vz2s = vz2
* theta = b, phi = a, g = psi; pitch-roll-yaw; z-y-x axis rotations
      vx1 = vx1s*(cb*ca)
      vx1 = vx1 + vy1s*(cb*sa)
      vx1 = vx1 - vz1s*sb
*
      vy1 = vx1s*(sg*sb*ca - cg*sa)
      vy1 = vy1 + vy1s*(sg*sb*sa + cg*ca)
      vy1 = vy1 + vz1s*(cb*sg)
*
      vz1 = vx1s*(cg*sb*ca + sg*sa)
      vz1 = vz1 + vy1s*(cg*sb*sa - sg*ca)
      vz1 = vz1 + vz1s*(cb*cg)
**
**
      vx2 = vx2s*(cb*ca)
      vx2 = vx2 + vy2s*(cb*sa)
      vx2 = vx2 - vz2s*sb
*
      vy2 = vx2s*(sg*sb*ca - cg*sa)
      vy2 = vy2 + vy2s*(sg*sb*sa + cg*ca)
      vy2 = vy2 + vz2s*(cb*sg)
*
      vz2 = vx2s*(cg*sb*ca + sg*sa)
      vz2 = vz2 + vy2s*(cg*sb*sa - sg*ca)
      vz2 = vz2 + vz2s*(cb*cg)
**
*
      RETURN
      END
*

***
      SUBROUTINE hrdiag_remnant(zpars,mt,mc,lum,r,aj,kw)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
      
      real*8 zpars(20)

      real*8 mt,mc,lum,r,aj
      integer kw

      real*8 mch,mchold
      real*8 xx,fac,ahe,aco
      parameter(ahe=4.d0,aco=16.d0)

      
* input mc(or mcmax),mass
* output mt, kw, mc, mass,bhspin
* common: mch, mxns,
* ifflag,ecsn (or mc1), ecsn_low(mc2), bhspinflag,
*  bhspinmag,  Mbh_initial

         mch = 1.44d0 !set here owing to AIC ECSN model.

         if(kw.ge.10.and.kw.le.12)then
*
*        White dwarf.
*
         mc = mt
         mchold = mch
         if(ecsn.gt.0.d0.and.kw.eq.12) mch = 1.38d0
         if(mc.ge.mch)then
*
* Accretion induced supernova with no remnant
* unless WD is ONe in which case we assume a NS
* of minimum mass is the remnant.
*
            if(kw.eq.12)then
               kw = 13
               aj = 0.d0
               mt = 1.3d0
               if(ecsn.gt.0.d0)then
                  mt = 1.38d0
                  mt = 0.9d0*mt !in ST this is a quadratic, will add in later.
               endif
            else
               kw = 15
               aj = 0.d0
               mt = 0.d0
               lum = 1.0d-10
               r = 1.0d-10
            endif
         else
*
            if(kw.eq.10)then
               xx = ahe
            else
               xx = aco
            endif
*
            if(wdflag.eq.0)then
*
* Mestel cooling
*
               lum = 635.d0*mt*zpars(14)/(xx*(aj+0.1d0))**1.4d0
*
            elseif(wdflag.ge.1)then
*
* modified-Mestel cooling
*
               if(aj.lt.9000.0)then
                  lum = 300.d0*mt*zpars(14)/(xx*(aj+0.1d0))**1.18d0
               else
                  fac = (9000.1d0*xx)**5.3d0
                  lum = 300.d0*fac*mt*zpars(14)/(xx*(aj+0.1d0))**6.48d0
               endif
*
            endif
*
            r = 0.0115d0*SQRT(MAX(1.48204d-06,(mch/mt)**(2.d0/3.d0)
     &                                      - (mt/mch)**(2.d0/3.d0)))
            r = MIN(0.1d0,r)
            if(mt.lt.0.0005d0) r = 0.09d0
            if(mt.lt.0.000005d0) r = 0.009d0
*
         endif
         mch = mchold !added for AIC ECSN stuff.
      endif
*
      if(kw.eq.13)then
*
*        Neutron Star.
*
         mc = mt
         if(mc.gt.mxns)then
*
* Accretion induced Black Hole?
*
            kw = 14
            aj = 0.d0
         else
            lum = 0.02d0*(mt**0.67d0)/(MAX(aj,0.1d0))**2
            r = 1.4d-05
         endif
      endif
*
      if(kw.eq.14)then
*
*        Black hole
*
         mc = mt
* Store the initial BH mass for calculating the ISCO later
         if(Mbh_initial.eq.0)then
            Mbh_initial = mt
         endif
         lum = 1.0d-10
         r = 4.24d-06*mt
      endif
*
      !added by PA
      if(kw .eq.15) then
*
*         Massless remnant
*
          aj = 0.d0
          mt = 0.d0
          lum = 1.0d-10
          r = 1.0d-10
      endif
*
      end

***
      SUBROUTINE COMENV(M01,M1,MC1,AJ1,JSPIN1,KW1,
     &                  M02,M2,MC2,AJ2,JSPIN2,KW2,
     &                  ZPARS,ECC,SEP,JORB,COEL,star1,star2,vk,
     &                  kick_info,formation1,formation2,sigmahold,
     &                  bhspin1,bhspin2,binstate,mergertype,
     &                  jp,tphys,switchedCE,rad,tms,evolve_type,disrupt,
     &                  lumin,B_0,bacc,tacc,epoch,menv_bpp,renv_bpp,
     &                  bkick)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
* Common Envelope Evolution.
*
*     Author : C. A. Tout
*     Date :   18th September 1996
*
*     Redone : J. R. Hurley
*     Date :   7th July 1998
*
*     Update : P. D. Kiel (for ECSN, fallback and bugs)
*     Date : cmc version mid 2010
*
*
      INTEGER KW1,KW2,KW,KW1i,KW2i,snp
      INTEGER star1,star2
      INTEGER binstate,mergertype
*
      REAL*8 M01,M1,MC1,AJ1,JSPIN1,R1,L1,K21
      REAL*8 M02,M2,MC2,AJ2,JSPIN2,R2,L2,K22,MC22
      REAL*8 TSCLS1(20),TSCLS2(20),LUMS(10),GB(10),TM1,TM2,TN,ZPARS(20)
      REAL*8 EBINDI,EBINDF,EORBI,EORBF,ECIRC,SEPF,SEPL,MF,XX
      REAL*8 SEP_postCE, M_postCE
      REAL*8 CONST,DELY,DERI,DELMF,MC3,FAGE1,FAGE2
      REAL*8 ECC,SEP,JORB,TB,OORB,OSPIN1,OSPIN2,TWOPI
      REAL*8 RC1,RC2,Q1,Q2,RL1,RL2,LAMB1,LAMB2
      REAL*8 MENV,RENV,MENVD,RZAMS,vk
      REAL*8 Porbi,Porbf,Mcf,Menvf,qi,qf,G
      REAL*8 kick_info(2,17),fallback,M1i,M2i
      REAL*8 bkick(20)
      REAL*8 bhspin1,bhspin2
      common /fall/fallback
      INTEGER formation1,formation2
      REAL*8 sigmahold
      REAL*8 AURSUN,K3
      PARAMETER (AURSUN = 214.95D0,K3 = 0.21D0)
      LOGICAL COEL,output
      REAL*8 CELAMF,RL,RZAMSF
      EXTERNAL CELAMF,RL,RZAMSF
      INTEGER jp
      REAL*8 tphys
      LOGICAL switchedCE,disrupt
      INTEGER kstar1_bpp,kstar2_bpp
      REAL*8 mass1_bpp,mass2_bpp
      REAL*8 rrl1_bpp,rrl2_bpp,evolve_type
      REAL*8 aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp
      REAL*8 massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp
      REAL*8 q1_bpp,q2_bpp,teff1,teff2
      REAL*8 KW1_TEMP, KW2_TEMP
      REAL*8 rad(2),tms(2),lumin(2),B_0(2),bacc(2),tacc(2),epoch(2)
      REAL*8 menv_bpp(2),renv_bpp(2)
*
* Initialize
*

      aj1_bpp = 0.d0
      aj2_bpp = 0.d0
      massc1_bpp = 0.d0
      massc2_bpp = 0.d0

      if(using_cmc.eq.0) then
         tms1_bpp = tms(1)
         tms2_bpp = tms(2)
         rad1_bpp = rad(1)
         rad2_bpp = rad(2)
      endif

*
* Common envelope evolution - entered only when KW1 = 2, 3, 4, 5, 6, 8 or 9.
*
* For simplicity energies are divided by -G.
*
      TWOPI = 2.D0*ACOS(-1.D0)
      COEL = .FALSE.
      snp = 0
      output = .false.
*
* Obtain the core masses and radii.
*
      KW = KW1
      CALL star(KW1,M01,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS)
      CALL hrdiag(M01,AJ1,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS,
     &            R1,L1,KW1,MC1,RC1,MENV,RENV,K21,
     &            bhspin1,star1)
      OSPIN1 = JSPIN1/(K21*R1*R1*(M1-MC1)+K3*RC1*RC1*MC1)
      MENVD = MENV/(M1-MC1)
      RZAMS = RZAMSF(M01)
*
* Decide which CE prescription to use based on LAMBDA flag
* MJZ: NOTE - Nanjing lambda prescription DOES NOT WORK!
*
      LAMB1 = CELAMF(KW,M01,L1,R1,RZAMS,MENVD,LAMBDAF)
      KW = KW2
      CALL star(KW2,M02,M2,TM2,TN,TSCLS2,LUMS,GB,ZPARS)
      CALL hrdiag(M02,AJ2,M2,TM2,TN,TSCLS2,LUMS,GB,ZPARS,
     &            R2,L2,KW2,MC2,RC2,MENV,RENV,K22,
     &            bhspin2,star2)
      OSPIN2 = JSPIN2/(K22*R2*R2*(M2-MC2)+K3*RC2*RC2*MC2)
*
* Calculate the binding energy of the giant envelope (multiplied by lambda).
*
      EBINDI = M1*(M1-MC1)/(LAMB1*R1)
*
* If the secondary star is also giant-like add its envelopes energy.
* Determine EORBI based on CEFLAG (CEFLAG=1 for de Kool prescription)
*
      IF(KW2.GE.2.AND.KW2.LE.9.AND.KW2.NE.7)THEN
         MENVD = MENV/(M2-MC2)
         RZAMS = RZAMSF(M02)
         LAMB2 = CELAMF(KW,M02,L2,R2,RZAMS,MENVD,LAMBDAF)
         EBINDI = EBINDI + M2*(M2-MC2)/(LAMB2*R2)
*
* Calculate the initial orbital energy
*
         IF(CEFLAG.EQ.0) EORBI = MC1*MC2/(2.D0*SEP)
         IF(CEFLAG.EQ.1) EORBI = M1*M2/(2.D0*SEP)
      ELSE
         IF(CEFLAG.EQ.0) EORBI = MC1*M2/(2.D0*SEP)
         IF(CEFLAG.EQ.1) EORBI = M1*M2/(2.D0*SEP)
      ENDIF
      if(output) write(*,*)'Init CE:',M01,M1,R1,M02,M2,R2,EBINDI,EORBI
*
* Allow for an eccentric orbit.
*
      ECIRC = EORBI/(1.D0 - ECC*ECC)
*
* Calculate the final orbital energy without coalescence.
*
      EORBF = EORBI + EBINDI/ALPHA1
*
* If the secondary is on the main sequence see if it fills its Roche lobe.
*
      IF(KW2.LE.1.OR.KW2.EQ.7)THEN
         SEPF = MC1*M2/(2.D0*EORBF)
         Q1 = MC1/M2
         Q2 = 1.D0/Q1
         RL1 = RL(Q1)
         RL2 = RL(Q2)
*
* If cemergeflag is set, cause kstars without clear core-envelope
* structure to merge automatically if they enter a CE
*
         IF(cemergeflag.eq.1)THEN
            if(KW1.eq.0.or.KW1.eq.1.or.KW1.eq.2.or.KW1.eq.7.or.
     &         KW1.eq.8.or.KW1.eq.10.or.KW1.eq.11.or.KW1.eq.12)then
                  COEL = .TRUE.
                  SEPL = RC1/RL1
                  binstate = 1
                  CALL CONCATKSTARS(KW1, KW2, mergertype)
            endif
         ENDIF
*
* The helium core of a very massive star of type 4 may actually fill
* its Roche lobe in a wider orbit with a very low-mass secondary.
*
         IF(RC1/RL1.GE.R2/RL2)THEN
            IF(RC1.GT.RL1*SEPF)THEN
               COEL = .TRUE.
               SEPL = RC1/RL1
               binstate = 1
               CALL CONCATKSTARS(KW1, KW2, mergertype)
            ENDIF
         ELSE
            IF(R2.GT.RL2*SEPF)THEN
               COEL = .TRUE.
               SEPL = R2/RL2
               binstate = 1
               CALL CONCATKSTARS(KW1, KW2, mergertype)
            ENDIF
         ENDIF
         IF(COEL)THEN
*
            KW = KTYPE(KW1,KW2) - 100
            MC3 = MC1
            IF(KW2.EQ.7.AND.KW.EQ.4) MC3 = MC3 + M2
*
* Coalescence - calculate final binding energy.
*
            EORBF = MAX(MC1*M2/(2.D0*SEPL),EORBI)
            EBINDF = EBINDI - ALPHA1*(EORBF - EORBI)
            KW1_TEMP = KW
            KW2_TEMP = 15
         ELSE
*
* Primary becomes a black hole, neutron star, white dwarf or helium star.
*
            MF = M1
            M1 = MC1
            KW1i = KW1
            KW2i = KW2
            M1i = M1
*
* Choose which masses and separations to use in SN based on cekickflag
*
            IF(cekickflag.eq.0)then
               SEP_postCE=SEPF
               M_postCE=MF
            ELSEIF(cekickflag.eq.1)then
               SEP_postCE=SEP
               M_postCE=MF
            ELSEIF(cekickflag.eq.2)then
               SEP_postCE=SEPF
               M_postCE=MC1
            ENDIF

            CALL star(KW1,M01,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS)
            CALL hrdiag(M01,AJ1,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS,
     &                  R1,L1,KW1,MC1,RC1,MENV,RENV,K21,
     &                  bhspin1,star1)
            IF(KW1.GE.13)THEN
               formation1 = 1
               if(KW1.eq.13.and.ecsn.gt.0.d0)then
                  if(KW1i.le.6)then
                     if(M1i.le.zpars(5))then
                        if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                           sigma = -sigmahold/sigmadiv
                        elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                           sigma = sigmadiv
                        endif
                        formation1 = 2
                     endif
                  elseif(KW1i.ge.7.and.KW1i.le.9)then
                     if(M1i.gt.ecsn_mlow.and.M1i.le.ecsn)then
* BSE orgi: 1.6-2.25, Pod: 1.4-2.5, StarTrack: 1.83-2.25 (all in Msun)
                        if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                           sigma = -sigmahold/sigmadiv
                        elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                           sigma = sigmadiv
                        endif
                        formation1 = 2
                     endif
                  elseif(formation1.eq.11)then
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation1 = 5
                  elseif(KW1i.ge.10.or.KW1i.eq.12)then
* AIC formation, will never happen here but...
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation1 = 4
                  endif
               endif
*              Check if M1 and M2 were switched on pass to comenv
               if(switchedCE)then
                   mass1_bpp = M2
                   mass2_bpp = M_postCE
                   massc1_bpp = MC2
                   massc2_bpp = MC1

                   kstar1_bpp = KW2i
                   kstar2_bpp = KW1i
                   q1_bpp = mass1_bpp/mass2_bpp
                   q2_bpp = 1.d0/q1_bpp
                   rrl1_bpp = R2/(RL(q1_bpp)*SEP_postCE)
                   rrl2_bpp = RC1/(RL(q2_bpp)*SEP_postCE)
                   aj1_bpp = AJ2
                   aj2_bpp = AJ1

                   evolve_type = 16.0d0

               else
                   mass1_bpp = M_postCE
                   mass2_bpp = M2
                   massc1_bpp = MC1
                   massc2_bpp = MC2

                   kstar1_bpp = KW1i
                   kstar2_bpp = KW2i
                   q1_bpp = mass1_bpp/mass2_bpp
                   q2_bpp = 1.d0/q1_bpp
                   rrl1_bpp = RC1/(RL(q1_bpp)*SEP_postCE)
                   rrl2_bpp = R2/(RL(q2_bpp)*SEP_postCE)
                   evolve_type = 15.0d0
                   aj1_bpp = AJ1
                   aj2_bpp = AJ2
               endif
               TB = (SEP_postCE/AURSUN)*
     &               SQRT(SEP_postCE/(AURSUN*(M_postCE+M2)))
               if(using_cmc.eq.0)then
                   if(switchedCE)then
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0)) 
                       CALL writebpp(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,SEP_postCE,TB,ECC,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M02,M01,lumin(2),lumin(1),teff2,teff1,
     &                      RC2,RC1,menv_bpp(2),menv_bpp(1),renv_bpp(2),
     &                      renv_bpp(1),OSPIN2,OSPIN1,B_0(2),B_0(1),
     &                      bacc(2),bacc(1),tacc(2),tacc(1),epoch(2),
     &                      epoch(1),bhspin2,bhspin1)
                   else
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0))
                       CALL writebpp(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,SEP_postCE,TB,ECC,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M01,M02,lumin(1),lumin(2),teff1,teff2,
     &                      RC1,RC2,menv_bpp(1),menv_bpp(2),renv_bpp(1),
     &                      renv_bpp(2),OSPIN1,OSPIN2,B_0(1),B_0(2),
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin1,bhspin2)
                   endif
               endif
               CALL kick(KW1,M_postCE,M1,M2,ECC,SEP_postCE,
     &                   JORB,vk,star1,R2,fallback,sigmahold,
     &                   kick_info,disrupt,bkick)
* Returning variable state to original naming convention
               MF = M_postCE
               SEPF = SEP_postCE
               snp = 1
               if(M2.lt.0.d0)then
                  if(KW2.ge.10) M1 = M1-M2
                  MC1 = M1
                  MC2 = 0.D0
                  bhspin2 = 0.D0
                  M2 = 0.D0
                  KW2 = 15
                  AJ1 = 0.D0
                  COEL = .true.
                  GOTO 30
               endif
               IF(ECC.GT.1.D0) GOTO 30
            ENDIF
         ENDIF
      ELSE
*
* Degenerate or giant secondary. Check if the least massive core fills its
* Roche lobe.
*
         SEPF = MC1*MC2/(2.D0*EORBF)
         Q1 = MC1/MC2
         Q2 = 1.D0/Q1
         RL1 = RL(Q1)
         RL2 = RL(Q2)
*
* If cemergeflag is set, cause kstars without clear core-envelope
* structure to merge automatically if they enter a CE
*
         IF(cemergeflag.eq.1)THEN
            if(KW1.eq.0.or.KW1.eq.1.or.KW1.eq.2.or.KW1.eq.7.or.
     &         KW1.eq.8.or.KW1.eq.10.or.KW1.eq.11.or.KW1.eq.12)then
                  COEL = .TRUE.
                  SEPL = RC1/RL1
                  binstate = 1
                  CALL CONCATKSTARS(KW1, KW2, mergertype)
            endif
         ENDIF
         IF(RC1/RL1.GE.RC2/RL2)THEN
            IF(RC1.GT.RL1*SEPF)THEN
               COEL = .TRUE.
               SEPL = RC1/RL1
               binstate = 1
               CALL CONCATKSTARS(KW1, KW2, mergertype)
            ENDIF
         ELSE
            IF(RC2.GT.RL2*SEPF)THEN
               COEL = .TRUE.
               SEPL = RC2/RL2
               binstate = 1
               CALL CONCATKSTARS(KW1, KW2, mergertype)
            ENDIF
         ENDIF
*
         IF(COEL)THEN
*
* If the secondary was a neutron star or black hole the outcome
* is an unstable Thorne-Zytkow object that leaves only the core.
*
            SEPF = 0.D0
            IF(KW2.GE.13)THEN
               MC1 = MC2
               M1 = MC1
               MC2 = 0.D0
               M2 = 0.D0
               KW1 = KW2
               KW2 = 15
               bhspin1 = bhspin2
               bhspin2 = 0.d0
               AJ1 = 0.D0
*
* The envelope mass is not required in this case.
*
               GOTO 30
            ENDIF
*
            KW = KTYPE(KW1,KW2) - 100
            MC3 = MC1 + MC2
*
* Calculate the final envelope binding energy.
*
            EORBF = MAX(MC1*MC2/(2.D0*SEPL),EORBI)
            EBINDF = EBINDI - ALPHA1*(EORBF - EORBI)
            if(output) write(*,*)'In dg or giant 1:',M01,M1,R1,M02,M2,
     & R2,MC1,MC2,MC3,KW1,KW2,KW,EORBF,EBINDF
*
* Check if we have the merging of two degenerate cores and if so
* then see if the resulting core will survive or change form.
*
            IF(KW1.EQ.6.AND.(KW2.EQ.6.OR.KW2.GE.11))THEN
               CALL dgcore(KW1,KW2,KW,MC1,MC2,MC3,EBINDF)
               if(output) write(*,*)'dg/giant 2:',KW,MC1,MC2,MC3,EBINDF
            ENDIF
            IF(KW1.LE.3.AND.M01.LE.ZPARS(2))THEN
               IF((KW2.GE.2.AND.KW2.LE.3.AND.M02.LE.ZPARS(2)).OR.
     &             KW2.EQ.10)THEN
                  CALL dgcore(KW1,KW2,KW,MC1,MC2,MC3,EBINDF)
                  if(output) write(*,*)'dg/giant 2:',KW,MC1,MC2,MC3,
     & EBINDF
                  IF(KW.GE.10)THEN
                     KW1 = KW
                     M1 = MC3
                     MC1 = MC3
                     IF(KW.LT.15) M01 = MC3
                     AJ1 = 0.D0
                     MC2 = 0.D0
                     M2 = 0.D0
                     KW2 = 15
                     binstate = 2
                     mergertype = -1
                     GOTO 30
                  ENDIF
               ENDIF
            ENDIF
*
         ELSE
*
* The cores do not coalesce - assign the correct masses and ages.
*
            MF = M1
            M1 = MC1
            KW1i = KW1
            KW2i = KW2
            M1i = M1
*
* Choose which masses and separations to use in SN based on cekickflag
*
            IF(cekickflag.eq.0)then
               SEP_postCE=SEPF
               M_postCE=MF
            ELSEIF(cekickflag.eq.1)then
               SEP_postCE=SEP
               M_postCE=MF
            ELSEIF(cekickflag.eq.2)then
               SEP_postCE=SEPF
               M_postCE=MC1
            ENDIF
*
* If cehestarflag is specified, determine the post-CE separation and/or
* mass for He-star/compact object system according to Tauris+2015
*
            IF(KW1.ge.7.and.KW1.le.9.and.KW2.ge.13)THEN
                if(cehestarflag.ne.0)then
* calculate G in Rsun/Msun/days, and initial Porb in days
                    G = 2957.45d+0
                    Porbi = (TWOPI/(G*(MF+M2))**(1d0/2d0)) *
     &                  SEP**(3d0/2d0)
                    Mcf = (1d0/(400d0*Porbi)+0.49d0)*MF -
     &                  ((0.016d0/Porbi) - 0.106d0)
                    if(Porbi.le.2d0.and.Porbi.gt.0.06d0)then
                        Menvf = 0.18d0*Porbi**(0.45d0) *
     &                      (LOG(Mcf**4d0) - 1.05d0)
                    elseif(Porbi.gt.2.d0)then
                        Menvf = Mcf*(LOG(Porbi**(-0.2d0))+1) +
     &                      LOG(Porbi**(0.5d0))-1.5d0
                    elseif(Porbi.le.0.06d0)then
*                       outside range of validity, use BSE masses
                        Menvf = 0d0
                        Mcf = MC1
                    endif
                    qi = MF/M2
* if cehestarflag is 1, use BSEs calculation of post-CE core mass
                    if(cehestarflag.eq.1)then
                        M_postCE = MC1
                        qf = MC1/M2
* elseif cehestarflag is 2, use Tauris fitting formula for post-CE mass
                    elseif(cehestarflag.eq.2)then
*                   first, check that the mass is more than core mass
                        if((Mcf+Menvf).lt.MC1)then
                           M_postCE = MC1
                        else
                           M_postCE = (Mcf+Menvf)
                        endif
                        qf = (Mcf+Menvf)/M2
                    endif
                    Porbf = (((qi+1)/(qf+1))**(2d0) * (qi/qf)**(3d0) *
     &                      EXP(3d0*(qf-qi))) * Porbi
                    SEP_postCE = (G*(M_postCE+M2) / (TWOPI**(2d0)) *
     &                      Porbf**(2d0))**(1d0/3d0)
                endif
            ENDIF

            CALL star(KW1,M01,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS)
            CALL hrdiag(M01,AJ1,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS,
     &                  R1,L1,KW1,MC1,RC1,MENV,RENV,K21,
     &                  bhspin1,star1)
            IF(KW1.GE.13)THEN
               formation1 = 1
               if(KW1.eq.13.and.ecsn.gt.0.d0)then
                  if(KW1i.le.6)then
                     if(M1i.le.zpars(5))then
                        if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                           sigma = -sigmahold/sigmadiv
                        elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                           sigma = sigmadiv
                        endif
                        formation1 = 2
                     endif
                  elseif(KW1i.ge.7.and.KW1i.le.9)then
                     if(M1i.gt.ecsn_mlow.and.M1i.le.ecsn)then
* BSE orgi: 1.6-2.25, Pod: 1.4-2.5, StarTrack: 1.83-2.25 (all in Msun)
                        if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                           sigma = -sigmahold/sigmadiv
                        elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                           sigma = sigmadiv
                        endif
                        formation1 = 2
                     endif
                  elseif(formation1.eq.11)then
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation1 = 5
                  elseif(KW1i.ge.10.or.KW1i.eq.12)then
* AIC formation, will never happen here but...
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation1 = 4
                  endif
               endif
*              Check if M1 and M2 were switched on pass to comenv
               if(switchedCE)then
                   mass1_bpp = M2
                   mass2_bpp = M_postCE
                   massc1_bpp = MC2
                   massc2_bpp = MC1

                   kstar1_bpp = KW2i
                   kstar2_bpp = KW1i
                   q1_bpp = mass1_bpp/mass2_bpp
                   q2_bpp = 1.d0/q1_bpp
                   rrl1_bpp = R2/(RL(q1_bpp)*SEP_postCE)
                   rrl2_bpp = RC1/(RL(q2_bpp)*SEP_postCE)
                   aj1_bpp = AJ2
                   aj2_bpp = AJ1
                   evolve_type = 16.d0

               else
                   mass1_bpp = M_postCE
                   mass2_bpp = M2
                   massc1_bpp = MC1
                   massc2_bpp = MC2

                   kstar1_bpp = KW1i
                   kstar2_bpp = KW2i
                   q1_bpp = mass1_bpp/mass2_bpp
                   q2_bpp = 1.d0/q1_bpp
                   rrl1_bpp = RC1/(RL(q1_bpp)*SEP_postCE)
                   rrl2_bpp = R2/(RL(q2_bpp)*SEP_postCE)
                   aj1_bpp = AJ1
                   aj2_bpp = AJ2
                   evolve_type = 15.0d0
               endif
               TB = (SEP_postCE/AURSUN)*
     &               SQRT(SEP_postCE/(AURSUN*(M_postCE+M2)))
               if(using_cmc.eq.0)then
                   if(switchedCE)then
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0))
                       CALL writebpp(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,SEP_postCE,TB,ECC,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M02,M01,lumin(2),lumin(1),teff2,teff1,
     &                      RC2,RC1,menv_bpp(2),menv_bpp(1),renv_bpp(2),
     &                      renv_bpp(1),OSPIN2,OSPIN1,B_0(2),B_0(1),
     &                      bacc(2),bacc(1),tacc(2),tacc(1),epoch(2),
     &                      epoch(1),bhspin2,bhspin1)
                   else
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0))
                       CALL writebpp(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,SEP_postCE,TB,ECC,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M01,M02,lumin(1),lumin(2),teff1,teff2,
     &                      RC1,RC2,menv_bpp(1),menv_bpp(2),renv_bpp(1),
     &                      renv_bpp(2),OSPIN1,OSPIN2,B_0(1),B_0(2),
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin1,bhspin2)
                   endif
               endif
* USSN: if ussn flag is set, have reduced kicks for stripped He stars (SN=8)
               if(KW1.eq.13.and.KW2.ge.13.and.ussn.eq.1)then
                  if(KW1i.ge.7.and.KW1i.le.9)then
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                  formation1 = 3
                  endif
               endif
               CALL kick(KW1,M_postCE,M1,M2,ECC,SEP_postCE,
     &                   JORB,vk,star1,R2,fallback,sigmahold,
     &                   kick_info,disrupt,bkick)
* Returning variable state to original naming convention
               MF = M_postCE
               SEPF = SEP_postCE
               snp = 1
               if(M2.lt.0.d0)then
                  if(KW2.ge.10) M1 = M1-M2
                  MC1 = M1
                  MC2 = 0.D0
                  M2 = 0.D0
                  KW2 = 15
                  AJ1 = 0.D0
                  COEL = .true.
                  GOTO 30
               endif
               IF(ECC.GT.1.D0) GOTO 30
            ENDIF
            MF = M2
            KW = KW2
            M2 = MC2
            KW1i = KW1
            KW2i = KW2
            M2i = M2
*
* Choose which masses and separations to use in SN based on cekickflag
*
            IF(cekickflag.eq.0)then
               SEP_postCE=SEPF
               M_postCE=MF
            ELSEIF(cekickflag.eq.1)then
               SEP_postCE=SEP
               M_postCE=MF
            ELSEIF(cekickflag.eq.2)then
               SEP_postCE=SEPF
               M_postCE=MC2
            ENDIF

            CALL star(KW2,M02,M2,TM2,TN,TSCLS2,LUMS,GB,ZPARS)
            CALL hrdiag(M02,AJ2,M2,TM2,TN,TSCLS2,LUMS,GB,ZPARS,
     &                  R2,L2,KW2,MC2,RC2,MENV,RENV,K22,
     &                  bhspin2,star2)
            IF(KW2.GE.13.AND.KW.LT.13)THEN
               formation2 = 1
               if(KW2.eq.13.and.ecsn.gt.0.d0)then
                  if(KW2i.le.6)then
                     if(M2i.le.zpars(5))then
                        if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                           sigma = -sigmahold/sigmadiv
                        elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                           sigma = sigmadiv
                        endif
                        formation2 = 2
                     endif
                  elseif(KW2i.ge.7.and.KW2i.le.9)then
                     if(M2i.gt.ecsn_mlow.and.M2i.le.ecsn)then
* BSE orgi: 1.6-2.25, Pod: 1.4-2.5, StarTrack: 1.83-2.25 (all in Msun)
                        if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                           sigma = -sigmahold/sigmadiv
                        elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                           sigma = sigmadiv
                        endif
                        formation2 = 2
                     endif
                  elseif(formation2.eq.11)then
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation2 = 5
                  elseif(KW2i.ge.10.or.KW2i.eq.12)then
* AIC formation, will never happen here but...
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation2 = 4
                  endif
               endif
*              Check if M1 and M2 were switched on pass to comenv
               if(switchedCE)then
                   mass1_bpp = M_postCE
                   mass2_bpp = M1
                   massc1_bpp = MC2
                   massc2_bpp = MC1

                   kstar1_bpp = KW2i
                   kstar2_bpp = KW1i
                   q1_bpp = mass1_bpp/mass2_bpp
                   q2_bpp = 1.d0/q1_bpp
                   rrl1_bpp = RC2/(RL(q1_bpp)*SEP_postCE)
                   rrl2_bpp = R1/(RL(q2_bpp)*SEP_postCE)
                   evolve_type = 15.0d0
                   aj1_bpp = AJ2
                   aj2_bpp = AJ1
*              M2, which here is mass(1), undergoes SN

               else
                   mass1_bpp = M1
                   mass2_bpp = M_postCE
                   massc1_bpp = MC1
                   massc2_bpp = MC2

                   kstar1_bpp = KW1i
                   kstar2_bpp = KW2i
                   q1_bpp = mass1_bpp/mass2_bpp
                   q2_bpp = 1.d0/q1_bpp
                   rrl1_bpp = R1/(RL(q1_bpp)*SEP_postCE)
                   rrl2_bpp = RC2/(RL(q2_bpp)*SEP_postCE)
                   evolve_type = 16.0d0
                   aj1_bpp = AJ1
                   aj2_bpp = AJ2
*              M2, which here is mass(2), undergoes SN
               endif
               TB = (SEP_postCE/AURSUN)*
     &               SQRT(SEP_postCE/(AURSUN*(M_postCE+M1)))
               if(using_cmc.eq.0)then
                   if(switchedCE)then
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0))
                       CALL writebpp(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,SEP_postCE,TB,ECC,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M02,M01,lumin(2),lumin(1),teff2,teff1,
     &                      RC2,RC1,menv_bpp(2),menv_bpp(1),renv_bpp(2),
     &                      renv_bpp(1),OSPIN2,OSPIN1,B_0(2),B_0(1),
     &                      bacc(2),bacc(1),tacc(2),tacc(1),epoch(2),
     &                      epoch(1),bhspin2,bhspin1)
                   else
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0))
                       CALL writebpp(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,SEP_postCE,TB,ECC,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M01,M02,lumin(1),lumin(2),teff1,teff2,
     &                      RC1,RC2,menv_bpp(1),menv_bpp(2),renv_bpp(1),
     &                      renv_bpp(2),OSPIN1,OSPIN2,B_0(1),B_0(2),
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin1,bhspin2)
                   endif
               endif
               CALL kick(KW2,M_postCE,M2,M1,ECC,SEP_postCE,
     &                   JORB,vk,star2,R1,fallback,sigmahold,
     &                   kick_info,disrupt,bkick)
* Returning variable state to original naming convention
               MF = M_postCE
               SEPF = SEP_postCE
               snp = 1
               if(M1.lt.0.d0)then
                  if(KW2.ge.10) M2 = M2-M1
                  MC2 = M2
                  MC1 = 0.D0
                  M1 = 0.D0
                  bhspin1 = 0.D0
                  KW1 = 15
                  AJ2 = 0.D0
                  COEL = .true.
                  GOTO 30
               endif
               IF(ECC.GT.1.D0) GOTO 30
            ENDIF
         ENDIF
      ENDIF
*
      IF(COEL)THEN
         MC22 = MC2
         IF(KW.EQ.4.OR.KW.EQ.7)THEN
* If making a helium burning star calculate the fractional age
* depending on the amount of helium that has burnt.
            IF(KW1.LE.3)THEN
               FAGE1 = 0.D0
            ELSEIF(KW1.GE.6)THEN
               FAGE1 = 1.D0
            ELSE
               FAGE1 = (AJ1 - TSCLS1(2))/(TSCLS1(13) - TSCLS1(2))
            ENDIF
            IF(KW2.LE.3.OR.KW2.EQ.10)THEN
               FAGE2 = 0.D0
            ELSEIF(KW2.EQ.7)THEN
               FAGE2 = AJ2/TM2
               MC22 = M2
            ELSEIF(KW2.GE.6)THEN
               FAGE2 = 1.D0
            ELSE
               FAGE2 = (AJ2 - TSCLS2(2))/(TSCLS2(13) - TSCLS2(2))
            ENDIF
         ENDIF
         if(output) write(*,*)'coel 1:',KW,MC1,MC2,MC3,MC22,FAGE1,FAGE2
      ENDIF
*
* Now calculate the final mass following coelescence.  This requires a
* Newton-Raphson iteration.
*
      IF(COEL)THEN
*
* Calculate the orbital spin just before coalescence.
*
         TB = (SEPL/AURSUN)*SQRT(SEPL/(AURSUN*(MC1+MC2)))
         OORB = TWOPI/TB
*
         XX = 1.D0 + ZPARS(7)
         IF(EBINDF.LE.0.D0)THEN
            MF = MC3
            GOTO 20
         ELSE
            CONST = ((M1+M2)**XX)*(M1-MC1+M2-MC22)*EBINDF/EBINDI
         ENDIF
*
* Initial Guess.
*
         MF = MAX(MC1 + MC22,(M1 + M2)*(EBINDF/EBINDI)**(1.D0/XX))
   10    DELY = (MF**XX)*(MF - MC1 - MC22) - CONST
*        IF(ABS(DELY/MF**(1.D0+XX)).LE.1.0D-02) GOTO 20
         IF(ABS(DELY/MF).LE.1.0D-03) GOTO 20
         DERI = MF**ZPARS(7)*((1.D0+XX)*MF - XX*(MC1 + MC22))
         DELMF = DELY/DERI
         MF = MF - DELMF
         GOTO 10
*
* Set the masses and separation.
*
   20    IF(MC22.EQ.0.D0) MF = MAX(MF,MC1+M2)
         M2 = 0.D0
         M1 = MF
         KW2 = 15
         bhspin2 = 0.d0
*
* Combine the core masses.
*
         if(output) write(*,*)'coel 2 1:',KW,KW1,KW2,M1,M2,MF,MC22,
     & TB,OORB
         IF(KW.EQ.2)THEN
            CALL star(KW,M1,M1,TM2,TN,TSCLS2,LUMS,GB,ZPARS)
            IF(GB(9).GE.MC1)THEN
               M01 = M1
               AJ1 = TM2 + (TSCLS2(1) - TM2)*(AJ1-TM1)/(TSCLS1(1) - TM1)
               CALL star(KW,M01,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS)
            ENDIF
            if(output) write(*,*)'coel 2 2:',KW,KW1,KW2,M1,M01,MC22,
     & TB,OORB
         ELSEIF(KW.EQ.7)THEN
            M01 = M1
            CALL star(KW,M01,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS)
            AJ1 = TM1*(FAGE1*MC1 + FAGE2*MC22)/(MC1 + MC22)
            if(output) write(*,*)'coel 2 3:',KW,KW1,KW2,M1,M01,MC22,
     & TB,OORB
         ELSEIF(KW.EQ.4.OR.MC2.GT.0.D0.OR.KW.NE.KW1)THEN
            IF(KW.EQ.4) AJ1 = (FAGE1*MC1 + FAGE2*MC22)/(MC1 + MC22)
            MC1 = MC1 + MC2
            MC2 = 0.D0
*
* Obtain a new age for the giant.
*
            CALL gntage(MC1,M1,KW,ZPARS,M01,AJ1)
            CALL star(KW,M01,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS)
            if(output) write(*,*)'coel 2 4:',KW,KW1,KW2,M1,M01,MC22,
     & TB,OORB
         ENDIF
         MF = M1
         KW1i = KW
         KW2i = KW2
         M1i = M1
         CALL hrdiag(M01,AJ1,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS,
     &               R1,L1,KW,MC1,RC1,MENV,RENV,K21,
     &               bhspin1,star1)
         if(output) write(*,*)'coel 2 5:',KW,M1,M01,R1,MENV,RENV
         IF(KW1i.LE.12.and.KW.GE.13)THEN
            formation1 = 1
            if(KW.eq.13.and.ecsn.gt.0.d0)then
               if(KW1i.le.6)then
                  if(M1i.le.zpars(5))then
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation1 = 2
                  endif
               elseif(KW1i.ge.7.and.KW1i.le.9)then
                  if(M1i.gt.ecsn_mlow.and.M1i.le.ecsn)then
* BSE orgi: 1.6-2.25, Pod: 1.4-2.5, StarTrack: 1.83-2.25 (all in Msun)
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation1 = 2
                  endif
               elseif(formation1.eq.11)then
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = -sigmahold/sigmadiv
                  elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                     sigma = sigmadiv
                  endif
                  formation1 = 5
               elseif(KW1i.ge.10.or.KW1i.eq.12)then
* AIC formation, will never happen here but...
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = -sigmahold/sigmadiv
                  elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                     sigma = sigmadiv
                  endif
                  formation1 = 4
               endif
            endif
*              Check if M1 and M2 were switched on pass to comenv
            if(switchedCE)then
                mass1_bpp = 0.d0
                mass2_bpp = MF
                massc1_bpp = 0.d0
                massc2_bpp = MC1

                kstar1_bpp = KW2i
                kstar2_bpp = KW1i
                rrl1_bpp = 0.d0
                rrl2_bpp = 0.d0
                evolve_type = 16.0d0
                aj1_bpp = AJ2
                aj2_bpp = AJ1
            else
                mass1_bpp = MF
                mass2_bpp = 0.d0
                massc1_bpp = MC1
                massc2_bpp = 0.d0

                kstar1_bpp = KW1i
                kstar2_bpp = KW2i
                rrl1_bpp = 0.d0
                rrl2_bpp = 0.d0
                evolve_type = 15.0d0
                aj1_bpp = AJ1
                aj2_bpp = AJ2
            endif
            TB = 0.d0
            if(using_cmc.eq.0)then
                   if(switchedCE)then
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0))
                       CALL writebpp(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,-1.d0,TB,0.d0,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M02,M01,lumin(2),lumin(1),teff2,teff1,
     &                      RC2,RC1,menv_bpp(2),menv_bpp(1),renv_bpp(2),
     &                      renv_bpp(1),OSPIN2,OSPIN1,B_0(2),B_0(1),
     &                      bacc(2),bacc(1),tacc(2),tacc(1),epoch(2),
     &                      epoch(1),bhspin2,bhspin1)
                   else
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0))
                       CALL writebpp(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,-1.d0,TB,0.d0,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M01,M02,lumin(1),lumin(2),teff1,teff2,
     &                      RC1,RC2,menv_bpp(1),menv_bpp(2),renv_bpp(1),
     &                      renv_bpp(2),OSPIN1,OSPIN2,B_0(1),B_0(2),
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin1,bhspin2)
                   endif
            endif
            CALL kick(KW,MF,M1,0.d0,0.d0,-1.d0,0.d0,vk,star1,
     &                0.d0,fallback,sigmahold,kick_info,disrupt,bkick)
            if(output) write(*,*)'coel 2 6:',KW,M1,M01,R1,MENV,RENV
         ENDIF
         JSPIN1 = OORB*(K21*R1*R1*(M1-MC1)+K3*RC1*RC1*MC1)
         KW1 = KW
         ECC = 0.D0
         if(output) write(*,*)'coel 2 7:',KW1,M1,M01,R1,MENV,RENV
      ELSE
*
* Check if any eccentricity remains in the orbit by first using
* energy to circularise the orbit before removing angular momentum.
* (note this should not be done in case of CE SN ... fixed PDK).
*
         IF(snp.EQ.0)THEN
            IF(EORBF.LT.ECIRC)THEN
               ECC = SQRT(1.D0 - EORBF/ECIRC)
            ELSE
               ECC = 0.D0
            ENDIF
         ENDIF
*
* Set both cores in co-rotation with the orbit on exit of CE,
*
         TB = (SEPF/AURSUN)*SQRT(SEPF/(AURSUN*(M1+M2)))
         OORB = TWOPI/TB
         JORB = M1*M2/(M1+M2)*SQRT(1.D0-ECC*ECC)*SEPF*SEPF*OORB
*        JSPIN1 = OORB*(K21*R1*R1*(M1-MC1)+K3*RC1*RC1*MC1)
*        JSPIN2 = OORB*(K22*R2*R2*(M2-MC2)+K3*RC2*RC2*MC2)
*
* or, leave the spins of the cores as they were on entry.
* Tides will deal with any synchronization later.
*
         JSPIN1 = OSPIN1*(K21*R1*R1*(M1-MC1)+K3*RC1*RC1*MC1)
         JSPIN2 = OSPIN2*(K22*R2*R2*(M2-MC2)+K3*RC2*RC2*MC2)
      ENDIF
   30 SEP = SEPF
      if(output) write(*,*)'end of CE1:',KW1,M1,M01,R1,MENV,RENV
      if(output) write(*,*)'end of CE1:',KW2,M2,M02,R2,MENV,RENV
      sigma = sigmahold
      RETURN
      END
***
